VERSION 5.00
Begin VB.Form Main 
   Caption         =   "Story Generator"
   ClientHeight    =   8445
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   12195
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   8445
   ScaleWidth      =   12195
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton FileLoadButton 
      Caption         =   "Load File"
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   7080
      Width           =   2295
   End
   Begin VB.Frame RightFrame 
      Caption         =   "Story Output"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   8415
      Left            =   2640
      TabIndex        =   1
      Top             =   0
      Width           =   9615
      Begin VB.TextBox StoryText 
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   8055
         Left            =   165
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   2
         Text            =   "Main.frx":0000
         Top             =   240
         Width           =   9375
      End
   End
   Begin VB.Frame LeftFrame 
      Caption         =   "Controls"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   8415
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2535
      Begin VB.CheckBox ErrorCheck 
         Caption         =   "Show Errors"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   120
         TabIndex        =   10
         Top             =   8040
         Value           =   1  'Checked
         Width           =   2175
      End
      Begin VB.CommandButton HelpButton 
         Caption         =   "Help"
         Height          =   435
         Left            =   120
         TabIndex        =   9
         Top             =   705
         Width           =   2295
      End
      Begin VB.DriveListBox DriveListBox 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Left            =   90
         TabIndex        =   8
         Top             =   1200
         Width           =   2355
      End
      Begin VB.DirListBox DirListBox 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   1665
         Left            =   90
         TabIndex        =   7
         Top             =   1560
         Width           =   2340
      End
      Begin VB.FileListBox FileListBox 
         Height          =   3690
         Left            =   75
         Pattern         =   "*.s"
         TabIndex        =   6
         Top             =   3270
         Width           =   2370
      End
      Begin VB.CommandButton WriteButton 
         Caption         =   "Write a Story"
         Height          =   420
         Left            =   120
         TabIndex        =   3
         Top             =   240
         Width           =   2295
      End
      Begin VB.Label FileNameLabel 
         Alignment       =   2  'Center
         Caption         =   "<no file loaded>"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   7680
         Width           =   2295
      End
   End
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' We create Dictionaries of Collections to help organize the word and grammar
' lists into a single database.

Public PartsOfSpeech  ' a Dictionary of Collections for wordlists
Public Grammars  ' the Dictionary that will hold the grammar Collections
Public Maps  ' a Dictionary of mappings between words; verb tenses, for instance

Public FilesParsed  ' a Dictionary to make sure we don't INCLUDE a file more than once

' Dictionaries for holding conjugations and plural forms of verbs and nouns
Public Verbs
Public Nouns

Enum Tenses
   VERB_TYPE = 0
   INFINITIVE = 1
   ROOT = 2
   FIRST_PRESENT = 3
   FIRST_PAST = 4
   SECOND_PRESENT = 5
   SECOND_PAST = 6
   THIRD_PRESENT = 7
   THIRD_PAST = 8
   PLURAL_PRESENT = 9
   PLURAL_PAST = 10
   PAST_PERFECT = 11
   PARTICIPLE = 12
End Enum

Enum NounForms
   SINGULAR = 0
   PLURAL = 1
End Enum

Enum PatternMatchStates
   MATCHING = 0
   FINDING_MATCHED_OUT = 1
   PARSING_MATCHED_OUTS = 2
   SKIPPING_TO_OUT = 3
   SKIPPING_TO_IN = 4
   SKIPPING_IF_BLOCK = 5
   SKIPPING_ELSE_BLOCK = 5
End Enum

Enum LogicalOps
   L_NIL = 0
   L_OR = 1
   L_AND = 2
End Enum

' We use several other Dictionaries, one for storing "temporary" grammers
' that result from our new CONST and PATTERNGROUP features, one for
' storing the CONST declarations themselves, and one for storing the PATTERNGROUP
' declarations.  The CONST declarations get "instanced" as temporary grammers
' (lists of specific words) every time a story is written.

Public ConstDeclarations  ' expressions evaluated down to words and held constant for one story
Public Patterns  ' a dictionary of pattern-matching lists
Public PatternParents  ' a dictionary that maps patterns to their parents
Public PatternProperties  ' a dictionary that maps patterns to dictionaries of instance properties
Public PatternProcedures  ' a dictionary of first-word indices that allow shortcuts during pattern-matching
Public PatternWildcards  ' additional info for shortcuts -- the line numbers of first-word wildcards
Public RunTimeGrammars  ' place where CONST values reside during run-time

' by default, we keep track of which words you've picked and only pick new words:
Public PickableWords  ' dictionary of collections

' We keep track of the total number of words and
' grammars we have loaded at any one time.

Public TotalWordCount As Integer
Public TotalGrammarCount As Integer
Public TotalPatternCount As Integer

' global variable used by GetNextLine() to remember whether it is scanning
' part of a file contained within a comment.

Public bWaitingForEndComment As Boolean

' We do something a little fancy with error messages.  During the
' parsing of a file, we might catch a large number of error messages.  Instead of
' annoying the user with MsgBox'es, we just keep track of the errors in a big string
' called ErrorsString and display them all at once in the StoryText text box.

Public ErrorsString As String


' This routine gets called when the program starts running.
Public Sub Form_Load()
  
  Randomize  ' make sure Rnd is really random
  
  FileListBox.Path = DirListBox.Path & "\StoryFiles\"
  DirListBox.Path = DirListBox.Path & "\StoryFiles\"
    
  ' We need to build our toplevel Dictionary objects when the program first
  ' starts.  We will fill them with Collections later, based on the file that
  ' the user selects.
  
  Set PartsOfSpeech = CreateObject("Scripting.Dictionary")
  Set Verbs = CreateObject("Scripting.Dictionary")
  Set Nouns = CreateObject("Scripting.Dictionary")
  
  Set Maps = CreateObject("Scripting.Dictionary")
  Set Grammars = CreateObject("Scripting.Dictionary")
  Set ConstDeclarations = CreateObject("Scripting.Dictionary")
  Set Patterns = CreateObject("Scripting.Dictionary")
  Set PatternParents = CreateObject("Scripting.Dictionary")
  Set PatternProperties = CreateObject("Scripting.Dictionary")
  Set PatternProcedures = CreateObject("Scripting.Dictionary")
  Set PatternWildcards = CreateObject("Scripting.Dictionary")
  Set RunTimeGrammars = CreateObject("Scripting.Dictionary")

  Set PickableWords = CreateObject("Scripting.Dictionary")
  
  Set FilesParsed = CreateObject("Scripting.Dictionary")
  
  ' display help file in the main window
  DisplayHelpFile
  
End Sub

Public Sub Form_UnLoad(cancel As Integer)
End Sub

Public Sub DisplayHelpFile()
  
  helpText = ""
  
  Set fs = CreateObject("Scripting.FileSystemObject")  ' need a FileSystemObject to access file methods
  If fs.FileExists("SDocumentation.txt") Then
    Set f = fs.OpenTextFile("SDocumentation.txt")  '  open a TextStream to the file for reading
    helpText = f.ReadAll()
  End If

  StoryText.Text = helpText
  
End Sub

Sub HelpButton_Click()
  DisplayHelpFile
End Sub

Public Sub InitializeGlobals()
  
  ' First make sure that we empty out all of the toplevel Dictionaries.
  ' Doing so lets the user change which file he's using without restarting
  ' the program
  
  PartsOfSpeech.RemoveAll
  Grammars.RemoveAll
  Maps.RemoveAll
  ConstDeclarations.RemoveAll
  Patterns.RemoveAll
  PatternParents.RemoveAll
  PatternProperties.RemoveAll
  PatternProcedures.RemoveAll
  PatternWildcards.RemoveAll
  RunTimeGrammars.RemoveAll
  PickableWords.RemoveAll
  
  FilesParsed.RemoveAll
  
  Nouns.RemoveAll
  Verbs.RemoveAll
  
  ' build system groups like w_noun and w_verb

  Dim w_noun As New Collection
  PartsOfSpeech.Add "w_noun", w_noun
  Dim w_noun_pl As New Collection
  PartsOfSpeech.Add "w_noun_pl", w_noun_pl
  
  Dim w_verb As New Collection
  PartsOfSpeech.Add "w_verb", w_verb
  Dim w_verb_infinitive As New Collection
  PartsOfSpeech.Add "w_verb_infinitive", w_verb_infinitive
  Dim w_verb_present As New Collection
  PartsOfSpeech.Add "w_verb_present", w_verb_present
  Dim w_verb_past As New Collection
  PartsOfSpeech.Add "w_verb_past", w_verb_past
  Dim w_verb_first_present As New Collection
  PartsOfSpeech.Add "w_verb_first_present", w_verb_first_present
  Dim w_verb_first_past As New Collection
  PartsOfSpeech.Add "w_verb_first_past", w_verb_first_past
  Dim w_verb_second_present As New Collection
  PartsOfSpeech.Add "w_verb_second_present", w_verb_second_present
  Dim w_verb_second_past As New Collection
  PartsOfSpeech.Add "w_verb_second_past", w_verb_second_past
  Dim w_verb_third_present As New Collection
  PartsOfSpeech.Add "w_verb_third_present", w_verb_third_present
  Dim w_verb_third_past As New Collection
  PartsOfSpeech.Add "w_verb_third_past", w_verb_third_past
  Dim w_verb_plural_present As New Collection
  PartsOfSpeech.Add "w_verb_plural_present", w_verb_plural_present
  Dim w_verb_plural_past As New Collection
  PartsOfSpeech.Add "w_verb_plural_past", w_verb_plural_past
  Dim w_verb_past_perfect As New Collection
  PartsOfSpeech.Add "w_verb_past_perfect", w_verb_past_perfect
  Dim w_verb_participle As New Collection
  PartsOfSpeech.Add "w_verb_participle", w_verb_participle

  Dim w_verb_linking As New Collection
  PartsOfSpeech.Add "w_verb_linking", w_verb_linking
  Dim w_verb_transitive As New Collection
  PartsOfSpeech.Add "w_verb_transitive", w_verb_transitive
  Dim w_verb_intransitive As New Collection
  PartsOfSpeech.Add "w_verb_intransitive", w_verb_intransitive

  ' Build system mappings like m_noun_form and m_verb_form
  
  Dim m_noun_form
  Set m_noun_form = CreateObject("Scripting.Dictionary")
  Maps.Add "m_noun_form", m_noun_form

  Dim m_verb_form
  Set m_verb_form = CreateObject("Scripting.Dictionary")
  Maps.Add "m_verb_form", m_verb_form

  Dim m_transitive_verb_form
  Set m_transitive_verb_form = CreateObject("Scripting.Dictionary")
  Maps.Add "m_transitive_verb_form", m_transitive_verb_form

  Dim m_intransitive_verb_form
  Set m_intransitive_verb_form = CreateObject("Scripting.Dictionary")
  Maps.Add "m_intransitive_verb_form", m_intransitive_verb_form

  Dim m_linking_verb_form
  Set m_linking_verb_form = CreateObject("Scripting.Dictionary")
  Maps.Add "m_linking_verb_form", m_linking_verb_form
  
End Sub

' This is the parser.  It gets called by FileLoadButton_Click()
' when the user presses the "Load File" button.  First we make sure the
' toplevel dictionaries are empty, then we traverse the textfile line-by-line,
' adding words and grammars as we encounter them.

' To implement the INCLUDE directive, we let this function call itself
' recursively.  As a result, we would like to know how "deep" we are inside
' the recursion tree so that we can only do certain things at the root level
' of the algorithm

Public Sub ParseFile(FileName As String, recursionLevel As Integer)
  
  ' We want to keep track of parsing errors in a string so that they can be printed
  ' all at once in the text window.  The first step is to make sure that the
  ' global variable ErrorsString is empty.
  
  ' only reset the errors text if we're at the top level (i.e. the first call
  ' to ParseFile()
  If recursionLevel = 0 Then
    InitializeGlobals
    ErrorsString = ""
    TotalGrammarCount = 0
    TotalWordCount = 0
    TotalPatternCount = 0
  End If
  
  If FilesParsed.Exists(FileName) Then
    Exit Sub
  End If
  
  ' make sure we don't INCLUDE the same file twice
  FilesParsed.Add FileName, FileName
  
  ' print a message to let the user know which files got parsed.
  ErrorsString = ErrorsString & "Parsing " & FileName & "...." & vbCrLf
  
  ' Now we open the file for parsing
  
  Set fs = CreateObject("Scripting.FileSystemObject")  ' need a FileSystemObject to access file methods
  If Not fs.FileExists(FileName) Then
      ErrorsString = ErrorsString & "Warning: File not found: " & FileName & vbCrLf
      Exit Sub
  End If
  Set f = fs.OpenTextFile(FileName)  '  open a TextStream to the file for reading
  
  ' The f variable now points to a TextStream object that will
  ' allow us to read in the data line by line.  We do that with the
  ' ReadLine method of the TextStream object
  
  Do While f.AtEndOfStream <> True  ' while not at the end of the file...
 '   l = CleanString(f.ReadLine)  ' read a line of text; trim extra whitespace; CleanString() is defined below
     l = GetNextLine(f)

     words = Split(l)  ' returns an array of the words in l
     If UBound(words) >= 0 Then   ' if we find a line containing at least one word of text...
      
      ' We decide how to continue parsing based on the first word on the line
      firstWord = UCase(words(0))   ' convert to uppercase to make the comparison case-insensitive
      
      Select Case firstWord
        
        Case "WORDGROUP"  ' command for defining a Collection of words
          If UBound(words) < 1 Then  ' make sure the user gave a name for the word group
            ' add an error to the string we use to keep track of errors.  note that vbCrLf is the newline character.
            ErrorsString = ErrorsString & "Line " & f.Line & " - WORDGROUP requires a name in order to be created." & vbCrLf
          Else  ' call a subroutine to continue parsing the file specifically for words
            ' Note that since we didn't Dim wordListName it is automatically declared
            ' as a Variant
            wordListName = words(1)
            Call ParseWordList(f, wordListName)  ' NOTE: must use "Call" because f is an object
          End If
          
        Case "GRAMMARGROUP"  ' command for defining a Collection of grammars
          If UBound(words) < 1 Then  ' make sure the user gave a name for the grammar group
            ErrorsString = ErrorsString & "Line " & f.Line & " - GRAMMARGROUP requires a name in order to be created." & vbCrLf
          Else  ' call a subroutine to continue parsing the file specifically for grammars
            grammarListName = words(1)
            Call ParseGrammarList(f, grammarListName)  ' NOTE: must use "Call" because f is an object
          End If
              
        Case "PATTERNGROUP"  ' command for defining a Collection of pattern-matches
          If UBound(words) < 1 Then  ' make sure the user gave a name for the pattern group
            ErrorsString = ErrorsString & "Line " & f.Line & " - PATTERNGROUP requires a name in order to be created." & vbCrLf
          Else  ' call a subroutine to continue parsing the file specifically for patterns
            patternListName = words(1)
            If UBound(words) >= 3 Then  ' if this pattern is a subclass...
              If StrComp(UCase(words(2)), "EXTENDS") = 0 Then
                If Not Patterns.Exists(words(3)) Then ' validate that parent pattern exists
                  ErrorsString = ErrorsString & "Line " & f.Line & " - The parent of a child pattern must be defined before the child: " & words(3) & vbCrLf
                Else
                  PatternParents.Add patternListName, words(3)
                End If
              End If
            End If
            Call ParsePatternList(f, patternListName)  ' NOTE: must use "Call" because f is an object
          End If
                              
        Case "MAP"  ' command for defining a many-to-one mapping
          If UBound(words) < 1 Then  ' make sure the user gave a name for the map
            ErrorsString = ErrorsString & "Line " & f.Line & " - MAP requires a name in order to be created." & vbCrLf
          Else  ' call a subroutine to continue parsing the file specifically for patterns
            mapListName = words(1)
            Call ParseMap(f, mapListName)  ' NOTE: must use "Call" because f is an object
          End If
                              
        Case "CONST"  ' command for defining a const variable
          If UBound(words) < 2 Then  ' make sure the user gave a name and value for the variable
            ErrorsString = ErrorsString & "Line " & f.Line & " - CONST requires a name AND a value in order to be created." & vbCrLf
          Else  ' call a subroutine to continue parsing the file specifically for patterns
            constListName = words(1)
            Call ParseConst(f, constListName, words)  ' NOTE: must use "Call" because f is an object
          End If
                 
        Case "ADDWORD"
          If UBound(words) < 2 Then  ' make sure the user specified a list and a word
            ErrorsString = ErrorsString & "Line " & f.Line & " - ADDWORD requires a list name and a word.  Syntax: ADDWORD <listname> <word>." & vbCrLf
          Else
            Call AddToWordList(words(1), words(2))
          End If
          
        Case "ADDGRAMMAR"
          If UBound(words) < 2 Then  ' make sure the user specified a list and a grammar
             ErrorsString = ErrorsString & "Line " & f.Line & " - ADDGRAMMAR requires a list name and a grammar.  Syntax: ADDGRAMMAR <listname> <grammar>.  (" & Join(words) & ")" & vbCrLf
           Else
             Dim tempWords As New Collection
             For i = 2 To UBound(words)
               tempWords.Add (words(i))
             Next
             Call AddToGrammarList(words(1), tempWords)
           End If
        
        Case "APPENDPATTERN"
          If UBound(words) < 2 Then  ' make sure the user specified a list and a pattern
            ErrorsString = ErrorsString & "Line " & f.Line & " - APPENDPATTERN requires a list name and a pattern.  Syntax: APPENDPATTERN <listname> <pattern>.  (" & Join(words) & ")" & vbCrLf
          Else
            Dim tempWords2 As New Collection ' make a Collection of the words to be combined into one pattern array
            For i = 2 To UBound(words)
              tempWords2.Add (words(i))
            Next
            Call AppendPattern(words(1), tempWords2)
          End If
        
        Case "PREPENDPATTERN"
          If UBound(words) < 2 Then  ' make sure the user specified a list and a pattern
            ErrorsString = ErrorsString & "Line " & f.Line & " - PREPENDPATTERN requires a list name and a pattern.  Syntax: PREPENDPATTERN <listname> <pattern>.  (" & Join(words) & ")" & vbCrLf
          Else
            Dim tempWords3 As New Collection ' make a Collection of the words to be combined into one pattern array
            For i = 2 To UBound(words)
              tempWords3.Add (words(i))
            Next
            Call PrependPattern(words(1), tempWords3)
          End If
        
        Case "ADDMAP"
          If UBound(words) < 3 Then  ' make sure the user specified a list, a key, and a word
            ErrorsString = ErrorsString & "Line " & f.Line & " - ADDMAP requires a map name, a key, and a word.  Syntax: ADDMAP <mapname> <key> <word>.  (" & Join(words) & ")" & vbCrLf
          Else
            Dim tempWords4 As New Collection ' make a Collection of the words to be combined into one String
            For i = 2 To UBound(words)
              tempWords4.Add (words(i))
            Next
            Call AddToMap(words(1), tempWords4(0), tempWords4(1))
          End If
        
        Case "INCLUDE"  ' Parse a specified file for additional words and grammars
          If UBound(words) < 1 Then  ' make sure the user specified a filename
            ErrorsString = ErrorsString & "Line " & f.Line & " - INCLUDE requires a filename.  Syntax: INCLUDE <filename>.  All filenames are relative; do NOT specify an absolute path." & vbCrLf
          Else ' figure out the filename and then parse the file with a recursive call to ParseFile()
            Dim newFileName As String
            newFileName = FileListBox.Path & "\" & words(1)  ' calculate an explicit path from a relative one
            ' recursively call ourselves; this causes us to stop processing the current file
            ' until the included file has been parsed
            Call ParseFile(newFileName, recursionLevel + 1)
          End If
        
        Case "WRITE"  ' command for defining the list of grammars that will be written
          
          ' if the user put words after the WRITE keyword, warn him that WRITE grammars
          ' go *below* the keyword
          
          If UBound(words) > 0 Then
            ErrorsString = ErrorsString & "Line " & f.Line & " - WRITE requires that all grammars to be written be defined BELOW the keyword, not on the same line." & vbCrLf
          End If
          
          Call ParseGrammarsToWrite(f)  ' NOTE: must use "Call" because f is an object
          
      End Select
      
    End If
  Loop
  
  f.Close  ' close the FileStream object when we're done

  ' If we aren't at the top level (i.e. if more files have yet to finish parsing)
  ' we simply add a message to ErrorsString that notes that we finished parsing.
  ' Otherwise, we do a final check for database errors and display ErrorsString as before.
  
  If recursionLevel > 0 Then  ' more files waiting to finish parsing...
    
    ErrorsString = ErrorsString & "Done parsing " & FileName & "." & vbCrLf
    Exit Sub  ' exit ParseString()
  
  Else
    
    ' Add an error message if the user didn't define a WRITE command
    If Not Grammars.Exists("g_system_grammartowrite") Then
      ErrorsString = ErrorsString & "ERROR: file must contain a WRITE command." & vbCrLf
    End If

    ErrorsString = ErrorsString & "Done parsing " & FileName & "." & vbCrLf
    ErrorsString = ErrorsString & "TOTAL WORDS = " & TotalWordCount & "   TOTAL GRAMMARS = " & TotalGrammarCount & "   TOTAL PATTERN ELEMENTS = " & TotalPatternCount & "." & vbCrLf
  
  ' Now that we're done parsing, display the list of error messages in the the
  ' StoryText TextBox.
    StoryText.Text = ErrorsString
  
  End If
  
End Sub

' a routine that parses words out of a TextStream until it
' reaches a blank line or the end of the file.

Public Sub ParseWordList(f As Variant, name As Variant)

  ' First make sure that a Dictionary of word lists doesn't already contain a wordlist
  ' by the same name.  If it does, we merge the new words automatically into the old list.
  
  Dim wordCollection As New Collection  ' don't forget to use New when creating an object variable
  
  Dim autoMerging
  autoMerging = False
  
  If PartsOfSpeech.Exists(name) Then
    autoMerging = True
    Set wordCollection = PartsOfSpeech.item(name)
    ErrorsString = ErrorsString & _
      ".... merging lists automatically.  Line " & f.Line & " - WORDLIST " & name & " already defined." & vbCrLf
  End If
    
  mapName = "m" & Right(name, Len(name) - 1)
  Dim theMap
  If Maps.Exists(mapName) And (autoMerging = False) Then
     ErrorsString = ErrorsString & "Line " & f.Line & " - WARNING: automatically generated MAP " & mapName & " already exists, and you haven't defined " & name & " previously.  That's some bad voodoo." & vbCrLf
     theMap = Maps.item(mapName)
  Else
    Set theMap = CreateObject("Scripting.Dictionary")
  End If
  
  Dim addLocal As Boolean
  addLocal = True
  If StrComp(LCase(name), "w_verb") = 0 Or StrComp(LCase(name), "w_noun_plural") = 0 Then
    addLocal = False
  End If


  ' Now we add the words.  Each word is on a separate line.  We stop adding words
  ' when we reach a blank line or the end of the file.
    
  wordsAdded = 0  'keep track of how many words we added
  
  Do While f.AtEndOfStream <> True
    
'    l = CleanString(f.ReadLine)  ' read a line of text; trim extra whitespace; CleanString() is defined below
    l = GetNextLine(f)
    If l = "" Then Exit Do  ' a blank line: no more words left to add
    
    ' take a peek at the first word of a line to look for a special directive like
    ' "_MERGE"
    
    words = Split(l)  ' we know we have at least one word
    Select Case UCase(words(0))
      
      Case "_MERGE"  ' a keyword for merging the contents of another wordlist
          
          If UBound(words) < 1 Then  ' make sure the user specified a wordlist name
            ErrorsString = ErrorsString & "Line " & f.Line & " - _MERGE requires a wordlist name.  Syntax: _MERGE <wordlist>." & vbCrLf
          Else
            listToMerge = words(1)
            If PartsOfSpeech.Exists(listToMerge) Then
              ' this routine is defined at the bottom of this module; it merges the
              ' elements from one Collection into another
              Call MergeCollections(wordCollection, PartsOfSpeech.item(listToMerge))
              ' count the number of words we've added
              wordsAdded = wordsAdded + PartsOfSpeech.item(listToMerge).count
            Else
              ErrorsString = ErrorsString & "Line " & f.Line & " - _MERGE can't find WORDLIST " & listToMerge & ".  Be sure to only merge from lists that PRECEDE a given _MERGE command." & vbCrLf
            End If
          End If
      
      Case "_NOUN"
          
          If UBound(words) < 2 Then  ' make sure the user specified a wordlist name
            
            ErrorsString = ErrorsString & "Line " & f.Line & " - _NOUN requires two arguments.  Syntax: _NOUN <singular> <plural>." & vbCrLf
          
          Else
            
            Dim noun
            noun = Array("", "")
            noun(SINGULAR) = replace(words(SINGULAR + 1), "_", " ")
            noun(PLURAL) = replace(words(PLURAL + 1), "_", " ")
            Nouns.Add noun(SINGULAR), noun
            ' add to the global list of nouns
            Call AddToWordList("w_noun", noun(SINGULAR))
            Call AddToWordList("w_noun_plural", noun(PLURAL))
            Call AddToMap("m_noun_form", noun(SINGULAR), noun(SINGULAR))
            Call AddToMap("m_noun_form", noun(PLURAL), noun(SINGULAR))
            
            If addLocal Then
              localName = name & "_plural": MakeSureWordlistExists (localName)
              Call AddToWordList(localName, noun(PLURAL))
            End If
            
            ' create a MAP specific to this wordlist
            Call AddToMap(mapName, noun(SINGULAR), noun(SINGULAR))
            Call AddToMap(mapName, noun(PLURAL), noun(SINGULAR))
            If Not Maps.Exists(mapName) Then Maps.Add mapName, theMap  ' do this only once
            
            ' add to the local list
            wordCollection.Add (noun(SINGULAR))  ' key off of the singular form
            wordsAdded = wordsAdded + 1  ' count the number of words we've added
          End If

      Case "_VERB"
          Dim verb
          verb = Array("", "", "", "", "", "", "", "", "", "", "", "", "")
          If UBound(words) = 2 Then
            verb(VERB_TYPE) = replace(words(VERB_TYPE + 1), "_", " ")
            verb(ROOT) = replace(words(INFINITIVE + 1), "_", " ")  ' kludge
            verb(INFINITIVE) = ConjugateVerb(verb(ROOT), INFINITIVE)
            verb(FIRST_PRESENT) = ConjugateVerb(verb(ROOT), FIRST_PRESENT)
            verb(FIRST_PAST) = ConjugateVerb(verb(ROOT), FIRST_PAST)
            verb(SECOND_PRESENT) = ConjugateVerb(verb(ROOT), SECOND_PRESENT)
            verb(SECOND_PAST) = ConjugateVerb(verb(ROOT), SECOND_PAST)
            verb(THIRD_PRESENT) = ConjugateVerb(verb(ROOT), THIRD_PRESENT)
            verb(THIRD_PAST) = ConjugateVerb(verb(ROOT), THIRD_PAST)
            verb(PLURAL_PRESENT) = ConjugateVerb(verb(ROOT), PLURAL_PRESENT)
            verb(PLURAL_PAST) = ConjugateVerb(verb(ROOT), PLURAL_PAST)
            verb(PAST_PERFECT) = ConjugateVerb(verb(ROOT), PAST_PERFECT)
            verb(PARTICIPLE) = ConjugateVerb(verb(ROOT), PARTICIPLE)
          ElseIf UBound(words) >= 13 Then
            verb(VERB_TYPE) = replace(words(VERB_TYPE + 1), "_", " ")
            verb(INFINITIVE) = replace(words(INFINITIVE + 1), "_", " ")
            verb(ROOT) = replace(words(ROOT + 1), "_", " ")
            verb(FIRST_PRESENT) = replace(words(FIRST_PRESENT + 1), "_", " ")
            verb(FIRST_PAST) = replace(words(FIRST_PAST + 1), "_", " ")
            verb(SECOND_PRESENT) = replace(words(SECOND_PRESENT + 1), "_", " ")
            verb(SECOND_PAST) = replace(words(SECOND_PAST + 1), "_", " ")
            verb(THIRD_PRESENT) = replace(words(THIRD_PRESENT + 1), "_", " ")
            verb(THIRD_PAST) = replace(words(THIRD_PAST + 1), "_", " ")
            verb(PLURAL_PRESENT) = replace(words(PLURAL_PRESENT + 1), "_", " ")
            verb(PLURAL_PAST) = replace(words(PLURAL_PAST + 1), "_", " ")
            verb(PAST_PERFECT) = replace(words(PAST_PERFECT + 1), "_", " ")
            verb(PARTICIPLE) = replace(words(PARTICIPLE + 1), "_", " ")
          Else
            ErrorsString = ErrorsString & "Line " & f.Line & " - _VERB requires either two or thirteen arguments: " & vbCrLf & "    (1) Syntax: _VERB <type> <root>" & vbCrLf & "    (2) Syntax: _VERB <type> <infinitive> <root> <first_present> <first_past> <second_present> <second_past> <third_present> <third_past> <plural_present> <plural_past> <past_perfect> <participle>." & vbCrLf
            GoTo NextVerb:
          End If
          
          Verbs.Add verb(ROOT), verb
                    
          ' add to the global and local lists of verbs for a variety of matching possibilities
          
          Call AddToWordList("w_verb", verb(ROOT))  ' ROOT added to main list below
          If addLocal Then
            localName = name & "_root": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(ROOT))
          End If

          Call AddToWordList("w_verb_infinitive", verb(INFINITIVE))
          If addLocal Then
            localName = name & "_infinitive": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(INFINITIVE))
          End If
          
          Call AddToWordList("w_verb_present", verb(FIRST_PRESENT))
          Call AddToWordList("w_verb_present", verb(SECOND_PRESENT))
          Call AddToWordList("w_verb_present", verb(THIRD_PRESENT))
          Call AddToWordList("w_verb_present", verb(PLURAL_PRESENT))
          
          If addLocal Then
            localName = name & "_present": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(FIRST_PRESENT))
            Call AddToWordList(localName, verb(SECOND_PRESENT))
            Call AddToWordList(localName, verb(THIRD_PRESENT))
            Call AddToWordList(localName, verb(PLURAL_PRESENT))
          End If
  
          Call AddToWordList("w_verb_past", verb(FIRST_PAST))
          Call AddToWordList("w_verb_past", verb(SECOND_PAST))
          Call AddToWordList("w_verb_past", verb(THIRD_PAST))
          Call AddToWordList("w_verb_past", verb(PLURAL_PAST))
          
          If addLocal Then
            localName = name & "_past": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(FIRST_PAST))
            Call AddToWordList(localName, verb(SECOND_PAST))
            Call AddToWordList(localName, verb(THIRD_PAST))
            Call AddToWordList(localName, verb(PLURAL_PAST))
          End If
          
          Call AddToWordList("w_verb_first_present", verb(FIRST_PRESENT))
          If addLocal Then
            localName = name & "_first_present": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(FIRST_PRESENT))
          End If
          
          Call AddToWordList("w_verb_second_present", verb(SECOND_PRESENT))
          If addLocal Then
            localName = name & "_second_present": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(SECOND_PRESENT))
          End If
          
          Call AddToWordList("w_verb_third_present", verb(THIRD_PRESENT))
          If addLocal Then
            localName = name & "_third_present": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(THIRD_PRESENT))
          End If
          
          Call AddToWordList("w_verb_plural_present", verb(PLURAL_PRESENT))
          If addLocal Then
            localName = name & "_plural_present": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(PLURAL_PRESENT))
          End If
          
          Call AddToWordList("w_verb_first_past", verb(FIRST_PAST))
          If addLocal Then
            localName = name & "_first_past": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(FIRST_PAST))
          End If
          
          Call AddToWordList("w_verb_second_past", verb(SECOND_PAST))
          If addLocal Then
            localName = name & "_second_past": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(SECOND_PAST))
          End If
          
          Call AddToWordList("w_verb_third_past", verb(THIRD_PAST))
          If addLocal Then
            localName = name & "_third_past": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(THIRD_PAST))
          End If
          
          Call AddToWordList("w_verb_plural_past", verb(PLURAL_PAST))
          If addLocal Then
            localName = name & "_plural_past": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(PLURAL_PAST))
          End If
          
          Call AddToWordList("w_verb_past_perfect", verb(PAST_PERFECT))
          If addLocal Then
            localName = name & "_past_perfect": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(PAST_PERFECT))
          End If
          
          Call AddToWordList("w_verb_participle", verb(PARTICIPLE))
          If addLocal Then
            localName = name & "_participle": MakeSureWordlistExists (localName)
            Call AddToWordList(localName, verb(PARTICIPLE))
          End If
          
          vtTemp = UCase(verb(VERB_TYPE))
          If StrComp(vtTemp, "TRANSITIVE") = 0 Then
            Call AddToWordList("w_verb_transitive", verb(ROOT))
            Call AddVerbToMap("m_transitive_verb_form", verb)
          ElseIf StrComp(vtTemp, "INTRANSITIVE") = 0 Then
            Call AddToWordList("w_verb_intransitive", verb(ROOT))
            Call AddVerbToMap("m_intransitive_verb_form", verb)
          ElseIf StrComp(vtTemp, "LINKING") = 0 Then
            Call AddToWordList("w_verb_linking", verb(ROOT))
            Call AddVerbToMap("m_linking_verb_form", verb)
          End If
          
          Call AddVerbToMap("m_verb_form", verb)
          
          ' create a MAP specific to this wordlist
          Call AddVerbToMap(mapName, verb)
          If Not Maps.Exists(mapName) Then Maps.Add mapName, theMap  ' do this only once
          
          ' add to the local list
          wordCollection.Add (verb(ROOT)) ' key off of the "root"
          wordsAdded = wordsAdded + 1  ' count the number of words we've added
      
      Case "##"  ' ignore line; a comment
      Case "//"  ' ignore line; a comment
      Case "_"  ' ignore line; a comment
        
      Case Else  ' the default: add a word to the Collection
        wordCollection.Add (l) ' use the text of the whole line as the "word"
        wordsAdded = wordsAdded + 1  ' count the number of words we've added
    
    End Select
    
NextVerb:
  Loop
  
'  If wordsAdded = 0 Then  ' if no words were found, warn the user and don't add the collection
'    ErrorsString = ErrorsString & _
'      "Line " & f.Line & " - WARNING: no words found for WORDLIST " & name & "." & vbCrLf
'  Else
    If autoMerging = False Then
      PartsOfSpeech.Add name, wordCollection ' add the wordlist to the master list of lists
    End If
    TotalWordCount = TotalWordCount + wordsAdded  ' keep a running tally
'  End If
  
End Sub

' The code to parse a list of grammars is almost identical to that for
' parsing words.  The main difference is that we must parse each grammar into
' array of Strings with the Split() function.

Public Sub ParseGrammarList(f As Variant, name As Variant)
  
  ' create a Collection for holding all of the grammars
  Dim grammarCollection As New Collection
  
  Dim autoMerging
  autoMerging = False
  
  ' First make sure that a Dictionary of grammar lists doesn't already contain a grammar list
  ' by the same name.  We will merge additional grammars automatically if a list already exists
  
  If Grammars.Exists(name) Then
    autoMerging = True
    Set grammarCollection = Grammars.item(name)
    ErrorsString = ErrorsString & _
      ".... merging lists automatically.  Line " & f.Line & " - GRAMMARLIST " & name & " already defined." & vbCrLf
  End If
    
  ' Now we add the grammars.  Each grammar is on a separate line and needs to be stored
  ' as an array of Strings.  We stop adding grammars when we reach a blank line
  ' or the end of the file.
  
  grammarsAdded = 0  'keep track of how many words we added
  Do While f.AtEndOfStream <> True
'    l = CleanString(f.ReadLine)  ' read a line of text; trim extra whitespace; CleanString() is defined below
     l = GetNextLine(f)
    If l = "" Then Exit Do  ' a blank line: no more words left to add
    
    ' take a peek at the first word of a line to look for a special directive like
    ' "_MERGE"
    
    words = Split(l)  ' we know we have at least one word
    Select Case UCase(words(0))
      
      Case "_MERGE"  ' a keyword for merging the contents of another grammar list
          
          If UBound(words) < 1 Then  ' make sure the user specified a grammar list name
            ErrorsString = ErrorsString & "Line " & f.Line & " - _MERGE requires a grammar list name.  Syntax: _MERGE <grammarlist>." & vbCrLf
          Else
            listToMerge = words(1)
            If Grammars.Exists(listToMerge) Then
              ' this routine is defined at the bottom of this module; it merges the
              ' elements from one Collection into another
              Call MergeCollections(grammarCollection, Grammars.item(listToMerge))
              ' count the number of words we've added
              grammarsAdded = grammarsAdded + Grammars.item(listToMerge).count
            Else
              ErrorsString = ErrorsString & "Line " & f.Line & " - _MERGE can't find GRAMMARLIST " & listToMerge & ".  Be sure to only merge from lists that PRECEDE a given _MERGE command." & vbCrLf
            End If
          End If
      
      Case "##"  ' ignore line; a comment
      Case "//"  ' ignore line; a comment
      Case "_"  ' ignore line; a comment
      
      Case Else  ' the default: add a grammar to the Collection
'        If autoMerging = False Then
          grammarCollection.Add (words)  ' rememeber: words is an array of the whole line
'        End If
        grammarsAdded = grammarsAdded + 1  ' count the number of words we've added
    End Select
    
  Loop
  
'  If grammarsAdded = 0 Then  ' if no grammars were found, warn the user
'    ErrorsString = ErrorsString & _
'      "Line " & f.Line & " - WARNING: no grammars found for GRAMMARLIST " & name & "." & vbCrLf
'      Grammars.Add name, grammarCollection   ' add the grammar list to the master list of lists
'  Else
    If autoMerging = False Then
      Grammars.Add name, grammarCollection   ' add the grammar list to the master list of lists
    End If
    TotalGrammarCount = TotalGrammarCount + grammarsAdded  ' keep a running tally
'  End If
  
End Sub

' It would be ugly to duplicate all of the code for parsing a grammar list, so
' we simply call ParseGrammarList with a special name for the grammar list to be parsed:
' "g_system_grammartowrite".  When the user presses "Write a Story", we will simply
' write the grammar "g_system_grammartowrite".

Public Sub ParseGrammarsToWrite(f As Variant)
  Call ParseGrammarList(f, "g_system_grammartowrite")
End Sub

' parse a pattern group into a long list of _in and _out declarations.
' We store this list as a Collection of arrays.
'
' Note that this code is almost EXACTLY the same as the code for ParseGrammarList()
' I just copied it down here and modified a few names.
Public Sub ParsePatternList(f As Variant, name As Variant)

  ' create a Collection for holding all of the patterns
  Dim patternCollection As New Collection
  
  Dim autoMerging
  autoMerging = False
  
  ' First make sure that the Dictionary of pattern lists doesn't already contain a pattern list
  ' by the same name.  This will cause a Visual Basic error in the Dictionary object.
  
  If Patterns.Exists(name) Then
    autoMerging = True
    Set patternCollection = Patterns.item(name)
    ErrorsString = ErrorsString & _
      ".... merging lists automatically.  Line " & f.Line & " - PATTERNLIST " & name & " already defined." & vbCrLf
      Exit Sub  ' return back to the main parsing loop
  End If
  
  ' create a lookup table of "first words," essentially procedure names.  A speed enhancement.
  Dim addingProcedures As Boolean: addingProcedures = True
  Dim waitingForOut As Boolean: waitingForOut = False
  Dim mostRecentWildcard As Integer: mostRecentWildcard = 0
  If autoMerging = False Then
    Set procedureIndex = CreateObject("Scripting.Dictionary")
    Set wildcardIndex = CreateObject("Scripting.Dictionary")
  Else
    procedureIndex = PatternProcedures.item(name)
    wildcardIndex = PatternWildcards.item(name)
  End If
  
  ' we presume that an _in line is a "procedure" only if it falls outside an if block.
  Dim ifBlock As Integer
  ifBlock = 0
  
  ' Now we add the patterns.  Each pattern is on a separate line and needs to be stored
  ' as an array of Strings.  We stop adding patterns when we reach a blank line
  ' or the end of the file.
  
  patternsAdded = 0  'keep track of how many words we added
  Do While f.AtEndOfStream <> True
    l = GetNextLine(f)
    If l = "" Then Exit Do  ' a blank line: no more patterns left to add
    
    ' take a peek at the first word of a line to look for a special directive like
    ' "_MERGE"
    
    words = Split(l)  ' we know we have at least one word
    firstWord = UCase(words(0))
    Select Case firstWord
    
      Case "_MERGE"  ' a keyword for merging the contents of another pattern list
          
          If UBound(words) < 1 Then  ' make sure the user specified a pattern list name
            ErrorsString = ErrorsString & "Line " & f.Line & " - _MERGE requires a pattern list name.  Syntax: _MERGE <patternlist>." & vbCrLf
          Else
            listToMerge = words(1)
            If Patterns.Exists(listToMerge) Then
              ' this routine is defined at the bottom of this module; it merges the
              ' elements from one Collection into another
              Call MergeCollections(patternCollection, Patterns.item(listToMerge))
              ' count the number of words we've added
              patternsAdded = patternsAdded + Patterns.item(listToMerge).count
            Else
              ErrorsString = ErrorsString & "Line " & f.Line & " - _MERGE can't find PATTERNLIST " & listToMerge & ".  Be sure to only merge from lists that PRECEDE a given _MERGE command." & vbCrLf
            End If
          End If
      
      Case "_PROPERTY"
          If UBound(words) < 2 Then  ' make sure the user specified a property name and value
            ErrorsString = ErrorsString & "Line " & f.Line & " - _property requires a property name and value.  Syntax: _property <name> <value>." & vbCrLf
          Else
            If PatternProperties.Exists(name) Then
              Set propDictionary = PatternProperties.item(name)
            Else
              Set propDictionary = CreateObject("Scripting.Dictionary")
              PatternProperties.Add name, propDictionary
            End If
            a = SubArray(words, 2, UBound(words))
            propDictionary.Add words(1), a  ' property, value
          End If
            
      Case "##"  ' ignore line; a comment
      Case "//"  ' ignore line; a comment
      Case "_"  ' ignore line; a comment
      
      Case Else  ' the default: add a pattern to the Collection
        patternCollection.Add (words)  ' rememeber: words is an array of the whole line
        patternsAdded = patternsAdded + 1  ' count the number of patterns we've added
        
        ' pre-compile a lookup table for speed
        Select Case firstWord
          
          Case "_IF"
              ifBlock = ifBlock + 1
          
          Case "_ENDIF"
              ifBlock = ifBlock - 1
              
          Case "_OUT"
              If waitingForOut = True Then
                addingProcedures = False
              End If
          
          Case "_OUTM"
              If waitingForOut = True Then
                addingProcedures = False
              End If
              
          Case "_IN"
    
              If waitingForOut = True Then
                waitingForOut = False
              End If
          
              ' add a quick lookup entry for a line that looks like a "procedure"
              If addingProcedures = True And UBound(words) > 0 Then
                If words(1) Like "[$~[*][#][?][!]*]" Then  ' a wildcard line
                  waitingForOut = True  ' procs can occur after non-returning wildcard matches
                  mostRecentWildcard = patternsAdded
                ElseIf ifBlock = 0 Then
                  If Not procedureIndex.Exists(words(1)) Then
                    procedureIndex.Add words(1), patternsAdded
                    wildcardIndex.Add words(1), mostRecentWildcard
                  End If
                End If
              End If
    
        End Select
        
    End Select
    
  Loop
    
  ' instance all properties inherited from ones parent(s)
  If PatternParents.Exists(name) Then
    parentName = PatternParents(name)
    Call CreatePropertyInstances(name, parentName)
  End If
  
  ' all patterns have some default, "hidden" code that handles inheritance
  
  ' implement the "_self" keyword for having patterns return handles to themselves
'   If patternCollection.count >= 1 Then
'      pattern = Array("_out", name, "~a")   ' the code is in reverse to how these will execute
'     pattern = Array("_out", "{", name, "_self", "{", "~a", "}", "}")   ' the code is in reverse to how these will execute
'     pattern = Array("_out", "{", name, "_self", "~a", "}")   ' the code is in reverse to how these will execute
'     patternCollection.Add item:=pattern, before:=1
'     pattern = Array("_in", "~a", "_self")
'     patternCollection.Add item:=pattern, before:=1
'     pattern = Array("_out", name)
'     patternCollection.Add item:=pattern, before:=1
'     pattern = Array("_in", "_self")
'     patternCollection.Add item:=pattern, before:=1
'   Else
'     pattern = Array("_in", "_self")   ' this code is in order
'     patternCollection.Add (pattern)
'     pattern = Array("_out", name)
'     patternCollection.Add (pattern)
'     pattern = Array("_in", "~a", "_self")
'     patternCollection.Add (pattern)
'     pattern = Array("_out", "{", name, "_self", "~a", "}")
'     pattern = Array("_out", "{", name, "_self", "{", "~a", "}", "}")
'     pattern = Array("_out", name, "~a")
'     patternCollection.Add (pattern)
 ' End If
  
'  If patternsAdded = 0 Then  ' if no patterns were found, warn the user and don't add the collection
'    ErrorsString = ErrorsString & _
'      "Line " & f.Line & " - WARNING: no patterns found for PATTERNLIST " & name & "." & vbCrLf
'  Else
    If autoMerging = False Then
      Patterns.Add name, patternCollection   ' add the pattern list to the master list of lists
      PatternProcedures.Add name, procedureIndex
      PatternWildcards.Add name, wildcardIndex
    End If
    TotalPatternCount = TotalPatternCount + patternsAdded  ' keep a running tally
'  End If
  
End Sub

' Parse a many-to-one mapping of words into a Dictionary

Public Sub ParseMap(f As Variant, name As Variant)
  
  ' create a Dictionary for holding all of the mappings
  Dim mapDictionary
  Set mapDictionary = CreateObject("Scripting.Dictionary")
  
  Dim autoMerging
  autoMerging = False
  
  ' First make sure that a Dictionary of grammar lists doesn't already contain a grammar list
  ' by the same name.  We will merge additional grammars automatically if a list already exists
  
  If Maps.Exists(name) Then
    autoMerging = True
    Set mapDictionary = Maps.item(name)
    ErrorsString = ErrorsString & _
      ".... merging lists automatically.  Line " & f.Line & " - MAP " & name & " already defined." & vbCrLf
  End If
    
  ' Now we add the grammars.  Each grammar is on a separate line and needs to be stored
  ' as an array of Strings.  We stop adding grammars when we reach a blank line
  ' or the end of the file.
  
  mapsAdded = 0  'keep track of how many words we added
  Do While f.AtEndOfStream <> True
     l = GetNextLine(f)
     If l = "" Then Exit Do  ' a blank line: no more words left to add
    
    ' take a peek at the first word of a line to look for a special directive like
    ' "_MERGE"
    
    words = Split(l)  ' we know we have at least one word
    Select Case UCase(words(0))
      
      Case "_MERGE"  ' a keyword for merging the contents of another map
          
          If UBound(words) < 1 Then  ' make sure the user specified a map name
            ErrorsString = ErrorsString & "Line " & f.Line & " - _MERGE requires a map name.  Syntax: _MERGE <map>." & vbCrLf
          Else
            mapToMerge = words(1)
            If Maps.Exists(mapToMerge) Then
              ' this routine is defined at the bottom of this module; it merges the
              ' elements from one Dictionary into another
              Call MergeDictionaries(mapDictionary, Maps.item(mapToMerge), False)
              ' count the number of words we've added
              mapsAdded = mapsAdded + Maps.item(mapToMerge).count
            Else
              ErrorsString = ErrorsString & "Line " & f.Line & " - _MERGE can't find MAP " & mapToMerge & ".  Be sure to only merge from maps that PRECEDE a given _MERGE command." & vbCrLf
            End If
          End If
      
      Case "##"  ' ignore line; a comment
      Case "//"  ' ignore line; a comment
      Case "_"  ' ignore line; a comment
      
      Case Else  ' the default: add a map to the Dictionary
        If autoMerging = False Then
          If UBound(words) < 1 Then  ' make sure the user specified both a key and an item
            ErrorsString = ErrorsString & "Line " & f.Line & " - MAP requires both a key and an item: " & l & vbCrLf
          Else
            If mapDictionary.Exists(words(0)) Then
              ErrorsString = ErrorsString & "Line " & f.Line & " - MAP contains duplicate mapping.  Mapping will be ignored: " & l & vbCrLf
            Else
              Call mapDictionary.Add(replace(words(0), "_", " "), replace(words(1), "_", " "))
            End If
          End If
        End If
        mapsAdded = mapsAdded + 1  ' count the number of mappings we've added
    End Select
    
  Loop
  
'  If mapsAdded = 0 Then  ' if no mappings were found, warn the user and don't add the Dictionary
'    ErrorsString = ErrorsString & _
'      "Line " & f.Line & " - WARNING: no mappings found for MAP " & name & "." & vbCrLf
'  Else
    If autoMerging = False Then
      Maps.Add name, mapDictionary   ' add map to the master list of Dictionaries
    End If
'    TotalGrammarCount = TotalGrammarCount + grammarsAdded  ' keep a running tally
'  End If
  
End Sub

' parse a CONST line.  This routine is different than the other parsing routines in
' that it has to parse a single command-line rather than a series of lines.  The
' CONST line is passed in as an array in the "words" argument.

Public Sub ParseConst(f As Variant, name As Variant, words As Variant)

  ' First make sure that the Dictionary of CONST directives doesn't already contain
  ' a directive by the same name.  This will cause a Visual Basic error in the
  ' Dictionary object.
  
  If ConstDeclarations.Exists(name) Then
    ' NOTE: " _" is the symbol for continuing a line of code on another line
    ErrorsString = ErrorsString & _
      "Line " & f.Line & " - CONST " & name & " already defined.  CONST declaration will be skipped." & vbCrLf
      Exit Sub  ' return back to the main parsing loop
  End If
  
  ' Just store the last part of the CONST line in an array.  This array will be
  ' treated like a grammar for evaluation every time a story is written.
  
  Dim constGrammar() As Variant  ' a dynamically sized array for storing the grammar
  ReDim constGrammar(UBound(words) - 2)  ' we skip the word "CONST" and the variable name
  
  ' fill the array with word values
  For i = 0 To UBound(words) - 2  ' arrays are numbered from 0
    constGrammar(i) = words(i + 2)
  Next
  
  ConstDeclarations.Add name, constGrammar   ' add the const grammar to the master list
'    TotalGrammarCount = TotalGrammarCount + grammarsAdded  ' keep a running tally

End Sub

' A routine that lets us update the FileListBox whenever the user changes
' the current directory in the DirListBox object.
'
' SPECIAL NOTE: I'm being pretty sloppy by giving the variables that refer to
' these objects (DirListBox, FileListBox; etc.) the same names as the object classes.
' It works for us, since we only have one instance of each object, but it's
' probably bad coding style.  Just remember that when I use "DirListBox" in
' code I'm using a variable local to this application, not a universal object.

Private Sub DirListBox_Change()
  FileListBox.Path = DirListBox.Path
End Sub

' a routine that lets us update the FileListBox and DirListBox when
' the user selects a new drive.

Private Sub DriveListBox_Change()
  DirListBox.Path = DriveListBox.Drive
  FileListBox.Path = DriveListBox.Drive
End Sub

' if the user double-clicks on a filename, automatically try to load it
Private Sub FileListBox_DblClick()
  FileLoadButton_Click  ' we fake a click from the "Load File" button.
End Sub
   
' this routine gets called when the user clicks on "Load File".
' We let the user select a file, then we try to load the data from it.
' If all goes well, we update the text of FileNameLabel to show the
' user that the file is active.

Private Sub FileLoadButton_Click()

  If FileListBox.ListIndex >= 0 Then
    FileName = FileListBox.List(FileListBox.ListIndex)
    FileNameLabel.Caption = FileName  ' display the filename in the label below the Load button
    ' we must use a complete path now that the user can load files from
    ' a folder different from the default folder
    Dim completePath As String
    completePath = FileListBox.Path & "\" & FileName
    Call ParseFile(completePath, 0)
    ' load the data!
  Else
    MsgBox ("Please select a file from the list box before pressing the Load botton.")
  End If
  
End Sub

Sub WriteButton_Click()
  
  ' We now rely completely on an external text file to define a WRITE
  ' command.  This routine tries to write a grammar called "g_system_grammartowrite",
  ' which is what the WRITE command gets parsed into.  If we can't find it,
  ' we print an error.
  
  If Not Grammars.Exists("g_system_grammartowrite") Then
    StoryText.Text = "Sorry, man, you've gotta load a file that contains a valid WRITE command before I can summon my Muse."
  Else
    
    Dim storyArray As Variant
    storyArray = Array("g_system_grammartowrite")
  
    ErrorsString = ""  ' clear out the errors, so that we can display the new ones
    
    InitializeConstValues  ' initialize user variables, values that remain constant for one story

    ' TBD: maybe this goes in its own handler
    PickableWords.RemoveAll
    
    ' The story is constructed by a separate routine that takes the grammar as
    ' input and returns a String.
  
    Dim story As String
    story = WriteStory(storyArray)
  
    ' One thing about creating nested, random grammatical structures is that
    ' it's pretty difficult to know in advance exactly how to punctuate the
    ' sentence.  As a cheap hack, we ignore the problem and simply do
    ' a cheap hack after the story has been written.  We "postprocess" the story
    ' to remove common grammatical errors.  Postprocessing also includes capitalization,
    ' which we implemented by "tagging" the text whereever a word needs to be capitalized.
  
    Dim fixedStory As String
    fixedStory = FixStory(story)
  
    ' Notify user of any error messages during story generation
    If ErrorCheck.Value = 1 Then
      fixedStory = fixedStory & vbCrLf & vbCrLf & ErrorsString
    End If
    
    ' Now all we have left to do is assign the Text property of the text window
    ' to the text of the story.

    StoryText.Text = fixedStory
    
  End If
  
End Sub
  
' takes a grammer and spits out a String eveluation of it
Public Function WriteStory(unevaluatedGrammar As Variant)
  
  Dim Result As String  ' we will store the story here
  Dim words As Variant
  Dim newGrammars As Variant
  Dim newGrammar As Variant
  Dim grammar As Variant
  
  ' First evaluate the grammer down to the level of words.
  
  grammar = Eval(unevaluatedGrammar)
  
  ' Even though we've "evaluated" the grammar, several special-case directives remain
  ' in the array.  We iterate over those here, handling punctuation and other nicities.
  
  For curIndex = 0 To UBound(grammar)
    wordType = grammar(curIndex)
    Select Case wordType
      Case "f_cap"  ' a "function" that says "capitalize the next word"
        ' we insert a marker (|c|) into the text for now.  It will be easier
        ' to do the capitalizing after the whole story has been written
        Result = Result & "|c|"
      Case "f_paragraph"
        Result = Result & vbCrLf & vbCrLf
      Case """"  ' 32 = quotation mark
        Result = Result & """"
      Case "f_start_quote"
        Result = Result & " |qs|"
      Case "f_end_quote"
        Result = Result & "|qe|"
      Case "'s"  ' no space before this
        Result = Result & "'s"
'     This formatting is now handled in FixStory
      Case ","
        Result = Result & ","
      Case ";"
        Result = Result & ";"
      Case "."
        Result = Result & ".  "  ' add a space after a period
      Case Else
        Result = Result & " " & wordType
    End Select
  Next
  
  WriteStory = Result  ' return the story as a String

End Function

' This routine eveluates the grammar of the CONST values, storing
' the results as "temporary grammars" in RunTimeGrammars

Public Sub InitializeConstValues()

  RunTimeGrammars.RemoveAll  ' remove old values of the CONST variables
  allVarnames = ConstDeclarations.keys
  For Each varName In allVarnames
    grammar = ConstDeclarations.item(varName)
    wordlist = Eval(grammar)  ' a generic routine to evaluate a grammar down to words
    RunTimeGrammars.Add varName, wordlist
  Next
  
End Sub

' a generic routine to evaluate a grammar down to a word list (an array)
Public Function Eval(grammarInitial As Variant) As Variant
    Dim grammar As Variant   ' a partly evaluated version of the grammar passed to us
    Dim resultCollection As New Collection
    Dim Result() As Variant  ' we use a dynamic array that grows with the list of words
    Dim numWords As Long
    Dim funcCountReturn As Integer
    Dim tempArray() As Variant
    Dim count As Long
    Dim resultArray() As Variant
    Dim currentWord As Long
    Dim r As Long
    
    ' temp storage
    Dim headArray As Variant
    Dim tailArray As Variant
    
    ' first evaluate all "pointers" that are being referenced by the "`" symbol.
        
    ' the "`" symbol strips off the first character of the next word and
    ' then evals the word.  Useful for passing names of objects around
    ' and choosing when they get evaluated.
            
    grammar = EvalPointers(grammarInitial)
    
    numWords = 0
    
    currentWord = -1
    Do While currentWord < UBound(grammar)
CONTINUE:
      currentWord = currentWord + 1
      wordType = grammar(currentWord)
      
        ' evaluate elements inside braces first
        
          If StrComp(wordType, "{") = 0 Then
            If currentWord >= UBound(grammar) Then
              ErrorsString = ErrorsString & _
                "WARNING: SYNTAX ERROR: " & wordType & " at end of line.  Ignored. ( " & Join(grammar) & " )" & vbCrLf
              GoTo SecondPass ' bail out of the first pass; we're at the end of the list
            End If
                        
            finalGrammar = GetArg(grammar, currentWord - 1, funcCountReturn)
            
            If UBound(finalGrammar) < 1 Then
              GoTo CONTINUE  ' syntax error
            End If
            
'            ErrorsString = ErrorsString & "ARG: " & Join(argument) & vbCrLf
             
            ' strip away the outer {} and Eval() what's inside
            finalGrammar = Eval(SubArray(finalGrammar, 1, UBound(finalGrammar) - 1))
            
            lastArgWord = currentWord + funcCountReturn
            
            If currentWord > 0 Then
              headArray = SubArray(grammar, 0, currentWord - 1)
              finalGrammar = ConcatenateArrays(headArray, finalGrammar)
            End If
          
            If lastArgWord < UBound(grammar) Then
              tailArray = SubArray(grammar, lastArgWord + 1, UBound(grammar))
              finalGrammar = ConcatenateArrays(finalGrammar, tailArray)
            End If
          
            grammar = finalGrammar
            currentWord = currentWord - 1   ' re-eval the current word; it has changed
            GoTo CONTINUE   ' keep iterating through grammar
            
            'googoo
'            ReDim tempArray(0)
'            count = 0: nests = 1
'            For x = currentWord + 1 To UBound(grammar)
'              If StrComp(grammar(x), "{") = 0 Then nests = nests + 1
'              If StrComp(grammar(x), "}") = 0 Then
'                nests = nests - 1
'                If nests = 0 Then
'                  Exit For
'                Else
'                  ReDim Preserve tempArray(count)
'                  tempArray(count) = grammar(x)
'                End If
'              Else
'                ReDim Preserve tempArray(count)
'                tempArray(count) = grammar(x)
'              End If
'              count = count + 1
'            Next
'
'            If nests > 0 Then
'              ErrorsString = ErrorsString & _
'                "WARNING: SYNTAX ERROR: missing brace.  Skipped. ( " & Join(grammar) & " )" & vbCrLf
'              currentWord = x + 1
'              If currentWord <= UBound(grammar) Then
'                GoTo CONTINUE   ' keep iterating through grammar
'              Else
'                GoTo SecondPass
'              End If
'            End If
'
'            If count = 0 Then
'              ErrorsString = ErrorsString & _
'                "WARNING: SYNTAX ERROR: empty parenthesis.  Ignored. ( " & Join(grammar) & " )" & vbCrLf
'              currentWord = x + 1
'              If currentWord <= UBound(grammar) Then
'                GoTo CONTINUE   ' keep iterating through grammar
'              Else
'                GoTo SecondPass ' bail out of the first pass; we're at the end of the list
'              End If
'            End If
'
'            finalArray = Eval(tempArray)  ' evaluate any statements returned by the pattern
'            Call AddArrayToCollection(resultCollection, finalArray)
'
'            currentWord = x + 1
            
'            If currentWord <= UBound(grammar) Then
'               GoTo CONTINUE   ' keep iterating through grammar
'            Else
'               GoTo SecondPass ' bail out of the first pass; we're at the end of the list
'            End If
          
          End If
          
        ' Look for a word list that matches wordType.  Remember that wordType is a String.
        ' We pass this string to the Dictionary object to access the word lists by "key".
        
        If PartsOfSpeech.Exists(wordType) Then
          Set words = PartsOfSpeech.item(wordType) ' get the collection of words specified by wordType
          If words.count > 0 Then
            ' TBD: removing all items is necessary, but this line does seem to generate
            ' multiple Collection objects, once they are added to the master list.
            ' Not sure what's really going on.
            Dim pickable As New Collection
            For Each w In pickable
              pickable.Remove (1)
            Next
            If PickableWords.Exists(wordType) Then
              Set pickable = PickableWords.item(wordType)
            Else
              For Each w In words
                  pickable.Add (w)
              Next
              Call PickableWords.Add(wordType, pickable)
            End If
            If pickable.count > 0 Then
              r = RandomInt(pickable.count)
              pick = pickable.item(r)
              pickable.Remove (r)
            Else
              pick = words.item(RandomInt(words.count))  ' TBD: re-init pickable list
            End If
            If Grammars.Exists(pick) Or _
               RunTimeGrammars.Exists(pick) Or _
               Maps.Exists(pick) Or _
               Patterns.Exists(pick) Or _
               PartsOfSpeech.Exists(pick) Then
              grammar(currentWord) = pick
              currentWord = currentWord - 1   ' re-eval the current word; it has changed
            Else
              resultCollection.Add (pick)
              numWords = numWords + 1
            End If
          End If
          
        ElseIf Grammars.Exists(wordType) Then  ' if there's a grammar by this name...
          Set newGrammars = Grammars.item(wordType) ' get the list of grammars specified by wordType
          newGrammar = newGrammars(RandomInt(newGrammars.count))  ' pick a random grammar
          finalGrammar = Eval(newGrammar)  ' recursive call; evaluate the sub-grammar and merge into the word list

          If currentWord > 0 Then
            headArray = SubArray(grammar, 0, currentWord - 1)
            finalGrammar = ConcatenateArrays(headArray, finalGrammar)
          End If
          
          If currentWord < UBound(grammar) Then
            tailArray = SubArray(grammar, currentWord + 1, UBound(grammar))
            finalGrammar = ConcatenateArrays(finalGrammar, tailArray)
          End If
          
          grammar = finalGrammar
          currentWord = currentWord - 1   ' re-eval the current word; it has changed

'          Call AddArrayToCollection(resultCollection, newWordList)
          
          ' count up the number of new words; reallocate enough memory in Result()
'          numNewWords = UBound(newWordList) + 1
'          numWords = numWords + numNewWords
                  
        ElseIf RunTimeGrammars.Exists(wordType) Then  ' if there's a CONST value by this name...
          newWordList = RunTimeGrammars.item(wordType) ' CONST values can change (ha!).  PatternsGroup commands can make them into higher-level grammars
          finalGrammar = Eval(newWordList)
          ' TBD: memory leaks here...?
          
          ' rebuild "grammar" and continue Evaling from the same point;
          ' this allows subgrammars to Eval() down to symbolic names that
          ' themselves need to be evaluated.
          
          If currentWord > 0 Then
            headArray = SubArray(grammar, 0, currentWord - 1)
            finalGrammar = ConcatenateArrays(headArray, finalGrammar)
          End If
          
          If currentWord < UBound(grammar) Then
            tailArray = SubArray(grammar, currentWord + 1, UBound(grammar))
            finalGrammar = ConcatenateArrays(finalGrammar, tailArray)
          End If
          
          grammar = finalGrammar
          currentWord = currentWord - 1   ' re-eval the current word; it has changed
          
'          Call AddArrayToCollection(resultCollection, finalGrammar)
          
          ' count up the number of new words; reallocate enough memory in Result()
'          numNewWords = UBound(finalGrammar) + 1
'          numWords = numWords + numNewWords
                  
        ElseIf Patterns.Exists(wordType) Then  ' if there's a pattern list by this name...
          If currentWord >= UBound(grammar) Then ' we have no argument for the pattern-match!
'            ErrorsString = ErrorsString & _
'              "WARNING: PATTERN " & wordType & " has no argument.  Pattern will not be applied." & vbCrLf
            resultCollection.Add (wordType) ' add the name of the patterngroup to the grammer; allows patterngroups to pass references to each other
            GoTo SecondPass ' bail out of the first pass; we're at the end of the list
          End If
         
'          If StrComp(LCase(grammar(currentWord + 1)), "_self") = 0 Then
'            resultCollection.Add (wordType) ' add the name of the patterngroup to the grammer; allows patterngroups to pass references to each other
'            currentWord = currentWord + 1
'          Else
         
            ' first evaluate any function calls that follow the pattern-match call
            argument = EvalArg(grammar, currentWord, funcCountReturn)
            
            lastArgWord = currentWord + funcCountReturn + 1
                                         
            Set patternCollection = Patterns.item(wordType) ' get the list of patterns specified by wordType
            matchedWordListTemp = PatternMatch(patternCollection, argument, wordType, wordType)
            'TBD: add error for when PatternMatch fails
            
            finalGrammar = Eval(matchedWordListTemp)  ' evaluate any statements returned by the pattern
                     
            If currentWord > 0 Then
              headArray = SubArray(grammar, 0, currentWord - 1)
              finalGrammar = ConcatenateArrays(headArray, finalGrammar)
            End If
          
            If lastArgWord < UBound(grammar) Then
              tailArray = SubArray(grammar, lastArgWord + 1, UBound(grammar))
              finalGrammar = ConcatenateArrays(finalGrammar, tailArray)
            End If
          
            grammar = finalGrammar
            currentWord = currentWord - 1   ' re-eval the current word; it has changed

'            Call AddArrayToCollection(resultCollection, matchedWordList)
            ' count up the number of new words; reallocate enough memory in Result()
'            numNewWords = UBound(matchedWordList) + 1
'            numWords = numWords + numNewWords
          
            ' we used up one or more words as an argument, so increment the currentWord of grammar
'            currentWord = currentWord + funcCountReturn + 1
'          End If
          
        ElseIf Maps.Exists(wordType) Then  ' if there's a mapping by this name...
          If currentWord >= UBound(grammar) Then ' we have no argument for the mapping!
            ErrorsString = ErrorsString & _
             "WARNING: MAP " & wordType & " has no argument.  Mapping will not be applied." & vbCrLf
            GoTo SecondPass ' bail out of the first pass; we're at the end of the list
          End If
          Set mapDictionary = Maps.item(wordType) ' get the map specified by wordType
          
          argument = EvalArg(grammar, currentWord, funcCountReturn)
          lastArgWord = currentWord + funcCountReturn + 1
          
        ' handle a multi-word Eval()
          ReDim resultArray(0)
          Dim a3 As Integer: a3 = 0
          For x = 0 To UBound(argument)
            ReDim Preserve resultArray(a3)
            If Not mapDictionary.Exists(argument(x)) Then
              ErrorsString = ErrorsString & _
                "WARNING: Bad mapping: maplist: " & wordType & "  arg: " & argument(x) & ".  Original word retained." & vbCrLf
              resultArray(a3) = argument(x)
            Else
              resultArray(a3) = mapDictionary.item(argument(x))
            End If
            a3 = a3 + 1
          Next
                    
          finalGrammar = resultArray
          
          If currentWord > 0 Then
            headArray = SubArray(grammar, 0, currentWord - 1)
            finalGrammar = ConcatenateArrays(headArray, finalGrammar)
          End If
          
          If lastArgWord < UBound(grammar) Then
            tailArray = SubArray(grammar, lastArgWord + 1, UBound(grammar))
            finalGrammar = ConcatenateArrays(finalGrammar, tailArray)
          End If
          
          grammar = finalGrammar
          currentWord = currentWord - 1   ' re-eval the current word; it has changed

'          Call AddArrayToCollection(resultCollection, resultArray)
            
          ' count up the number of new words; reallocate enough memory in Result()
'          numNewWords = UBound(resultArray) + 1
'          numWords = numWords + numNewWords
                    
        Else  ' if we don't understand the wordType, we treat it like a word
          
          Select Case wordType
          
          ' TBD: create an f_random for completely random wordchoice,
          ' but allow it to take a real arg in {}
          
          Case "f_random"   ' takes an arg; that's why we eval it on the first pass
            
            If currentWord >= UBound(grammar) Then ' we have no argument for the f_random!
              ErrorsString = ErrorsString & _
               "WARNING: f_random has no argument.  f_random will not be applied.  (" & Join(grammar) & ")" & vbCrLf
              GoTo SecondPass ' bail out of the first pass; we're at the end of the list
            End If
            
            argument = grammar(currentWord + 1)
            
            If Not PartsOfSpeech.Exists(argument) Then
              ErrorsString = ErrorsString & _
               "WARNING: f_random has an invalid argument.  f_random requires the name of a WORDLIST in order to pick an item.  (" & Join(grammar) & ")" & vbCrLf
            Else
              Set pickFrom = PartsOfSpeech.item(argument) ' get the wordlist specified by wordType
              w = pickFrom.item(RandomInt(pickFrom.count))
              numWords = numWords + 1
              currentWord = currentWord + 1
              resultCollection.Add (w)
            End If
            
          Case Else  ' just a boring old word
            numWords = numWords + 1
            resultCollection.Add (wordType)
          End Select
        End If
  Loop
  
SecondPass:

' second pass of evaluation for functions that operate only on words

' TBD: could add many more verb tenses.  Need generic way to convert verbs from present
'      to past without losing noun agreement.

  Dim finalResultCollection As New Collection
  For i = 1 To resultCollection.count
    wordType = resultCollection.item(i)
    Select Case wordType
    Case "f_plural"
      If i >= resultCollection.count Then ' we have no argument for the pluralize command!
        ErrorsString = ErrorsString & _
          "WARNING: f_plural has no argument.  No word will be pluralized." & vbCrLf
        GoTo ReturnResult ' bail out of Eval(); we're at the end of the list
      End If
      noun = resultCollection.item(i + 1)
      If Nouns.Exists(noun) Then
        nounList = Nouns.item(noun)
        noun_pl = nounList(PLURAL)
      Else  ' take a guess
        lNoun = LCase(noun)
        If Right(lNoun, 1) = "y" Then
          noun_pl = Left(noun, Len(noun) - 1) & "ies"
        ElseIf lNoun Like "*[xsjv]" Then
          noun_pl = noun & "es"
        Else
          noun_pl = noun & "s"
        End If
      End If
      finalResultCollection.Add (noun_pl)
      i = i + 1  ' skip the command and the singular noun
    Case "f_first_present"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, FIRST_PRESENT)
      If newVerb <> "" Then
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_first_past"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, FIRST_PAST)
      If newVerb <> "" Then
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_second_present"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, SECOND_PRESENT)
      If newVerb <> "" Then
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_second_past"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, SECOND_PAST)
      If newVerb <> "" Then
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_third_present"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, THIRD_PRESENT)
      If newVerb <> "" Then
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_third_past"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, THIRD_PAST)
      If newVerb <> "" Then
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_plural_present"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PLURAL_PRESENT)
      If newVerb <> "" Then
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_plural_past"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PLURAL_PAST)
      If newVerb <> "" Then
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_infinitive"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, INFINITIVE)
      If newVerb <> "" Then
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_past_perfect"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PAST_PERFECT)
      If newVerb <> "" Then
        finalResultCollection.Add ("had")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_past_subjunctive"   ' i.e. "have gone", "have eaten", etc.
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PAST_PERFECT)
      If newVerb <> "" Then
        finalResultCollection.Add ("have")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_participle"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PARTICIPLE)
      If newVerb <> "" Then
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_first_present_progressive"   ' i.e. "am going", "am eating", etc.
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PARTICIPLE)
      If newVerb <> "" Then
        finalResultCollection.Add ("am")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_second_present_progressive"   ' i.e. "are going", "are eating", etc.
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PARTICIPLE)
      If newVerb <> "" Then
        finalResultCollection.Add ("are")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_third_present_progressive"   ' i.e. "is going", "is eating", etc.
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PARTICIPLE)
      If newVerb <> "" Then
        finalResultCollection.Add ("is")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_plural_present_progressive"   ' i.e. "are going", "are eating", etc.
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PARTICIPLE)
      If newVerb <> "" Then
        finalResultCollection.Add ("are")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_first_past_progressive"   ' i.e. "was going", "was eating", etc.
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PARTICIPLE)
      If newVerb <> "" Then
        finalResultCollection.Add ("was")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_second_past_progressive"   ' i.e. "were going", "were eating", etc.
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PARTICIPLE)
      If newVerb <> "" Then
        finalResultCollection.Add ("were")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_third_past_progressive"   ' i.e. "was going", "was eating", etc.
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PARTICIPLE)
      If newVerb <> "" Then
        finalResultCollection.Add ("was")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_plural_past_progressive"   ' i.e. "were going", "were eating", etc.
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PARTICIPLE)
      If newVerb <> "" Then
        finalResultCollection.Add ("were")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_future_progressive"   ' i.e. "will be going", "will be eating", etc.
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, PARTICIPLE)
      If newVerb <> "" Then
        finalResultCollection.Add ("will")
        finalResultCollection.Add ("be")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
    Case "f_future"
      verb = resultCollection.item(i + 1)
      newVerb = ConjugateVerb(verb, ROOT)
      If newVerb <> "" Then
        finalResultCollection.Add ("will")
        finalResultCollection.Add (newVerb)
        i = i + 1  ' skip the command and the verb
      End If
      
      Case Else  ' by default, just duplicate the first-pass result
        finalResultCollection.Add (wordType)
    End Select
  Next
  
ReturnResult:
  
  If finalResultCollection.count > 0 Then
    ReDim Result(finalResultCollection.count - 1)
    i = 0
    For Each element In finalResultCollection
      Result(i) = element
      i = i + 1
    Next
  Else
    ReDim Result(0)
    Result(0) = "|e|"
  End If
  
  Eval = Result
  
End Function

Public Function EvalPointers(grammarInitial As Variant)
    
    Dim grammar() As Variant
    Dim count As Long
    Dim x As Integer
    
    ReDim grammar(0)
    count = 0
    For x = 0 To UBound(grammarInitial)
      curWord = grammarInitial(x)
      If StrComp(curWord, "`") = 0 Then
        x = x + 1
        If x > UBound(grammarInitial) Then
          ErrorsString = ErrorsString & _
            "WARNING: SYNTAX ERROR: ` at end of line.  Ignored. ( " & Join(grammar) & " )" & vbCrLf
        Else
          curWordArray = Eval(Array(grammarInitial(x)))
          curWord = curWordArray(0)
          curWord = Right(curWord, Len(curWord) - 1)
          ReDim Preserve grammar(count)
          grammar(count) = curWord
          count = count + 1
        End If
      Else
        ReDim Preserve grammar(count)
        grammar(count) = grammarInitial(x)
        count = count + 1
      End If
    Next x
    
'    ErrorsString = ErrorsString & _
'      "IN: " & Join(grammarInitial) & vbCrLf & "OUT: " & Join(grammar) & vbCrLf
    
    EvalPointers = grammar
    
End Function
' scans ahead in a grammar to evaluate nested function calls
Public Function EvalArg(grammar As Variant, currentWord As Variant, funcCountReturn As Integer)
  
  arg = GetArg(grammar, currentWord, funcCountReturn)
  If UBound(arg) < 1 Then
    EvalArg = arg
  Else
    EvalArg = Eval(SubArray(arg, 1, UBound(arg) - 1))  ' we return the fully evaluated result of all function calls immediately following currentWord
  End If

End Function

' scans ahead in a grammar to evaluate nested function calls
Public Function GetArg(grammar As Variant, currentWord As Variant, funcCountReturn As Integer)
  
  Dim evalArray() As Variant
  Dim a As Integer: a = 0
  Dim nests As Integer: nests = 0
  
'  foundBrace = False
  
  For x = currentWord + 1 To UBound(grammar)
    ReDim Preserve evalArray(a)
    evalArray(a) = grammar(x)
    If StrComp(grammar(x), "{") = 0 Then
      nests = nests + 1
    ElseIf StrComp(grammar(x), "}") = 0 Then
      nests = nests - 1
      If nests <= 0 Then  ' -1 is an error, caught below
        Exit For
      End If
    ElseIf Not Patterns.Exists(grammar(x)) And Not Maps.Exists(grammar(x)) Then
      If nests = 0 Then
        Exit For
      End If
    End If
    a = a + 1
  Next
    
  If nests <> 0 Then
    ErrorsString = ErrorsString & _
        "WARNING: SYNTAX ERROR: bad braces: " & Join(grammar) & vbCrLf
  End If
  
  funcCountReturn = a
  GetArg = evalArray

End Function

' a routine to pattern-match a list of words with a list of _in, _out
' pattern definitions
Public Function PatternMatch(patternCommands As Variant, wordlist As Variant, patternName As Variant, childName As Variant) As Variant
  
  Dim Result() As Variant  ' we use a dynamic array that grows with the list of words
  
  Dim wordBound As Long
  wordBound = UBound(wordlist)
        
  Dim patternBound As Long
  Dim matchedPattern As Variant
  Dim Variables
  Set Variables = CreateObject("Scripting.Dictionary")
  Dim OutGrammars As New Collection
  
  Dim currentWord As Long
  Dim funcCountReturn As Integer
  
  ' speed enhancement -- hop ahead if we can
  Dim hoppingToProcedure As Boolean: hoppingToProcedure = False
  Dim procedureLineNumber As Integer: procedureLineNumber = 0
  Dim lastWildcard As Integer: lastWildcard = 0
  If PatternProcedures.Exists(patternName) Then
    Set procedureIndex = PatternProcedures.item(patternName)
    If procedureIndex.Exists(wordlist(0)) Then
      hoppingToProcedure = True
      procedureLineNumber = procedureIndex.item(wordlist(0))
      Set wildcardIndex = PatternWildcards.item(patternName)
      lastWildcard = wildcardIndex.item(wordlist(0))
    End If
  End If
  
  ' temp storage
  Dim headArray As Variant
  Dim tailArray As Variant
  
  Dim varWordsTemp() As Variant

  Dim ifBlock As Integer  ' to iteratively keep track of how deep in an "if" structure we are
  ifBlock = 0
  
  Dim stage As Integer  ' a variable to help switch between stages of the algorithm.
  Dim pushStage As Integer
  stage = MATCHING
  pushStage = stage

  Dim parentName As Variant
  If PatternParents.Exists(patternName) Then
    parentName = PatternParents.item(patternName)
  Else
    parentName = "_BAD_PARENT_REF"
  End If

 ' ErrorsString = ErrorsString & "Matching '" & Join(wordlist) & "' in '" & patternName & "', parent of '" & childName & ".'" & vbCrLf
  
  ' first of all, the user might simply be querying for the value of a "property".
  ' we look for the property name; if we find it, we return a value.

  ' the search for a property value, GetPatternProperty(), automatically checks
  ' parent patterns, so do this check only once.
  If StrComp(patternName, childName) = 0 Then
    firstWord = wordlist(0)
    firstChar = Left(firstWord, 1)
    If firstChar = ">" Then
      firstWord = Right(firstWord, Len(firstWord) - 1)
      propertyVal = GetPatternProperty(patternName, firstWord)
      If propertyVal(0) <> "" Then
        PatternMatch = propertyVal
        Exit Function
      End If
    End If
  End If
  
  ' create a variable-list of all properties of this patterngroup
  Set Properties = GetPatternProperties(childName)
  
  ' TBD: change this to an iteration based on i and the "Item" method of Collection.
  ' allow a quick-hop to a procedure.
  Dim curPattern As Integer: curPattern = 0
  Do While curPattern < patternCommands.count
    If hoppingToProcedure = True Then  ' speed hack
      If curPattern >= lastWildcard And stage = MATCHING Then
        hoppingToProcedure = False
        curPattern = procedureLineNumber
      Else
        curPattern = curPattern + 1
      End If
    Else
      curPattern = curPattern + 1
    End If
    pattern = patternCommands.item(curPattern)
start:
    Select Case stage
      Case MATCHING:
        
        Variables.RemoveAll
        Call MergeDictionaries(Variables, Properties, False)  ' add all properties to the variables list
        Variables.Add "i_self", Array("@" & childName)
        ' eval parent-child refs whenever we eval local variables
'        Variables.Add "_child", Array(childName)
'        Variables.Add "_parent", Array(parentName)
        
        directive = LCase(pattern(0))
        
        If directive = "_if" Then
          cond = FillInVariables(pattern, Variables)
          If UBound(cond) < 3 Then  ' make sure the user specified at least three args
            ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _if requires a conditional statement, i.e. '_if c_one = c_two'.  (" & Join(cond) & ")" & vbCrLf
            GoTo NEXTPATTERN
          End If
          
          cond = SubArray(cond, 1, UBound(cond))
          tf = EvalConditional(cond, parentName, childName)
          If tf = False Then
            pushStage = stage
            ifBlock = 0
            stage = SKIPPING_IF_BLOCK
            GoTo NEXTPATTERN
          End If
        End If
        
        ' _else blocks should only be executed when the corresponding _if was false.
        ' if we see one here, we need to skip it.
        If directive = "_else" Then
          pushStage = stage
          ifBlock = 0
          stage = SKIPPING_ELSE_BLOCK
          GoTo NEXTPATTERN
        End If
        
        If directive <> "_in" Then GoTo NEXTPATTERN
        
        tf = MatchGrammarToPattern(wordlist, pattern, Variables, childName)
        
        If tf = True Then
          stage = FINDING_MATCHED_OUT  ' look for _out lines
          matchedPattern = pattern
'          GoTo start:
          GoTo NEXTPATTERN   ' recent change
        Else
          GoTo NEXTPATTERN
        End If
                
      Case FINDING_MATCHED_OUT:  ' first find the beginning of the _out lines
          lineTag = LCase(pattern(0))
          
          ' abort if we bump into another _in before finding any lines to process
          If StrComp(lineTag, "_in") = 0 Then
            stage = MATCHING
            GoTo start
          End If
          
          ' if statements also occur "inside" _out blocks
          If lineTag = "_if" Then
            cond = FillInVariables(pattern, Variables)
            If UBound(cond) < 3 Then  ' make sure the user specified at least three args
              ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _if requires a conditional statement, i.e. '_if c_one = c_two'.  (" & Join(cond) & ")" & vbCrLf
              GoTo NEXTPATTERN
            End If
          
            cond = SubArray(cond, 1, UBound(cond))
              tf = EvalConditional(cond, parentName, childName)
            If tf = False Then
              pushStage = stage
              ifBlock = 0
              stage = SKIPPING_IF_BLOCK
              GoTo NEXTPATTERN
            End If
          End If
        
          ' _else blocks should only be executed when the corresponding _if was false.
          ' if we see one here, we need to skip it.
          If lineTag = "_else" Then
            pushStage = stage
            ifBlock = 0
            stage = SKIPPING_ELSE_BLOCK
            GoTo NEXTPATTERN
          End If
          
          If StrComp(lineTag, "_out") <> 0 And _
             StrComp(lineTag, "_outm") <> 0 And _
             StrComp(lineTag, "_set") <> 0 And _
             StrComp(lineTag, "_eval") <> 0 And _
             StrComp(lineTag, "_createmap") <> 0 And _
             StrComp(lineTag, "_createwordgroup") <> 0 And _
             StrComp(lineTag, "_creategrammargroup") <> 0 And _
             StrComp(lineTag, "_addword") <> 0 And _
             StrComp(lineTag, "_removeword") <> 0 And _
             StrComp(lineTag, "_addmap") <> 0 And _
             StrComp(lineTag, "_removemap") <> 0 And _
             StrComp(lineTag, "_appendpattern") <> 0 And _
             StrComp(lineTag, "_prependpattern") <> 0 And _
             StrComp(lineTag, "_addgrammar") <> 0 Then GoTo NEXTPATTERN
       '   p_iter = p_iter - 1   ' back up one; start collecting _outs from the start of the list
 '         OutGrammars.Add (Pattern)
          stage = PARSING_MATCHED_OUTS  ' collect all _out patterns
          GoTo TotalHack
        
        Case PARSING_MATCHED_OUTS:  ' collect all of the subsequent _out lines and pick one to use
TotalHack:
          lineTag = LCase(pattern(0))
          Select Case lineTag
            Case "_out"
              ' TBD: moved this up so that _set calls could be reflected in _out lines
              '      need to move more eval stuff up here?
              finalWords = FillInVariables(pattern, Variables)
              OutGrammars.Add (finalWords)
            Case "_outm"    ' add an _out line multiple times (affects probablility of selection)
              If UBound(pattern) < 2 Then  ' make sure the user specified a list and a word
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _outm requires a multiplier and an out grammar.  Syntax: _outm <multiplier> <words...>.  (" & Join(pattern) & ")" & vbCrLf
              Else
                newPattern = ConcatenateArrays(Array("_out"), SubArray(pattern, 2, UBound(pattern)))
                finalWords = FillInVariables(newPattern, Variables)
                For i = 1 To CInt(pattern(1))
                  OutGrammars.Add (finalWords)
                Next
              End If
            Case "_eval"    ' just force a command to be eval'ed; good for sending messages to patterngroups
              If UBound(pattern) < 1 Then  ' make sure the user specified something to eval
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _eval requires a statement to evaluate.  Syntax: _eval <words...>.  (" & Join(pattern) & ")" & vbCrLf
              Else
                newPattern = SubArray(pattern, 1, UBound(pattern))
                finalWords = FillInVariables(newPattern, Variables)   ' new
                finalWords = EvalPointers(finalWords)   ' new
                finalWords = EvalInheritance(finalWords, parentName, childName)
                finalWords = Eval(finalWords)
                ' ignore finalwords; this command is simply for forcing an evaluation.
              End If
            Case "_addword"
              finalWords = FillInVariables(pattern, Variables)
              finalWords = EvalPointers(finalWords)
              If UBound(finalWords) < 2 Then  ' make sure the user specified a list and a word
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _addword requires a list name and a word.  Syntax: _addword <listname> <word>.  (" & Join(pattern) & ")" & vbCrLf
              Else
'                finalString = replace(Join(SubArray(finalWords, 2, UBound(finalWords))), "_", " ")
                
                finalWordsEval = SubArray(finalWords, 2, UBound(finalWords))
                finalWordsEval = EvalInheritance(finalWordsEval, parentName, childName)
                finalWordsEval = Eval(finalWordsEval)
                
'                finalString = Join(SubArray(finalWords, 2, UBound(finalWords)))
                finalString = Join(finalWordsEval)
                Call AddToWordList(finalWords(1), finalString)
              End If
            Case "_removeword"
              finalWords = FillInVariables(pattern, Variables)
              finalWords = EvalPointers(finalWords)
              If UBound(finalWords) < 2 Then  ' make sure the user specified a list and a word
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _removeword requires a list name and a word.  Syntax: _removeword <listname> <word>.  (" & Join(pattern) & ")" & vbCrLf
              Else
'                finalString = replace(Join(SubArray(finalWords, 2, UBound(finalWords))), "_", " ")
                finalWordsEval = SubArray(finalWords, 2, UBound(finalWords))
                finalWordsEval = EvalInheritance(finalWordsEval, parentName, childName)
                finalWordsEval = Eval(finalWordsEval)
                finalString = Join(finalWordsEval)
                Call RemoveFromWordList(finalWords(1), finalString)
              End If
            Case "_addgrammar"  ' TBD: debug all of these like _addword regarding pointers
              finalWords = FillInVariables(pattern, Variables)
              finalWords = EvalPointers(finalWords)
              If UBound(finalWords) < 2 Then  ' make sure the user specified a list and a grammar
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _addgrammar requires a list name and a grammar.  Syntax: _addgrammar <listname> <grammar>.  (" & Join(pattern) & ")" & vbCrLf
              Else
                
                finalWordsEval = SubArray(finalWords, 2, UBound(finalWords))
                finalWordsEval = EvalInheritance(finalWordsEval, parentName, childName)
                finalWordsEval = Eval(finalWordsEval)
                
                Call AddToGrammarList(finalWords(1), finalWordsEval)
              End If
            Case "_appendpattern"
              If UBound(pattern) < 2 Then  ' make sure the user specified a list and a pattern
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _appendpattern requires a list name and a pattern.  Syntax: _appendpattern <listname> <pattern>.  (" & Join(pattern) & ")" & vbCrLf
              Else
                Dim tempWords4 As New Collection ' make a Collection of the words to be combined into one pattern array
                For i = 2 To UBound(pattern)
                  tempWords4.Add (pattern(i))
                Next
                finalWords = FillInVariables(tempWords4, Variables)
                Call AppendPattern(pattern(1), finalWords)
              End If
            Case "_prependpattern"
              If UBound(pattern) < 2 Then  ' make sure the user specified a list and a pattern
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _prependpattern requires a list name and a pattern.  Syntax: _prependpattern <listname> <pattern>.  (" & Join(pattern) & ")" & vbCrLf
              Else
                Dim tempWords5 As New Collection ' make a Collection of the words to be combined into one pattern array
                For i = 2 To UBound(pattern)
                  tempWords5.Add (pattern(i))
                Next
                finalWords = FillInVariables(tempWords5, Variables)
                Call PrependPattern(pattern(1), finalWords)
              End If
            Case "_addmap"
              finalWords = FillInVariables(pattern, Variables)
              finalWords = EvalPointers(finalWords)
              If UBound(finalWords) < 3 Then  ' make sure the user specified a list, a key, and a word
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _addmap requires a map name, a key, and a word.  Syntax: _addmap <mapname> <key> <word>.  (" & Join(pattern) & ")" & vbCrLf
              Else
                finalWordsEval = SubArray(finalWords, 2, UBound(finalWords))
                finalWordsEval = EvalInheritance(finalWordsEval, parentName, childName)
                finalWordsEval = Eval(finalWordsEval)
                If UBound(finalWordsEval) >= 1 Then
                  Call AddToMap(finalWords(1), finalWordsEval(0), finalWordsEval(1))
                Else
                  ErrorsString = ErrorsString & "MAP NOT ADDED - TERMS LOST AFTER EVAL() -- " & Join(pattern) & ")" & vbCrLf
                End If
              End If
            Case "_removemap"
              finalWords = FillInVariables(pattern, Variables)
              finalWords = EvalPointers(finalWords)
              If UBound(finalWords) < 2 Then  ' make sure the user specified a list and a key
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _removemap requires a map name, a key, and a word.  Syntax: _removemap <mapname> <key>.  (" & Join(pattern) & ")" & vbCrLf
              Else
                finalWordsEval = SubArray(finalWords, 2, UBound(finalWords))
                finalWordsEval = EvalInheritance(finalWordsEval, parentName, childName)
                finalWordsEval = Eval(finalWordsEval)
                Call RemoveFromMap(pattern(1), finalWordsEval(0))
              End If
            Case "_createwordgroup"  ' command for defining a Collection of words
              If UBound(pattern) < 1 Then  ' make sure the user gave a name for the word group
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _createwordgroup requires a name in order to create the wordgroup." & vbCrLf
              Else
                wordListName = pattern(1)
                If Not PartsOfSpeech.Exists(wordListName) Then
                  Dim wordCollection As New Collection
                  PartsOfSpeech.Add wordListName, wordCollection
                End If
              End If
            Case "_creategrammargroup"  ' command for defining a Collection of grammars
              If UBound(pattern) < 1 Then  ' make sure the user gave a name for the grammar group
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _creategrammargroup requires a name in order to create the grammargroup." & vbCrLf
              Else
                grammarListName = pattern(1)
                If Not Grammars.Exists(grammarListName) Then
                  Dim grammarCollection As New Collection
                  Grammars.Add grammarListName, grammarCollection
                End If
              End If
            Case "_createmap"  ' command for defining a map
              If UBound(pattern) < 1 Then  ' make sure the user gave a name for the map
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _createmap requires a name in order to create the map." & vbCrLf
              Else
                mapName = pattern(1)
                If Not Maps.Exists(mapName) Then
                  Dim mapDictionary
                  Set mapDictionary = CreateObject("Scripting.Dictionary")
                  Maps.Add mapName, mapDictionary
                End If
              End If
            Case "_set"
              If UBound(pattern) < 2 Then  ' make sure the user specified a variable and a value
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _set requires a variable name and a value.  Syntax: _set <varname> <value1> [<value2> ...] .  (" & Join(pattern) & ")" & vbCrLf
              Else
'                head = SubArray(pattern, 0, 1)
'                tail = SubArray(pattern, 2, UBound(pattern))
              
 '               tail = FillInVariables(tail, Variables)
 '               tail = EvalPointers(tail)
 '               tail = Eval(tail)
                
  '              finalWords = ConcatenateArrays(head, tail)
                
                Dim tempWords2 As New Collection ' make a Collection of the words to be assigned to varName
                While tempWords2.count > 0  ' items sticking around?
                  tempWords2.Remove (1)
                Wend
                Dim iStart As Long  ' allow "=" for assignment, but don't require it
                If pattern(2) = "=" And UBound(pattern) > 2 Then
                  iStart = 3
                Else
                  iStart = 2
                End If
                For i = iStart To UBound(pattern)
                  tempWords2.Add (pattern(i))
                Next
                finalWords = FillInVariables(tempWords2, Variables)
                
                finalWordsEval = EvalPointers(finalWords)
                finalWordsEval = EvalInheritance(finalWordsEval, parentName, childName)
                finalWordsEval = Eval(finalWordsEval)
                
'                finalWordsEval = EvalInheritance(finalWords, parentName, childName)
'                finalWordsEval = Eval(finalWords)
                
                'we can set the value of both properties and const values
                varName = pattern(1)
                propertyVal = GetPatternProperty(childName, varName)
                
                If propertyVal(0) <> "" Then
                  Call SetPatternProperty(childName, varName, finalWordsEval)
                  ' keep local Properties and Variables lists up-to-date
                  Set Properties = GetPatternProperties(childName)
                  Call MergeDictionaries(Variables, Properties, True)
                Else
                  If RunTimeGrammars.Exists(varName) Then  ' if there's already a variable by this name...
                    RunTimeGrammars.Remove (varName)
                  End If
                  RunTimeGrammars.Add varName, finalWordsEval
                End If
              End If
              
            Case "_if"   ' if statements also occur "inside" _out blocks
              cond = FillInVariables(pattern, Variables)
              If UBound(cond) < 3 Then  ' make sure the user specified at least three args
                ErrorsString = ErrorsString & "PATTERN MATCH ERROR - _if requires a conditional statement, i.e. '_if c_one = c_two'.  (" & Join(cond) & ")" & vbCrLf
                GoTo NEXTPATTERN
              End If
          
              cond = SubArray(cond, 1, UBound(cond))
              cond = Eval(cond)
              tf = EvalConditional(cond, parentName, childName)
              If tf = False Then
                pushStage = stage
                ifBlock = 0
                stage = SKIPPING_IF_BLOCK
                GoTo NEXTPATTERN
              End If
        
              ' _else blocks should only be executed when the corresponding _if was false.
              ' if we see one here, we need to skip it.
            Case "_else"
              pushStage = stage
              ifBlock = 0
              stage = SKIPPING_ELSE_BLOCK
              GoTo NEXTPATTERN
            Case "_endif"   ' ignore

            Case Else
              If OutGrammars.count < 1 Then  ' keep going until we've found an _out
                stage = MATCHING
                GoTo start
              Else
                Exit Do  ' now pick a grammar and fill it in
              End If
          End Select
          
        Case SKIPPING_TO_OUT:  ' first find the beginning of the _out lines
          lineTag = LCase(pattern(0))
          If StrComp(lineTag, "_out") <> 0 And _
             StrComp(lineTag, "_outm") <> 0 And _
             StrComp(lineTag, "_set") <> 0 And _
             StrComp(lineTag, "_eval") <> 0 And _
             StrComp(lineTag, "_createmap") <> 0 And _
             StrComp(lineTag, "_createwordgroup") <> 0 And _
             StrComp(lineTag, "_creategrammargroup") <> 0 And _
             StrComp(lineTag, "_addword") <> 0 And _
             StrComp(lineTag, "_removeword") <> 0 And _
             StrComp(lineTag, "_addmap") <> 0 And _
             StrComp(lineTag, "_removemap") <> 0 And _
             StrComp(lineTag, "_appendpattern") <> 0 And _
             StrComp(lineTag, "_prependpattern") <> 0 And _
             StrComp(lineTag, "_addgrammar") <> 0 Then GoTo NEXTPATTERN
          stage = SKIPPING_TO_IN
        
        Case SKIPPING_TO_IN:  ' first find the beginning of the next _in or _if block
          lineTag = LCase(pattern(0))
          If StrComp(lineTag, "_in") <> 0 And _
             StrComp(lineTag, "_if") <> 0 Then GoTo NEXTPATTERN
          stage = MATCHING
          GoTo start
          
        Case SKIPPING_IF_BLOCK:
          
          lineTag = LCase(pattern(0))
          
          If StrComp(lineTag, "_if") = 0 Then
            ifBlock = ifBlock + 1
            GoTo NEXTPATTERN
          End If
          
          If StrComp(lineTag, "_else") = 0 Then
            If ifBlock = 0 Then
              stage = pushStage
              GoTo NEXTPATTERN
            End If
          End If
          
          If StrComp(lineTag, "_endif") = 0 Then
            ifBlock = ifBlock - 1
            If ifBlock = -1 Then
              stage = pushStage
              GoTo start
            Else
              GoTo NEXTPATTERN
            End If
          End If
              
        ' TBD: almost identical to SKIPPING_IF_BLOCK; could probably clean up
        Case SKIPPING_ELSE_BLOCK:
          
          lineTag = LCase(pattern(0))
          
          If StrComp(lineTag, "_if") = 0 Then
            ifBlock = ifBlock + 1
            GoTo NEXTPATTERN
          End If
          
          If StrComp(lineTag, "_else") = 0 Then
            If ifBlock = 0 Then
              ErrorsString = ErrorsString & "WARNING: misplaced _else: " & Join(pattern) & vbCrLf
              GoTo NEXTPATTERN
            End If
          End If
          
          If StrComp(lineTag, "_endif") = 0 Then
            ifBlock = ifBlock - 1
            If ifBlock = -1 Then
              stage = pushStage
              GoTo start
            Else
              GoTo NEXTPATTERN
            End If
          End If
              
    End Select
NEXTPATTERN:    Loop
    
    If OutGrammars.count < 1 Then
'      If ifBlock > 0 Then
'        PatternMatch = Array("")
'        Exit Function
'      End If
      If PatternParents.Exists(patternName) Then
' set up above now        parentName = PatternParents.item(patternName)
        Set parentCollection = Patterns.item(parentName)  ' we have validated this during parsing
        parentMatch = PatternMatch(parentCollection, wordlist, parentName, childName)
        PatternMatch = parentMatch
        Exit Function
      Else
        ' kludge: fail silently for internal pattern-match calls
        If StrComp(patternName, "p_system_internal_pattern") <> 0 Then
          If StrComp(patternName, childName) = 0 Then
            ErrorsString = ErrorsString & _
              "WARNING: " & patternName & ": Failed to match pattern: " & Join(wordlist) & vbCrLf
          Else
            ErrorsString = ErrorsString & _
              "WARNING: " & childName & ", child of " & patternName & ", failed to match pattern: " & Join(wordlist) & vbCrLf
          End If
        End If
'        Result = wordlist  ' match failed; return original word list
        Result = Array("|e|")  ' match failed; return empty symbol
        PatternMatch = Result
        Exit Function
      End If
    End If
        
    outGrammar = OutGrammars.item(RandomInt(OutGrammars.count))
    
' Just removed: **********
    ' need to fill in variables for the _out pattern
 '   Dim finalWordList() As Variant
'    Dim tempWords6 As New Collection ' make a Collection of the words to be assigned to varName
'    For i = 1 To UBound(outGrammar)  ' skip the "_out" word
'      tempWords6.Add (outGrammar(i))
'    Next
    
'    Dim finalWordList As Variant
'    finalWordList = FillInVariables(tempWords6, Variables)
    
    ' the _out line may still contain _parent and _child method-calls.
    ' we simply replace those keywords with the name of the corresponding
    ' pattern-groups and then call Eval().
    
'    finalWordList = EvalInheritance(finalWordList, parentName, childName)
' End just removed **********


    ' NEW BLOCK:
    newPattern = SubArray(outGrammar, 1, UBound(outGrammar))
    finalWordList = FillInVariables(newPattern, Variables)
    finalWordList = EvalPointers(finalWordList)
    finalWordList = EvalInheritance(finalWordList, parentName, childName)
    finalWordList = Eval(finalWordList)
            
'    If foundCall = True Then
'      finalWordList = Eval(finalWordList)
'    End If
    
    If UBound(finalWordList) < 0 Then
      ErrorsString = ErrorsString & _
        "WARNING: Strange... failed to populate _out line correctly " & Join(wordlist) & vbCrLf & "     OUT LINE: " & Join(outGrammar) & vbCrLf
      Result = wordlist  ' match failed; return original word list
      PatternMatch = Result
    Else
      Result = finalWordList
      PatternMatch = Result
    End If
  
'  ErrorsString = ErrorsString & "Returning match '" & Join(Result) & "'." & vbCrLf
    
End Function

Public Function EvalInheritance(grammar, parentName, childName)

  Dim foundCal As Boolean
  Dim currentWord As Long
  Dim funcCountReturn As Integer
  Dim lastArgWord As Integer
  
  foundCall = False
  currentWord = -1
  Do While currentWord < UBound(grammar)
    currentWord = currentWord + 1
    
    If StrComp(LCase(grammar(currentWord)), "_parent") = 0 Then
        If Patterns.Exists(parentName) Then
          foundCall = True
          grammar(currentWord) = parentName
        End If
    End If
    
    ' It's ok if childName = patternName.  We want to allow a superclass
    ' to call one of its own methods with the _child keyword.  That way,
    ' if a subclass overrides the method, the superclass will be calling the
    ' the new "child" version.  This is how virtual functions work in C++.
    
    If StrComp(LCase(grammar(currentWord)), "_child") = 0 Then
      foundCall = True
      grammar(currentWord) = childName
    End If
    
    If foundCall = True Then
    
      If currentWord < UBound(grammar) Then
              
        ' first evaluate any function calls that follow the pattern-match call
        argument = EvalArg(grammar, currentWord, funcCountReturn)
        
        lastArgWord = currentWord + funcCountReturn + 1
                                                                  
        Set patternCollection = Patterns.item(grammar(currentWord))
        matchedWordListTemp = PatternMatch(patternCollection, argument, grammar(currentWord), childName)
        'TBD: add error for when PatternMatch fails
        
        finalGrammar = Eval(matchedWordListTemp)  ' evaluate any statements returned by the pattern
                 
        If currentWord > 0 Then
          headArray = SubArray(grammar, 0, currentWord - 1)
          finalGrammar = ConcatenateArrays(headArray, finalGrammar)
        End If
      
        If lastArgWord < UBound(grammar) Then
          tailArray = SubArray(grammar, lastArgWord + 1, UBound(grammar))
          finalGrammar = ConcatenateArrays(finalGrammar, tailArray)
        End If
      
        grammar = finalGrammar
        foundCall = False
        currentWord = currentWord - 1   ' re-eval the current word; it has changed

      End If

    End If
    
  Loop

  EvalInheritance = grammar

End Function

Public Function MatchGrammarToPattern(wordlist, pattern, Variables, childName)

'  ErrorsString = ErrorsString & "Matching grammar to pattern.  GRAMMAR: " & Join(wordlist) & vbCrLf & "     PATTERN: " & Join(pattern) & vbCrLf

  MatchGrammarToPattern = False   ' fail by default

  Dim w_iter As Long: Dim p_iter As Long
  Dim patternBound As Long
  Dim wordBound As Long
  Dim p_currentWord As String
  Dim tf As Boolean
  Dim tempArray() As Variant
  Dim varWords() As Variant
  
        w_iter = 0: p_iter = 1  ' don't count the "_in"
        wordBound = UBound(wordlist)
        patternBound = UBound(pattern)
        While p_iter <= patternBound
          
          ' Note that this code is duplicated in the "lookahead" code for the ~ wildcard
          
          p_currentWord = pattern(p_iter)
          
          ' automatically replace any property names with their values
          matchedProperty = False
          propertyVal = GetPatternProperty(childName, p_currentWord)
          propertyVal = EvalPointers(propertyVal)
          If propertyVal(0) <> "" Then
            matchedProperty = True
            p_currentWord = propertyVal(0)
          End If
          
          ' match a subgrammar contained in a property
          If UBound(propertyVal) > 0 Then
            
            subGrammar = propertyVal
            varRoot = pattern(p_iter)  ' the name of a property that contained the grammar
            currentVar = GetUniqueVariable(Variables, varRoot)
              
            Dim w_iter_new As Long
            w_iter_new = w_iter
            tf = MatchSubGrammar(wordlist, w_iter_new, subGrammar, Variables, childName, currentVar)
              
            If tf = True Then
              If w_iter_new <= UBound(wordlist) Then
                w_iter = w_iter_new
                p_iter = p_iter + 1
                GoTo NEXTWILDCARD
              Else ' we matched the whole rest of the sentence
                MatchGrammarToPattern = True
                Exit Function
              End If
            Else
              Exit Function
            End If
          
          End If
          
          ' Check to see if the current word is the name of a word list.
          ' If so, accept the match if any word in the group matches.
          
          If w_iter <= wordBound Then  ' just being extra sure
            
            If PartsOfSpeech.Exists(p_currentWord) Then
              match = InList(p_currentWord, wordlist(w_iter))
              If match <> "" Then
                If matchedProperty = True Then
                  varRoot = pattern(p_iter)  ' the name of a property that contained the name of a wordlist; return value as $<property>n
                Else
                  varRoot = p_currentWord
                End If
                currentVar = GetUniqueVariable(Variables, varRoot)
                ReDim tempArray(0)
                tempArray(0) = wordlist(w_iter)
                Variables.Add currentVar, tempArray
                If w_iter = wordBound And p_iter = patternBound Then  ' the pattern matches
                  MatchGrammarToPattern = True
                  Exit Function
                End If
                If p_iter = patternBound And w_iter < wordBound Then Exit Function
                w_iter = w_iter + 1
                p_iter = p_iter + 1
                GoTo NEXTWILDCARD
              End If
            Exit Function
            
            ElseIf Maps.Exists(p_currentWord) Then
              Set map = Maps.item(p_currentWord)
              If map.Exists(wordlist(w_iter)) Then
                If matchedProperty = True Then
                  varRoot = pattern(p_iter)  ' the name of a property that contained the name of a map; return value as $<property>n
                Else
                  varRoot = p_currentWord
                End If
                currentVar = GetUniqueVariable(Variables, varRoot)
                ReDim tempArray(0)
                tempArray(0) = map.item(wordlist(w_iter))
                Variables.Add currentVar, tempArray
                If w_iter = wordBound And p_iter = patternBound Then  ' the pattern matches
                  MatchGrammarToPattern = True
                  Exit Function
                End If
                If p_iter = patternBound And w_iter < wordBound Then Exit Function
                w_iter = w_iter + 1
                p_iter = p_iter + 1
                GoTo NEXTWILDCARD
              End If
              Exit Function
              
            ElseIf RunTimeGrammars.Exists(p_currentWord) Then
              
              subGrammar = RunTimeGrammars.item(p_currentWord)
              subGrammar = EvalPointers(subGrammar)
                 
              If matchedProperty = True Then
                varRoot = pattern(p_iter)  ' the name of a property that contained the name of a CONST; return value as $<property>n
              Else
                varRoot = p_currentWord
              End If
              
              currentVar = GetUniqueVariable(Variables, varRoot)
              
'              Dim w_iter_new As Long
              w_iter_new = w_iter
              tf = MatchSubGrammar(wordlist, w_iter_new, subGrammar, Variables, childName, currentVar)
              
              If tf = True Then
                If w_iter_new <= UBound(wordlist) Then
                  w_iter = w_iter_new
                  p_iter = p_iter + 1
                  GoTo NEXTWILDCARD
                Else ' we matched the whole rest of the sentence
                  MatchGrammarToPattern = True
                  Exit Function
                End If
              Else
                Exit Function
              End If
            
            ElseIf Grammars.Exists(p_currentWord) Then
              
              Set grammarCollection = Grammars.item(p_currentWord)
              
              If matchedProperty = True Then
                varRoot = pattern(p_iter)  ' the name of a property that contained the name of a CONST; return value as $<property>n
              Else
                varRoot = p_currentWord
              End If
              
              currentVar = GetUniqueVariable(Variables, varRoot)
              
              For Each subGrammar In grammarCollection
                subGrammar = EvalPointers(subGrammar)
                w_iter_new = w_iter
                tf = MatchSubGrammar(wordlist, w_iter_new, subGrammar, Variables, childName, currentVar)
                If tf = True Then
                  If w_iter_new <= UBound(wordlist) Then
                    w_iter = w_iter_new
                    p_iter = p_iter + 1
                    GoTo NEXTWILDCARD
                  Else ' we matched the whole rest of the sentence
                    MatchGrammarToPattern = True
                    Exit Function
                  End If
                End If
              Next subGrammar
              Exit Function
            End If
          End If
          
          firstChar = Left(p_currentWord, 1)
          Select Case firstChar
            Case "$"
              currentVar = p_currentWord
              If w_iter > wordBound Then  ' just in case; $ means there *must* be a word in wordlist
                Exit Function
              End If
              ReDim tempArray(0)
              tempArray(0) = wordlist(w_iter)
              Variables.Add currentVar, tempArray
              If w_iter = wordBound And p_iter = patternBound Then  ' pattern matches
                  MatchGrammarToPattern = True
                  Exit Function
              End If
              If p_iter = patternBound And w_iter < wordBound Then Exit Function
              w_iter = w_iter + 1
              p_iter = p_iter + 1
            Case "~"
              currentVar = p_currentWord
              varStartWord = w_iter   ' keep track of boundary that this var represents
              p_iter = p_iter + 1  ' skip wildcard
                     
              If p_iter > patternBound Then
                If varStartWord <= wordBound Then  ' bind the ~ variable to the rest of the line
                  ReDim varWords(wordBound - varStartWord)
                  Dim v As Integer: v = -1
                  For w = varStartWord To wordBound
                    v = v + 1
                    varWords(v) = wordlist(w)
                  Next
                  Variables.Add currentVar, varWords
                Else
                  Variables.Add currentVar, Array("|e|")
                End If
                MatchGrammarToPattern = True
                Exit Function
              End If
            
              If w_iter > wordBound Then  ' pattern has additional words beyond length of wordlist
                Exit Function
              End If
    
              ' we know there will be an immediate match
              If Left(pattern(p_iter), 1) = "~" Or Left(pattern(p_iter), 1) = "$" Then
                GoTo NEXTWILDCARD
              End If
              
              ' this code is duplicated from the main loop; lets us bind values we might
              ' discover by looking ahead.
              
              p_currentWord = pattern(p_iter)
          
              ' automatically replace any property names with their values
              matchedProperty = False
              propertyVal = GetPatternProperty(childName, p_currentWord)
              propertyVal = EvalPointers(propertyVal)
              If propertyVal(0) <> "" Then
                matchedProperty = True
                p_currentWord = propertyVal(0)  ' TBD: a little odd; not used if UBound(propertyVal) > 0
              End If
              
              If UBound(propertyVal) > 0 Then
                ' look ahead for a subgrammar contained in a property
              
                subGrammar = propertyVal
                varRoot2 = pattern(p_iter)  ' the name of the property
                currentVar2 = GetUniqueVariable(Variables, varRoot2) ' var for a CONST match
              
                Dim w_lookahead As Long
                For i = w_iter To wordBound
                  w_lookahead = i
                  tf = MatchSubGrammar(wordlist, w_lookahead, subGrammar, Variables, childName, currentVar2)
                  If tf = True Then
                  
                    ' bind the ~ variable
                    
                    If varStartWord <= wordBound And i > w_iter Then
                      Call BindTilde(wordlist, varStartWord, i, Variables, currentVar)
                    Else
                      Variables.Add currentVar, Array("")  ' need null value so that _out lines won't print variable names
                    End If
                    
                    ' accept the match we found; don't re-do work.
                    ' remember that w_lookahead gets incremented by MatchSubGrammar()
                    
                    If w_lookahead <= UBound(wordlist) Then
                      w_iter = w_lookahead
                      p_iter = p_iter + 1
                      GoTo NEXTWILDCARD
                    Else ' we matched the whole rest of the sentence
                      MatchGrammarToPattern = True
                      Exit Function
                    End If
                  End If
                Next
                Exit Function
'              ElseIf matchedProperty = True Then  ' property contains a word
'                pattern(p_iter) = propertyVal(0)
              End If
                            
              ' for wordlist wildcards, look ahead to see if there will be a match
              If PartsOfSpeech.Exists(p_currentWord) Then
                wordListName = p_currentWord
                For i = w_iter To wordBound
                  match = InList(wordListName, wordlist(i))
                  If match <> "" Then
                    
'                    If matchedProperty = True Then
                      varRoot2 = pattern(p_iter)  ' the name of a property that contained the name of a wordlist; return value as $<property>n
'                    Else
'                      varRoot2 = p_currentWord
'                    End If
                    currentVar2 = GetUniqueVariable(Variables, varRoot2)
                    
                    ' bind the ~ variable
                    If varStartWord <= wordBound And i > w_iter Then
                      Call BindTilde(wordlist, varStartWord, i, Variables, currentVar)
                    Else
                      Variables.Add currentVar, Array("")  ' need null value so that _out lines won't print variable names
                    End If
                    
                    w_iter = i
                    
                    ' bind a variable to the match we found by looking ahead
                    
                    ReDim tempArray(0)
                    tempArray(0) = wordlist(w_iter)
                    Variables.Add currentVar2, tempArray
                    If w_iter = wordBound And p_iter = patternBound Then  ' the pattern matches
                      MatchGrammarToPattern = True
                      Exit Function
                    End If
                
                    If p_iter = patternBound And w_iter < wordBound Then Exit Function
                    
                    w_iter = w_iter + 1
                    p_iter = p_iter + 1
                    GoTo NEXTWILDCARD
                  
                  End If
                Next
                Exit Function
              End If
              
              ' for map wildcards, look ahead to see if there will be a match
              If Maps.Exists(p_currentWord) Then
                Set theMap = Maps.item(p_currentWord)
                For i = w_iter To wordBound
                  If theMap.Exists(wordlist(i)) Then
                    
'                    If matchedProperty = True Then
                      varRoot2 = pattern(p_iter)  ' the name of a property that contained the name of a map; return value as $<property>n
'                     Else
'                      varRoot2 = p_currentWord
'                    End If
                    currentVar2 = GetUniqueVariable(Variables, varRoot2)
                    
                    ' bind the ~ variable
                    If varStartWord <= wordBound And i > w_iter Then
                      Call BindTilde(wordlist, varStartWord, i, Variables, currentVar)
                    Else
                      Variables.Add currentVar, Array("")  ' need null value so that _out lines won't print variable names
                    End If
                                        
                    w_iter = i
                    
                    ' bind a variable to the match we found by looking ahead
                    
                    ReDim tempArray(0)
                    tempArray(0) = theMap.item(wordlist(w_iter))
                
                    Variables.Add currentVar2, tempArray
                    If w_iter = wordBound And p_iter = patternBound Then  ' the pattern matches
                      MatchGrammarToPattern = True
                      Exit Function
                    End If
                    
                    If p_iter = patternBound And w_iter < wordBound Then Exit Function
                    
                    w_iter = w_iter + 1
                    p_iter = p_iter + 1
                    GoTo NEXTWILDCARD
                  
                  End If
                Next
                Exit Function
              End If
              
              ' for CONST wildcards, look ahead to see if there will be a match
              If RunTimeGrammars.Exists(p_currentWord) Then
                
                subGrammar = RunTimeGrammars.item(p_currentWord)
                subGrammar = EvalPointers(subGrammar)
                 
'                If matchedProperty = True Then
                  varRoot2 = pattern(p_iter)  ' the name of a property that contained the name of a CONST; return value as $<property>n
'                Else
'                  varRoot2 = p_currentWord
'                End If
              
                currentVar2 = GetUniqueVariable(Variables, varRoot2) ' var for a CONST match
              
                ' Dim w_lookahead As Long
                For i = w_iter To wordBound
                  w_lookahead = i
                  tf = MatchSubGrammar(wordlist, w_lookahead, subGrammar, Variables, childName, currentVar2)
                  If tf = True Then
                  
                    ' bind the ~ variable
                    
                    If varStartWord <= wordBound And i > w_iter Then
                      Call BindTilde(wordlist, varStartWord, i, Variables, currentVar)
                    Else
                      Variables.Add currentVar, Array("")  ' need null value so that _out lines won't print variable names
                    End If
                    
                    ' accept the match we found; don't re-do work.
                    ' remember that w_lookahead gets incremented by MatchSubGrammar()
                    
                    If w_lookahead <= UBound(wordlist) Then
                      w_iter = w_lookahead
                      p_iter = p_iter + 1
                      GoTo NEXTWILDCARD
                    Else ' we matched the whole rest of the sentence
                      MatchGrammarToPattern = True
                      Exit Function
                    End If
                  End If
                Next
                Exit Function
              End If
              
              ' for grammar wildcards, look ahead to see if there will be a match
              If Grammars.Exists(p_currentWord) Then
                
                Set grammarCollection = Grammars.item(p_currentWord)
'                If matchedProperty = True Then
                  varRoot2 = pattern(p_iter)  ' the name of a property that contained the name of a CONST; return value as $<property>n
'                Else
'                  varRoot2 = p_currentWord
'                End If
                currentVar2 = GetUniqueVariable(Variables, varRoot2) ' var for a CONST match
              
                For Each subGrammar In grammarCollection
                  subGrammar = EvalPointers(subGrammar)
                  For i = w_iter To wordBound
                    w_lookahead = i
                    tf = MatchSubGrammar(wordlist, w_lookahead, subGrammar, Variables, childName, currentVar2)
                    If tf = True Then
                      ' bind the ~ variable
                      If varStartWord <= wordBound And i > w_iter Then
                        Call BindTilde(wordlist, varStartWord, i, Variables, currentVar)
                      Else
                        Variables.Add currentVar, Array("")  ' need null value so that _out lines won't print variable names
                      End If
                      ' accept the match we found; don't re-do work.
                      ' remember that w_lookahead gets incremented by MatchSubGrammar()
                      If w_lookahead <= UBound(wordlist) Then
                        w_iter = w_lookahead
                        p_iter = p_iter + 1
                        GoTo NEXTWILDCARD
                      Else ' we matched the whole rest of the sentence
                        MatchGrammarToPattern = True
                        Exit Function
                      End If
                    End If
                  Next i
                Next subGrammar
                Exit Function
              End If
              
              For i = w_iter To wordBound
'                If StrComp(UCase(pattern(p_iter)), UCase(wordlist(i))) = 0 Then
                If UCase(wordlist(i)) Like UCase(p_currentWord) Then  ' allow VB-style wildcards
                  If varStartWord <= wordBound And i > w_iter Then  ' bind the * variable
                    Dim varWords2() As Variant
                    ReDim varWords2(i - varStartWord - 1)
                    v = -1
                    For w = varStartWord To (i - 1)
                      v = v + 1
                      varWords2(v) = wordlist(w)
                    Next
                    Variables.Add currentVar, varWords2
                  Else
                    Variables.Add currentVar, Array("")
                  End If
                  
                  w_iter = i
                  GoTo NEXTWILDCARD
                                                 
                End If
                
              Next
              Exit Function
    '        p_iter = patternBound + 1  ' hack to bail out of loop; match has failed
            
            Case Else  ' we aren't dealing with a variable
            
              If w_iter > wordBound Then  ' pattern has additional words beyond length of wordlist
                Exit Function
              End If
            
'              If StrComp(UCase(p_currentWord), UCase(wordlist(w_iter))) = 0 Then
              If UCase(wordlist(w_iter)) Like UCase(p_currentWord) Then  ' allow VB-style wildcards
                  w_iter = w_iter + 1: p_iter = p_iter + 1
                  If w_iter > wordBound Then
                    If p_iter > patternBound Then
                      MatchGrammarToPattern = True
                      Exit Function
                    End If
                  End If
              Else
                ' if the pattern doesn't match (above), move on to the next pattern
                Exit Function
              End If
          
          End Select
NEXTWILDCARD: Wend

End Function

Public Function MatchSubGrammar(wordlist As Variant, w_iter As Long, subGrammar As Variant, Variables As Variant, childName As Variant, currentVar As Variant)
              
  MatchSubGrammar = False
  
  Dim discardVariables
  Set discardVariables = CreateObject("Scripting.Dictionary")
              
  ' newPattern will be the grammar we want to match on a sub-array
  ' of wordlist.
  Dim newPattern()
  ReDim newPattern(0)
  ReDim newPattern(UBound(subGrammar) + 2)  ' "_in <grammar> ~wildcard"
  For i = 0 To (UBound(subGrammar))
    newPattern(i + 1) = subGrammar(i)
  Next i
  ' match a grammar that is a substring of wordlist
  newPattern(0) = "_in"  ' TBD: kind of hacky to be doing this
  newPattern(UBound(newPattern)) = "~s_system_ooga_ooga_4256"
'ReDim Preserve grammar(count)
  Dim newWordList()
  ReDim newWordList(0)
  ReDim newWordList(UBound(wordlist) - w_iter)
  For i = w_iter To UBound(wordlist)
    newWordList(i - w_iter) = wordlist(i)
  Next i
  discardVariables.RemoveAll
  tf = MatchGrammarToPattern(newWordList, newPattern, discardVariables, childName)
  If tf = True Then
    If discardVariables.Exists("~s_system_ooga_ooga_4256") Then
      unmatchedWords = discardVariables.item("~s_system_ooga_ooga_4256")
    Else
      unmatchedWords = Array("")
    End If
    
    ' if the sub-grammar ends with a ~ wildcard, we match the whole sentence.
    ' ignore the fact that ~s_system_ooga_ooga_4256 got bound to the words that
    ' would have been given to the other ~ wildcard.
    
    lastWord = newPattern(UBound(newPattern) - 1)
    If StrComp(Left(lastWord, 1), "~") = 0 Then
      unmatchedWords = Array("")
    End If
    
    unmatchedCount = UBound(unmatchedWords) + 1
    If StrComp(unmatchedWords(0), "") = 0 Then unmatchedCount = 0
    matchedGrammar = SubArray(wordlist, w_iter, UBound(wordlist) - unmatchedCount)
                
    ' TBD: maybe this is a kludge.  just making sure a null match gets stored as |e|
    If UBound(matchedGrammer) = 1 And StrComp(matchedGrammer(0), "") = 0 Then
       matchedGrammer(0) = "|e|"
    End If
    
    ' add match to Variables
                
    Variables.Add currentVar, matchedGrammar

    If unmatchedCount > 0 Then
      w_iter = UBound(wordlist) - unmatchedCount + 1
      MatchSubGrammar = True
      Exit Function
    Else ' we matched the whole rest of the sentence
      w_iter = UBound(wordlist) + 1   ' no more matching...
      MatchSubGrammar = True
      Exit Function
    End If
              
  Else
    Exit Function   ' failed match
  End If
            
End Function

Public Function GetUniqueVariable(Variables, varRoot)
              
  GetUniqueVariable = "temp"
  For i = 1 To 20  ' find a unique name to store a value in
    testVar = "$" & varRoot & i
    If Not Variables.Exists(testVar) Then
      GetUniqueVariable = testVar
      Exit For
    End If
  Next

End Function

' bind the tilde variable; called from PatternMatch
Public Sub BindTilde(wordlist, varStartWord, i, Variables, currentVar)

  Dim varWordsTemp()
  
  ReDim varWordsTemp(i - varStartWord - 1)
  v = -1
  For w = varStartWord To (i - 1)
    v = v + 1
    varWordsTemp(v) = wordlist(w)
  Next
  Variables.Add currentVar, varWordsTemp

End Sub
' evaluates a conditional.
' any kind of syntax error simply causes the routine to return false.
Public Function EvalConditional(grammar As Variant, parentName As Variant, childName As Variant) As Variant
  Dim opLoc As Long
  Dim notLoc As Long
  Dim patternGroup As New Collection
  Dim funcCountReturn As Long
  Dim tf As Boolean
  Dim tfTemp As Boolean
  Dim currentOp As LogicalOps
  Dim i As Long
  
  EvalConditional = False  ' default
  tf = False  ' working value
  notFlag = False
  begunEval = False
  
  Dim curStart As Integer: curStart = 0
  Dim nests As Integer: nests = 0
  Dim segments As New Collection
  Dim logicals As New Collection
  Dim truths As New Collection
  
  ' find the big top-level logical breaks (&& and ||) and subdivide the problem
  
  For x = 0 To UBound(grammar)
    If StrComp(grammar(x), "&&") = 0 Or StrComp(grammar(x), "||") = 0 Then
      If nests = 0 Then
        If x < 1 Then
          ErrorsString = ErrorsString & "ERROR: badly formed conditional: " & Join(grammar) & vbCrLf
          EvalConditional = False
          Exit Function
        End If
        segments.Add (SubArray(grammar, curStart, x - 1))
        If StrComp(grammar(x), "&&") = 0 Then   ' TBD: inefficient
          logicals.Add (L_AND)
        Else
          logicals.Add (L_OR)
        End If
        curStart = x + 1
      End If
    End If
    If StrComp(grammar(x), "{") = 0 Then
      nests = nests + 1
    ElseIf StrComp(grammar(x), "}") = 0 Then
      nests = nests - 1
      If nests < 0 Then  ' syntax error
        ErrorsString = ErrorsString & "ERROR: badly formed conditional: " & Join(grammar) & vbCrLf
        EvalConditional = False
        Exit Function
      End If
    End If
  Next
  
  If nests <> 0 Or curStart > UBound(grammar) Then
    ErrorsString = ErrorsString & "ERROR: badly formed conditional: " & Join(grammar) & vbCrLf
    EvalConditional = False
    Exit Function
  End If

  segments.Add (SubArray(grammar, curStart, UBound(grammar)))
  logicals.Add (L_NIL)
  
  If segments.count > 1 Then
    For Each seg In segments
      tfTemp = EvalConditional(seg, parentName, childName)
      truths.Add (tfTemp)
    Next
    tf = False
    i = 0
    currentOp = L_NIL
    For Each t In truths
      i = i + 1
      Select Case currentOp
        Case L_NIL
          tf = t
          currentOp = logicals.item(i)
        Case L_AND
          If tf = False Or t = False Then
            tf = False
          Else
            tf = True
          End If
          currentOp = logicals.item(i)
        Case L_OR
          If tf = True Or t = True Then
            tf = True
          Else
            tf = False
          End If
          currentOp = logicals.item(i)
      End Select
    Next
    EvalConditional = tf
    Exit Function
  End If
  
  ' at this point, we know that we're merely calculating the T/F value of one segment.
  ' However, that segment might contain sub-segments inside {}.
        
  nests = 0
  opLoc = 0
  notLoc = 0
  For x = 0 To UBound(grammar)
    If StrComp(grammar(x), "=") = 0 Or StrComp(grammar(x), "~=") = 0 Or StrComp(grammar(x), "=~") = 0 Then
      If nests = 0 Then
        If x < 1 Or opLoc > 0 Then  ' multiple comparisons is a syntax error
          ErrorsString = ErrorsString & "ERROR: badly formed conditional: " & Join(grammar) & vbCrLf
          EvalConditional = False
          Exit Function
        End If
        opLoc = x
      End If
    End If
    If StrComp(grammar(x), "^") = 0 Then   ' a NOT operator
      If nests = 0 Then
        If x < 1 Then
          ErrorsString = ErrorsString & "ERROR: badly formed conditional: " & Join(grammar) & vbCrLf
          EvalConditional = False
          Exit Function
        End If
        notLoc = x
      End If
    End If
    If StrComp(grammar(x), "{") = 0 Then
      nests = nests + 1
    ElseIf StrComp(grammar(x), "}") = 0 Then
      nests = nests - 1
      If nests < 0 Then  ' syntax error
        ErrorsString = ErrorsString & "ERROR: badly formed conditional: " & Join(grammar) & vbCrLf
        EvalConditional = False
        Exit Function
      End If
    End If
  Next
  
  If nests <> 0 Then
    ErrorsString = ErrorsString & "ERROR: badly formed conditional: " & Join(grammar) & vbCrLf
    EvalConditional = False
    Exit Function
  End If

  ' potentially, the whole comparison is contained in braces
  If opLoc < 1 Then
    If UBound(grammar) > 1 Then
      If StrComp(grammar(0), "{") = 0 And StrComp(grammar(UBound(grammar)), "}") = 0 Then
        tf = EvalConditional(SubArray(grammar, 1, UBound(grammar) - 1), parentName, childName)
        EvalConditional = tf
        Exit Function
      End If
    End If
    ' allow functions that return _true/_false
    finalGrammar = Eval(grammar)
    If StrComp(LCase(Join(finalGrammar)), "_true") = 0 Then
      EvalConditional = True
    Else
      EvalConditional = False
    End If
    Exit Function
  End If
      
  ' we know opLoc >= 1
  If (opLoc >= UBound(grammar) Or notLoc >= opLoc) Or (notLoc > 0 And notLoc < opLoc - 1) Then
    ErrorsString = ErrorsString & "ERROR: badly formed conditional: " & Join(grammar) & vbCrLf
    EvalConditional = False
    Exit Function
  End If
  
  If notLoc = 0 Then
    leftArg = EvalInheritance(SubArray(grammar, 0, opLoc - 1), parentName, childName)
  Else
    leftArg = EvalInheritance(SubArray(grammar, 0, notLoc - 1), parentName, childName)
  End If
  rightArg = EvalInheritance(SubArray(grammar, opLoc + 1, UBound(grammar)), parentName, childName)
  op = grammar(opLoc)
  
  ' note that we use our own pattern-matching machinery to evaluate a conditional
  Select Case op
    Case "="   ' equivalence
      inPattern = ConcatenateArrays(Array("_in"), leftArg)
      outPattern = Array("_out", "_true")
      patternGroup.Add (inPattern)
      patternGroup.Add (outPattern)
      tfArray = PatternMatch(patternGroup, rightArg, "p_system_internal_pattern", "p_system_internal_pattern")
      If StrComp(tfArray(0), "_true") = 0 Then
        If notLoc > 0 Then
          EvalConditional = False
        Else
          EvalConditional = True
        End If
      Else
        If notLoc > 0 Then
          EvalConditional = True
        Else
          EvalConditional = False
        End If
      End If
      
    Case "~="  ' left contained in right
      inPattern = ConcatenateArrays(Array("_in", "~a"), leftArg)
      inPattern = ConcatenateArrays(inPattern, "~b")
      outPattern = Array("_out", "_true")
      patternGroup.Add (inPattern)
      patternGroup.Add (outPattern)
      tfArray = PatternMatch(patternGroup, rightArg, "p_system_internal_pattern", "p_system_internal_pattern")
      If StrComp(tfArray(0), "_true") = 0 Then
        If notLoc > 0 Then
          EvalConditional = False
        Else
          EvalConditional = True
        End If
      Else
        If notLoc > 0 Then
          EvalConditional = True
        Else
          EvalConditional = False
        End If
      End If
    
    Case "=~"  ' right contained in left
      inPattern = ConcatenateArrays(Array("_in", "~a"), rightArg)
      inPattern = ConcatenateArrays(inPattern, "~b")
      outPattern = Array("_out", "_true")
      patternGroup.Add (inPattern)
      patternGroup.Add (outPattern)
      tfArray = PatternMatch(patternGroup, leftArg, "p_system_internal_pattern", "p_system_internal_pattern")
      If StrComp(tfArray(0), "_true") = 0 Then
        If notLoc > 0 Then
          EvalConditional = False
        Else
          EvalConditional = True
        End If
      Else
        If notLoc > 0 Then
          EvalConditional = True
        Else
          EvalConditional = False
        End If
      End If
  
  End Select
  
End Function

Public Function FillInVariables(grammar As Variant, Variables As Variant) As Variant
    
    If IsEmpty(Variables) Then
      FillInVariables = grammar
      Exit Function
    End If
    
    Dim finalWordList() As Variant
    Dim finalWordCount As Integer: finalWordCount = -1
    For Each word In grammar
'      firstChar = Left(word, 1)
'      Select Case firstChar
'        Case "~", "$"  ' it's a variable; look up the words it matched with
          If Variables.Exists(word) Then
            varWordList = Variables.item(word)
            If varWordList(0) <> "" Then
              varWordCount = UBound(varWordList) + 1
              If varWordCount < 1 Then GoTo NEXTWORD
              finalWordCount = finalWordCount + varWordCount
              ReDim Preserve finalWordList(finalWordCount)
              Dim j As Integer: j = -1
              For k = (finalWordCount - varWordCount + 1) To finalWordCount
                j = j + 1
                finalWordList(k) = varWordList(j)
              Next
            End If
          Else
'        Case Else  ' just add the word
            finalWordCount = finalWordCount + 1
            ReDim Preserve finalWordList(finalWordCount)
            finalWordList(finalWordCount) = word
'      End Select
          End If
NEXTWORD:    Next word

  FillInVariables = finalWordList
  
End Function
' this routine does some post-processing to pretty up the story text
Public Function FixStory(story As String)
  
  Dim Result As String

  ' capitalize first letter of story
  If Left(story, 1) = " " Then
    Result = "|c|" & Mid(story, 2, Len(story) - 1)  ' delete first character, usually a space
  Else
    Result = "|c|" & story
  End If

'  If Left(story, 1) = " " Then
'    Result = Mid(story, 2, Len(story) - 1)  ' delete first character, usually a space
'  Else
'    Result = story
'  End If

  ' empty character
  Result = replace(Result, "|e|", "")
  
  ' newline character
  Result = replace(Result, "|n|", vbCrLf)
  
  ' We first remove all spaces that surround punctuation, then we resolve
  ' conflicts between different punctuation symbols, and finally we put
  ' some spaces back for readability.
  
  While (InStr(Result, " ,") > 0)
    Result = replace(Result, " ,", ",")
  Wend
  
  While (InStr(Result, ", ") > 0)
    Result = replace(Result, ", ", ",")
  Wend
  
  While (InStr(Result, " ;") > 0)
    Result = replace(Result, " ;", ";")
  Wend
  
  While (InStr(Result, "; ") > 0)
    Result = replace(Result, "; ", ";")
  Wend
  
  While (InStr(Result, " .") > 0)
    Result = replace(Result, " .", ".")
  Wend
  
  While (InStr(Result, ". ") > 0)
    Result = replace(Result, ". ", ".")
  Wend
  
  While (InStr(Result, " !") > 0)
    Result = replace(Result, " !", "!")
  Wend
  
  While (InStr(Result, "! ") > 0)
    Result = replace(Result, "! ", "!")
  Wend
  
  While (InStr(Result, " ?") > 0)
    Result = replace(Result, " ?", "?")
  Wend
  
  While (InStr(Result, "? ") > 0)
    Result = replace(Result, "? ", "?")
  Wend
  
  While (InStr(Result, " )") > 0)
    Result = replace(Result, " )", ")")
  Wend
  
  While (InStr(Result, ") ") > 0)
    Result = replace(Result, ") ", ")")
  Wend
  
  While (InStr(Result, " (") > 0)
    Result = replace(Result, " (", "(")
  Wend
  
  While (InStr(Result, "( ") > 0)
    Result = replace(Result, "( ", "(")
  Wend
  
  While (InStr(Result, " --") > 0)
    Result = replace(Result, " --", "--")
  Wend
  
  While (InStr(Result, "-- ") > 0)
    Result = replace(Result, "-- ", "--")
  Wend
  
  While (InStr(Result, ",,") > 0) ' remove double commas
    Result = replace(Result, ",,", ",")
  Wend
  
  While (InStr(Result, ";;") > 0) ' remove double semicolons
    Result = replace(Result, ";;", ";")
  Wend
  
  While (InStr(Result, "----") > 0) ' remove double dashes
    Result = replace(Result, "----", "--")
  Wend
  
  ' brute-force kludge: run through the rock-paper-scissors suite
 ' twice to catch cases where a large group of punctuation
 ' has collapsed into a smaller one but hasn't yet resolved to a winner.
  
  For k = 1 To 2
    Result = replace(Result, ";,", ";")  ' semicolon beats comma
    Result = replace(Result, ",;", ";")  ' semicolon beats comma
    Result = replace(Result, ",--", "--")  ' dash beats comma
    Result = replace(Result, "--,", "--")  ' dash beats comma
    Result = replace(Result, ";--", "--")  ' dash beats semicolon
    Result = replace(Result, "--;", "--")  ' dash beats semicolon
    Result = replace(Result, ",(", "(")  ' paren beats comma
    Result = replace(Result, "(,", "(")  ' paren beats comma
    Result = replace(Result, ";(", "(")  ' paren beats semicolon
    Result = replace(Result, "(;", "(")  ' paren beats semicolon
    Result = replace(Result, ",)", ")")  ' paren beats comma
    Result = replace(Result, "),", ")")  ' paren beats comma
    Result = replace(Result, ";)", ")")  ' paren beats semicolon
    Result = replace(Result, ");", ")")  ' paren beats semicolon
    Result = replace(Result, ",.", ".")  ' period beats comma
    Result = replace(Result, ".,", ".")  ' period beats comma
    Result = replace(Result, ";.", ".")  ' period beats semicolon
    Result = replace(Result, ".;", ".")  ' period beats semicolon
    Result = replace(Result, "--.", ".")  ' period beats dash
    Result = replace(Result, ".--", ".")  ' period beats dash
  Next
  
 
  ' put back correct spacing
  Result = replace(Result, ".", ".  |c|")
  Result = replace(Result, "!", "!  |c|")
  Result = replace(Result, "?", "?  |c|")
  Result = replace(Result, ",", ", ")
  Result = replace(Result, ";", "; ")
  Result = replace(Result, "--", " -- ")
 
 ' no extra space at the beginning of a paragraph
  Result = replace(Result, vbCrLf & " ", vbCrLf)
  Result = replace(Result, vbCrLf & " ", vbCrLf)
  
'  Result = Replace(Result, ","" ", ", """)  ' reformat leading quotation mark
'  Result = Replace(Result, ". """, ".""")  ' keep ending quotes snug with punctuation
      
   ' start quote
  Result = replace(Result, "|qs| ", "|qs|")
  Result = replace(Result, "|qs|", """")
    
   ' end quote
  Result = replace(Result, " |qe|", "|qe|")
  Result = replace(Result, " |qe|", "|qe|")
  Result = replace(Result, "|c||qe|", "|qe||c|")
  Result = replace(Result, ".  |qe|", ".|qe|")
  Result = replace(Result, ". |qe|", ".|qe|")
  Result = replace(Result, "!  |qe|", "!|qe|")
  Result = replace(Result, "! |qe|", "!|qe|")
  Result = replace(Result, "?  |qe|", "?|qe|")
  Result = replace(Result, "? |qe|", "?|qe|")
  Result = replace(Result, "|qe|", """")
  
'  Result = Replace(Result, " ,", ",")  ' get rid of spaces before commas
 
  ' use "an" when the next word starts with a vowel
  ' this is kind of a kludge
  
  Result = replace(Result, " a a", " an a")
  Result = replace(Result, " a A", " an A")
  Result = replace(Result, " a e", " an e")
  Result = replace(Result, " a E", " an E")
  Result = replace(Result, " a i", " an i")
  Result = replace(Result, " a I", " an I")
  Result = replace(Result, " a o", " an o")
  Result = replace(Result, " a O", " an O")
  Result = replace(Result, " a u", " an u")
  Result = replace(Result, " a U", " an U")
'  Result = Replace(Result, " a h", " an h")
'  Result = Replace(Result, " a H", " an H")
 
  ' Here we capitalize the first letter that follows any "|c|" occurring in
  ' the text.

  ' First we make sure that all |c| tags are flush up against the character to
  ' be capitalized.  We remove as many as two trailing spaces, plus we kill any
  ' commas that have ended up at (most likely) the start of the sentence.
  
  Result = replace(Result, "|c| ", " |c|")
  Result = replace(Result, "|c| ", " |c|")

  Result = replace(Result, "|c|,", "|c|")
  Result = replace(Result, "|c|,", "|c|")

  Result = replace(Result, "|c| ", " |c|")
  Result = replace(Result, "|c| ", " |c|")

  capPos = InStr(Result, "|c|")
  While capPos > 0  ' every time we find a tag...
    searchString = Mid(Result, capPos, 4)  ' the tag plus the character, what we want to REPLACE (Example: "|c|a")
    replaceString = UCase(Mid(Result, capPos + 3, 1)) ' the capitalized character.
    Result = replace(Result, searchString, replaceString, 1, 1)  ' only replace ONCE
    capPos = InStr(Result, "|c|")  ' see if there's another |c| tag.
  Wend

  ' tab character
'  Result = replace(Result, "|t|", vbTab)
  Result = replace(Result, "|t| ", "|t|")
  Result = replace(Result, "|t| ", "|t|")
'  Result = replace(Result, " |t| ", "|t|")
'  Result = replace(Result, " |t| ", "|t|")
  Result = replace(Result, "|t|", "     ")
  
  Result = replace(Result, ".  .  .", "...")
  Result = replace(Result, ". . .", "...")
  
  ' return the modified story
  
  FixStory = Result
  
End Function

Public Function ConjugateVerb(verb As Variant, tense As Long)
  
  Dim Result As String
  
  If Verbs.Exists(verb) Then
    verbList = Verbs.item(verb)
    Result = verbList(tense)
  Else
    
    Select Case tense
      Case INFINITIVE:
        Result = "to " & verb
      Case ROOT:
        Result = verb
      Case FIRST_PRESENT, SECOND_PRESENT, PLURAL_PRESENT:
        Result = verb
      Case THIRD_PRESENT:
        lastChar = Right(verb, 1)
        Select Case lastChar
          Case "y":
            Result = Left(verb, Len(verb) - 1) & "ies"
          Case Else
            Result = verb & "s"
        End Select
      Case FIRST_PAST, SECOND_PAST, THIRD_PAST, PLURAL_PAST, PAST_PERFECT:
        lastChar = Right(verb, 1)
        Select Case lastChar
          Case "y":
            Result = Left(verb, Len(verb) - 1) & "ied"
          Case "e":
            Result = verb & "d"
          Case Else
            If verb Like "*[!aeiou][aeiou][bdfgklmnprstz]" Then
              Result = verb & lastChar & "ed"
            Else
              Result = verb & "ed"
            End If
        End Select
      Case PARTICIPLE:
        lastChar = Right(verb, 1)
        Select Case lastChar
          Case "e":
            Result = Left(verb, Len(verb) - 1) & "ing"
          Case Else
            If verb Like "*[!aeiou][aeiou][!aeiou]" Then
              Result = verb & lastChar & "ing"
            Else
              Result = verb & "ing"
            End If
        End Select
      Case Else
        ErrorsString = ErrorsString & _
          "WARNING: failed to conjugate verb '" & verb & "'.  Original word will remain unchanged." & vbCrLf
          Result = ""
    End Select
    
  End If
  
  ConjugateVerb = Result
  
End Function

' returns whether a word is in a given list
Public Function InList(listName As Variant, targetWord As Variant) As Variant
    
    Result = ""
    
    If PartsOfSpeech.Exists(listName) Then
      Set words = PartsOfSpeech.item(listName) ' get the collection of words specified by wordType
      For Each word In words
        If StrComp(UCase(word), UCase(targetWord)) = 0 Then
          Result = targetWord
          Exit For
        End If
      Next
    End If
      
    InList = Result
    
End Function
' returns whether a word is in a given expression (list, word, map; etc.)
Public Function Equiv(targetWord As Variant, objName As Variant) As Variant
    
'    targetWord = Replace(targetWordArg, "_", " ")
 '   objName = Replace(objNameArg, "_", " ")
    
    Result = False
    
    If PartsOfSpeech.Exists(objName) Then
      If InList(objName, targetWord) <> "" Then Result = True
    ElseIf Maps.Exists(objName) Then
      map = Maps.item(objName)
      If map.Exists(targetWord) Then Result = True
    ElseIf RunTimeGrammars.Exists(objName) Then  ' if there's a CONST value by this name...
      newWordList = RunTimeGrammars.item(objName) ' CONST values can change (ha!).  PatternsGroup commands can make them into higher-level grammars
      finalGrammar = Eval(newWordList)
      If UBound(finalGrammar) >= 0 Then  ' only match single words
        finalString = Join(finalGrammar)
        If StrComp(targetWord, finalString) = 0 Then Result = True
      End If
    Else  ' we're dealing with two words
      If StrComp(targetWord, objName) = 0 Then Result = True
    End If
      
    Equiv = Result
    
End Function

' returns a random integer between 1 and maxInt.  Note that in Visual Basic,
' to return a value from a function, you set the name of the function equal
' to the value.

Public Function RandomInt(maxInt As Integer)
  RandomInt = CInt((Rnd * (maxInt - 1))) + 1
End Function

'Public Function GetNextLine(f As Variant)
'
'  Dim s As String
'  s = ""
'
'  tf = True
'  While tf
'    s = s & f.ReadLine
'    If InStr(s, "\") > 0 Then
'      s = replace(s, "\", "")
'      s = replace(s, vbCrLf, "")
'      s = replace(s, vbCr, "")
'      s = replace(s, vbLf, "")
'    Else
'      tf = False
'    End If
'  Wend
'
'  ' Don't split up punctuation for INCLUDE lines.
'
'  words = Split(s)
'  If UBound(words) >= 0 Then
'    firstWord = UCase(words(0))
'    If StrComp(firstWord, "INCLUDE") = 0 Then
'      GetNextLine = CleanString(s)  ' get rid of extra spaces
'      Exit Function
'    End If
'  End If
'
'      ' We decide how to continue parsing based on the first word on the line
'
'      ' Make sure that braces and other special characters are separated
'  ' by whitespace and read as separate tokens
'
'  s = replace(s, "{", " { ")
'  s = replace(s, "}", " } ")
'  s = replace(s, ".", " . ")
'  s = replace(s, ",", " , ")
'  s = replace(s, ";", " ; ")
'  s = replace(s, "--", " -- ")
'  s = replace(s, ")", " ) ")
'  s = replace(s, "(", " ( ")
'  s = replace(s, "?", " ? ")
'  s = replace(s, "!", " ! ")
'  s = replace(s, "=", " = ")
'  s = replace(s, "=~", " =~ ")
'  s = replace(s, "~=", " ~= ")
'  s = replace(s, "`", " ` ")
'
' ' special parsing of C++ style property references (var->property).
'  s = replace(s, "->", ">")
'  s = replace(s, ">", " >")
'
'  s = CleanString(s)  ' get rid of extra spaces
'
'  s = replace(s, "> ", ">")  ' CleanString() makes sure we only have one space to worry about
'
'  GetNextLine = s
'
'End Function
'
Public Function GetNextLine(f As Variant)
  
  Dim s As String
  s = ""
  Dim bLineContinuing As Boolean
  bLineContinuing = False
  Dim bEndingCComment As Boolean
  bEndingCComment = False
  
  tf = True
  While tf
  
    newLine = f.ReadLine
    
    If bWaitingForEndComment = True Then
      c2 = InStr(newLine, "*/")
      If c2 > 0 Then
        s = s & Right(newLine, Len(newLine) - c2 + 2)
        bEndingCComment = True  ' make sure we return at least "//"
        bWaitingForEndComment = False
      ElseIf bLineContinuing = False Then
'        cleanStr = CleanString(s)  ' get rid of extra spaces
'        If Len(cleanStr) = 0 And Len(newLine) > 0 Then cleanStr = "//"
'        GetNextLine = cleanStr
        GetNextLine = "//"
        Exit Function
      Else
        GoTo NextLine
      End If
    Else
      s = s & newLine
    End If
    
    
    ' ignore C++-style comments
    c1 = InStr(s, "//")
    If c1 > 0 Then
      s = Left(s, c1 - 1)
    End If
    
    ' a different kind of comment
    c1 = InStr(s, "##")
    If c1 > 0 Then
      s = Left(s, c1 - 1)
    End If
    
    ' C-style comments
    c1 = InStr(s, "/*")
    Do While (c1 > 0)
      c2 = InStr(s, "*/")
      If c2 > 0 Then
        s = Left(s, c1 - 1) & Right(s, Len(s) - c2 - 1)
      Else
        s = Left(s, c1 - 1)
        bWaitingForEndComment = True   ' a global variable; what a mess
        Exit Do
      End If
      c1 = InStr(s, "/*")
    Loop
    
    If InStr(s, "\") > 0 Then
      bLineContinuing = True
      s = replace(s, "\", "")
      s = replace(s, vbCrLf, "")
      s = replace(s, vbCr, "")
      s = replace(s, vbLf, "")
    Else
      tf = False
    End If
  
NextLine:
  Wend
  
  ' Don't split up punctuation for INCLUDE lines.
  
  words = Split(s)
  If UBound(words) >= 0 Then
    firstWord = UCase(words(0))
    If StrComp(firstWord, "INCLUDE") = 0 Then
      GetNextLine = CleanString(s)  ' get rid of extra spaces
      Exit Function
    End If
  End If
  
      ' We decide how to continue parsing based on the first word on the line
      
      ' Make sure that braces and other special characters are separated
  ' by whitespace and read as separate tokens
  
  s = replace(s, "{", " { ")
  s = replace(s, "}", " } ")
  s = replace(s, ".", " . ")
  s = replace(s, ",", " , ")
  s = replace(s, ";", " ; ")
  s = replace(s, "--", " -- ")
  s = replace(s, ")", " ) ")
  s = replace(s, "(", " ( ")
  s = replace(s, "?", " ? ")
  s = replace(s, "!", " ! ")
  s = replace(s, "=", " = ")
  s = replace(s, "=~", " =~ ")
  s = replace(s, "~=", " ~= ")
  s = replace(s, "&&", " && ")
  s = replace(s, "||", " || ")
  s = replace(s, "`", " ` ")
  s = replace(s, "^", " ^ ")
  
 ' special parsing of C++ style property references (var->property).
  s = replace(s, "->", ">")
  s = replace(s, ">", " >")
  
  s = CleanString(s)  ' get rid of extra spaces
  
  s = replace(s, "> ", ">")  ' CleanString() makes sure we only have one space to worry about

  If Len(s) = 0 And Len(newLine) > 0 Then s = "//"
  If Len(s) = 0 And bWaitingForNewline = True Then s = "//"
  GetNextLine = s
    
End Function

' This function removes extra whitespace from a line of text.  We have to
' do this, or the Split() function will create extra array elements for every
' extra space character.

Public Function CleanString(s As Variant)
  
  Result = Trim(s)  ' first remove leading and trailing whitespace

  ' since we use the " " character as a delimeter when parsing a line,
  ' we need to make sure there aren't any double spaces, triple spaces; etc.
  ' we do a bunch of Replace() calls to replace double spaces with " "
  
  While InStr(Result, "  ") > 0
    Result = replace(Result, "  ", " ")  ' remove double spaces
  Wend
  
  CleanString = Result  ' return the clean string
  
End Function

' add a word to a word list
Public Sub AddToWordList(listName As Variant, word As Variant)
  If PartsOfSpeech.Exists(listName) Then
    Set l = PartsOfSpeech.item(listName)
    l.Add (word)
  End If
End Sub

' remove a word from a word list
Public Sub RemoveFromWordList(listName As Variant, word As Variant)
  If PartsOfSpeech.Exists(listName) Then
    Set l = PartsOfSpeech.item(listName)
    Dim i As Integer: i = 0   ' TBD: use keys instead for speed
    For Each w In l
      i = i + 1
      If w = word Then
        l.Remove i
        Exit For
      End If
    Next w
  End If
End Sub

' add a grammar to a grammar list
Public Sub AddToGrammarList(listName As Variant, grammar As Variant)
  If Grammars.Exists(listName) Then
    Set g = Grammars.item(listName)
    g.Add (grammar)
  End If
End Sub
' append a pattern to a pattern list
Public Sub AppendPattern(listName As Variant, pattern As Variant)
  If Patterns.Exists(listName) Then
    Set p = Patterns.item(listName)
    p.Add (pattern)
  End If
End Sub
' prepend a pattern to a pattern list
Public Sub PrependPattern(listName As Variant, pattern As Variant)
  If Patterns.Exists(listName) Then
    Set p = Patterns.item(listName)
    If p.count >= 1 Then
      p.Add item:=pattern, before:=1
    Else
      p.Add (pattern)
    End If
  End If
End Sub

Public Sub SetPatternProperty(patternName, varName, words)

  If PatternProperties.Exists(patternName) Then  ' if this pattern group has properties
    Set propList = PatternProperties.item(patternName)
    If propList.Exists(varName) Then
      propList.Remove (varName)
      propList.Add varName, words
      Exit Sub
    End If
  End If
  
  ' try the parent
  If PatternParents.Exists(patternName) Then
    parentName = PatternParents.item(patternName)
    Call SetPatternProperty(parentName, varName, words)
    Exit Sub
  End If

  ErrorsString = ErrorsString & "Set Property of " & patternName & " - property not found: " & varName & "." & vbCrLf
  
End Sub

Public Function GetPatternProperty(patternName As Variant, varName As Variant)
  
  Dim NoValue() As Variant
  NoValue = Array("")
  
  If PatternProperties.Exists(patternName) Then  ' if this pattern group has properties
    Set propList = PatternProperties.item(patternName)
    If propList.Exists(varName) Then
      Result = propList.item(varName)
      GetPatternProperty = Result
      Exit Function
    End If
  End If
  
  ' try the parent
  If PatternParents.Exists(patternName) Then
    parentName = PatternParents(patternName)
    Result = GetPatternProperty(parentName, varName)
    GetPatternProperty = Result
    Exit Function
  End If
  
  GetPatternProperty = NoValue
  
End Function

Public Function GetPatternProperties(patternName As Variant)
  
  Dim Properties
  Set Properties = CreateObject("Scripting.Dictionary")
  
  If PatternProperties.Exists(patternName) Then  ' if this pattern group has properties
    Set propList = PatternProperties.item(patternName)
    keys = propList.keys
    items = propList.items
    For i = 0 To UBound(keys)
      Properties.Add keys(i), items(i)
    Next
  End If
  
   ' due to instancing, the parent should no longer contain relevant var storage
'  If PatternParents.Exists(patternName) Then
'    parentName = PatternParents(patternName)
'    Set moreProperties = GetPatternProperties(parentName)
'    Call MergeDictionaries(Properties, moreProperties, False)
'  End If
 
  Set GetPatternProperties = Properties
  
End Function

Public Sub CreatePropertyInstances(patternName As Variant, parentName As Variant)
  
  ' create a property list if one doesn't exist
  If PatternProperties.Exists(patternName) Then  ' if this pattern group has properties
    Set propList = PatternProperties.item(patternName)
  Else
    Set propList = CreateObject("Scripting.Dictionary")
    PatternProperties.Add patternName, propList
  End If
  
  ' if the parent has properties, add instances to the child
  If PatternProperties.Exists(parentName) Then  ' if this pattern group has properties
    Set parentProperties = PatternProperties.item(parentName)
    keys = parentProperties.keys
    Dim i As Integer
    For i = 0 To UBound(keys)
      If Not propList.Exists(keys(i)) Then
        propList.Add keys(i), parentProperties.item(keys(i))
      End If
    Next
  End If

  ' if the parent has a parent
  If PatternParents.Exists(parentName) Then
    parentName = PatternParents(parentName)
    Call CreatePropertyInstances(patternName, parentName)
  End If
  
End Sub

Public Sub MakeSureWordlistExists(wordListName As Variant)
  If Not PartsOfSpeech.Exists(wordListName) Then
    Dim wordCollection As New Collection
    PartsOfSpeech.Add wordListName, wordCollection
  End If
End Sub
' add a map to a map Dictionary
Public Sub AddToMap(listName As Variant, key As Variant, item As Variant)
  If Maps.Exists(listName) Then
    Set m = Maps.item(listName)
    If m.Exists(key) Then m.Remove (key)
    m.Add key, item
  End If
End Sub

' remove a map from a map Dictionary
Public Sub RemoveFromMap(listName As Variant, key As Variant)
  If Maps.Exists(listName) Then
    Set m = Maps.item(listName)
    If m.Exists(key) Then m.Remove (key)
  End If
End Sub

Public Sub AddVerbToMap(listName As Variant, verb As Variant)
  Call AddToMap(listName, verb(ROOT), verb(ROOT))
  Call AddToMap(listName, verb(INFINITIVE), verb(ROOT))
  Call AddToMap(listName, verb(FIRST_PRESENT), verb(ROOT))
  Call AddToMap(listName, verb(FIRST_PAST), verb(ROOT))
  Call AddToMap(listName, verb(SECOND_PRESENT), verb(ROOT))
  Call AddToMap(listName, verb(SECOND_PAST), verb(ROOT))
  Call AddToMap(listName, verb(THIRD_PRESENT), verb(ROOT))
  Call AddToMap(listName, verb(THIRD_PAST), verb(ROOT))
  Call AddToMap(listName, verb(PLURAL_PRESENT), verb(ROOT))
  Call AddToMap(listName, verb(PLURAL_PAST), verb(ROOT))
  Call AddToMap(listName, verb(PAST_PERFECT), verb(ROOT))
  Call AddToMap(listName, verb(PARTICIPLE), verb(ROOT))
End Sub

' a routine for merging the elements of one collection into another
Public Sub MergeCollections(destination As Variant, source As Variant)
    For Each element In source
      destination.Add (element)
    Next
End Sub
' a routine for merging the elements of one dictionary into another
Public Sub MergeDictionaries(destination As Variant, source As Variant, replace As Boolean)
    If source.count <= 0 Then Exit Sub
    k = source.keys
    For Each key In k
      If destination.Exists(key) Then  ' TBD: throw error?
        If replace = True Then
          destination.Remove (key)
          destination.Add key, source.item(key)
        End If
      Else
        destination.Add key, source.item(key)
      End If
    Next
End Sub

Public Sub AddArrayToCollection(c As Collection, a As Variant)
  For Each element In a
    c.Add (element)
  Next
End Sub

Public Function SubArray(a As Variant, s As Variant, e As Variant) As Variant
  
  Dim Result() As Variant
  ReDim Result(e - s)
  
  Dim cur As Integer: cur = 0
  For i = s To e
    Result(cur) = a(i)
    cur = cur + 1
  Next
  
  SubArray = Result
  
End Function

' Never got thos to work
Public Function ConcatenateArrays(a1 As Variant, a2 As Variant) As Variant
  
  Dim Result() As Variant
  
  If UBound(a1) < 0 Then
    ConcatenateArrays = a2
    Exit Function
  ElseIf UBound(a2) < 0 Then
    ConcatenateArrays = a1
    Exit Function
  End If
  
  ReDim Result((UBound(a1) + 1) + (UBound(a2) + 1) - 1)
  
  Dim i As Integer
  i = 0
  
  For Each element In a1
    Result(i) = element
    i = i + 1
  Next element
          
  For Each element In a2
    Result(i) = element
    i = i + 1
  Next element
          
  ConcatenateArrays = Result

 End Function

' removes all the items from a collection
Public Sub CollectionRemoveAll(c As Variant)

  For x = 1 To c.count
    c.Remove 1
  Next x

End Sub

' Random note: vbCrLf is a constant you can use to add a "line feed" to a
' string.  s = "Line 1." & vbCrLf & "Line 2." puts those two sentences on
' different lines.

