INCLUDE West_Balcony_LIB.s
INCLUDE Larissa_BOT.s
INCLUDE Diego_BOT.s
INCLUDE Snell_BOT.s
INCLUDE Items.s

// move this to story_lib...
// A recursive algorithm for generating a conversation

PATTERNGROUP p_converse
_
_property i_dialogue |e|
_property i_cur_speech |e|
_
_in $talker1 $talker2 $topic
_set i_dialogue = |e|
_set i_cur_speech = |e|
_out _child{_talk $talker1 $talker2 $topic}
_
_in _talk $talker1 $talker2 $topic ~last_speech
_set i_cur_speech = `$talker2 {_talk $talker1 $topic ~last_speech}
_if i_cur_speech = |e|
  _eval `$talker1 {_set_speech_topic |e|}
  _eval `$talker2 {_set_speech_topic |e|}
  _out i_dialogue
_else
  _set i_dialogue = i_dialogue i_cur_speech
  _out _child{_talk $talker2 $talker1 $topic i_cur_speech}   // let the other person respond
_endif

WORDGROUP w_character
@p_larissa
@p_diego
@p_snell

WORDGROUP w_location
@p_west_balcony

WORDGROUP w_item
@p_love_letter
// p_gold_watch
// p_violin

CONST c_hero w_character
CONST c_witness w_character
CONST c_location w_location
CONST c_hero_item w_item

GRAMMARGROUP g_actions

PATTERNGROUP p_test
_in _write
_eval c_location {_add_person c_hero}
_out w_west_balcony_people

WORDGROUP w_meet_word
encounters
discovers
finds
meets
bumps into

PATTERNGROUP p_story
_
_property i_story |e|
_property i_action |e|
_
_in _write
_eval `c_location {_add_person c_hero}
_eval `c_location {_add_person c_witness}
_eval `c_hero {_add_item c_hero_item}
_set i_story = |t| `c_hero->i_name w_meet_word `c_witness->i_name `c_location{_preposition} the `c_location->i_name . |n|
_set i_story = i_story p_converse {c_witness c_hero c_hero_item}
_set i_story = i_story `c_hero {_action c_hero_item c_witness} 
_out i_story

// _out p_converse {@p_diego @p_larissa loveletter}
// _out p_converse {@p_larissa @p_diego loveletter}
// _out g_actions

// GRAMMARGROUP g_story
// p_person_perceives_stimulus {@c_hero p_riotstreet {_stimulus} past} . p_riotstreet {_main_clause} .
// p_riotstreet {_main_clause} . p_person_perceives_stimulus {@c_hero p_riotstreet {_stimulus} past} .

GRAMMARGROUP g_story
c_hero->i_name ran into c_witness->i_name c_location {_in} c_location {_the} c_location {_noun}. \
     c_hero->i_pronoun p_conjugate{c_hero_item {_use_verb} @c_hero past} c_hero_item{_the} c_hero_item{_noun} .

WRITE
p_story{_write}
