INCLUDE StandardEnglish_LIB.s

// superclass of all things
// parts of speech that can vary are implemented as member functions

PATTERNGROUP p_thing
_
_ // way of handling semantic differences between articles.
_ // can be |e| (i.e. NULL)
_property i_a a   // "A rock..."
_property i_the the  // "The particular rock..."
_
_property i_pronoun it   // subjective pronoun
_property i_possessive its
_property i_reflexive itself
_property i_relative which
_property i_objective it
_property i_count singular
_
_ // temp storage.  TBD: some of these may be obsolete
_
_property i_tense past
_property i_compound_verbs true  // allow compound verbs
_property i_last_verb nil
_property i_doing_appositive false  // hack for communicating with subclasses
_
_property i_verb1 nil
_property i_verb2 nil
_property i_do1 nil
_property i_do2 nil
_property i_adverb1 nil
_property i_adverb2 nil
_property i_thing1 nil    // work vars for subclasses
_property i_thing2 nil
_
_in ~a
_set i_last_verb = nil
_
_in _main_clause $t
_set i_tense = $t
_
_in _main_clause ~a
_outm 2 _child{_noun_phrase} p_conjugate{be i_self i_tense} _child{_adjective}
_out _child{_noun_phrase} p_conjugate{be i_self i_tense} _child{_adjective} and _child{_adjective}
_outm 4 _child{_noun_phrase} _child{_verb_phrase}
_
_in _a
_out i_a
_
_in _the
_out i_the
_
_in _noun_phrase $article
_outm 4 _child{$article} _child{_noun}
_outm 4 _child{$article} _child{_adjective} _child{_noun}
_outm 2 _child{$article} _child{_adjective} , _child{_adjective} _child{_noun}
_out _child{$article} _child{_noun} , _child{_adjective} and _child{_adjective} ,
_out _child{$article} _child{_noun} , _child{_conjunction} p_conjugate{be i_self i_tense} _child{_adjective} ,
_out _child{$article} _child{_noun} , _child{_conjunction} p_conjugate{be i_self i_tense} _child{_adjective} and _child{_adjective} ,
_
_in _noun_phrase
_out _child{_noun_phrase _the}
_
_in _verb_phrase $t
_set i_tense = $t
_
_in _verb_phrase ~a
_set i_verb1 _child{_trans_verb}
_set i_do1 _child{_direct_object i_verb1}
_set i_verb2 _child{_intrans_verb}
_if {i_verb1 = nil || i_do1 = nil} && i_verb2 = nil
  _out [ERROR: p_thing: subclass must define trans or intrans verb]
_endif
_if i_verb1 ^= nil && i_do1 ^= nil
  _out _child{_trans_verb_phrase}
_endif
_if i_verb2 ^= nil
  _out _child{_intrans_verb_phrase}
_endif
_
_in _intrans_verb_phrase $t
_set i_tense = $t
_
_in _intrans_verb_phrase ~a
_set i_verb1 _child{_intrans_verb}
_set i_verb2 _child{_intrans_verb}
_if i_verb1 ^= nil
  _outm 2 p_conjugate{i_verb1 i_self i_tense}
  _outm 4 p_conjugate{i_verb1 i_self i_tense} _child{_intrans_adverb_phrase i_verb1}
  _outm 1 _child{_intrans_adverb} p_conjugate{i_verb1 i_self i_tense}
  _if i_verb2 ^= nil && i_compound_verbs = true
    _outm 6 p_conjugate{i_verb1 i_self i_tense} and p_conjugate{i_verb2 i_self i_tense}
    _out p_conjugate{i_verb1 i_self i_tense} and p_conjugate{i_verb2 i_self i_tense} _child{_intrans_adverb_phrase i_verb2}
    _out p_conjugate{i_verb1 i_self i_tense} _child{_intrans_adverb_phrase i_verb1} and p_conjugate{i_verb2 i_self i_tense}
    _out p_conjugate{i_verb1 i_self i_tense} _child{_intrans_adverb_phrase i_verb1} and p_conjugate{i_verb2 i_self i_tense} _child{_intrans_adverb_phrase i_verb2}
    _out _child{_intrans_adverb} p_conjugate{i_verb1 i_self i_tense} and p_conjugate{i_verb2 i_self i_tense}
  _endif
_endif
_
_in _trans_verb_phrase $t
_set i_tense = $t
_
_in _trans_verb_phrase ~a
_set i_verb1 _child{_trans_verb}
_set i_verb2 _child{_trans_verb}
_set i_do1 _child{_direct_object i_verb1}
_set i_do2 _child{_direct_object i_verb2}
_if i_verb1 ^= nil && i_do1 ^= nil
  _outm 4 p_conjugate{i_verb1 i_self i_tense} i_do1
  _out p_conjugate{i_verb1 i_self i_tense} i_do1 _child{_trans_adverb_phrase i_verb1}
  _out _child{_trans_adverb} p_conjugate{i_verb1 i_self i_tense} i_do1
  _if i_verb2 ^= nil  && i_do2 ^= nil  && i_compound_verbs = true
    _outm 8 p_conjugate{i_verb1 i_self i_tense} i_do1 and p_conjugate{i_verb2 i_self i_tense} i_do2
    _out p_conjugate{i_verb1 i_self i_tense} i_do1 _child{_trans_adverb_phrase i_verb1} and p_conjugate{i_verb2 i_self i_tense} i_do2
    _out p_conjugate{i_verb1 i_self i_tense} i_do1 and p_conjugate{i_verb2 i_self i_tense} i_do2 _child{_trans_adverb_phrase i_verb2}
    _out p_conjugate{i_verb1 i_self i_tense} i_do1 _child{_trans_adverb_phrase i_verb1} and p_conjugate{i_verb2 i_self i_tense} i_do2 _child{_trans_adverb_phrase i_verb2}
    _out _child{_trans_adverb} p_conjugate{i_verb1 i_self i_tense} i_do1 and p_conjugate{i_verb2 i_self i_tense} i_do2
  _endif
_endif
_
_in _direct_object $verb
_set i_last_verb = $verb
_
_in _direct_object ~a
_out nil
_
_in _trans_adverb_phrase $verb
_set i_last_verb = $verb
_
_in _trans_adverb_phrase ~a
_out _child{_trans_adverb}
_
_in _intrans_adverb_phrase $verb
_set i_last_verb = $verb
_
_in _intrans_adverb_phrase ~a
_out _child{_intrans_adverb}
_
_in _appositive_phrase $article  // not quite an "appositive," I don't think, but close
_set i_doing_appositive = true
_outm 8 _child{$article} _child{_noun} _child{_adjective}
_outm 4 _child{$article} _child{_noun} _child{_adjective} and _child{_adjective}
_set i_verb1 _child{_intrans_verb}
_set i_verb2 _child{_intrans_verb}
_if i_verb1 ^= nil
  _outm 8 _child{_noun_phrase} f_participle {i_verb1}
  _outm 2 _child{_noun_phrase} f_participle {i_verb1} _child{_intrans_adverb}
  _outm 2 _child{_noun_phrase} _child{_intrans_adverb} f_participle {i_verb1}
  _out _child{_noun_phrase} f_participle {i_verb1} , _child{_intrans_adverb} and _child{_intrans_adverb}
  _if i_verb2 ^= nil  && i_compound_verbs = true
    _outm 4 _child{_noun_phrase} f_participle {i_verb1} and f_participle {i_verb2}
    _out _child{_noun_phrase} f_participle {i_verb1} and f_participle {i_verb2} , _child{_intrans_adverb}
    _out _child{_noun_phrase} _child{_intrans_adverb} f_participle {i_verb1} and f_participle {i_verb2}
    _out _child{_noun_phrase} f_participle {i_verb1} and f_participle {i_verb2} , _child{_intrans_adverb} , _child{_intrans_adverb}
  _endif
_endif
_set i_verb1 _child{_trans_verb}
_set i_verb2 _child{_trans_verb}
_set i_do1 _child{_direct_object i_verb1}
_set i_do2 _child{_direct_object i_verb2}
_if i_verb1 ^= nil && i_do1 ^= nil 
  _outm 8 _child{_noun_phrase} f_participle {i_verb1} i_do1
  _outm 2 _child{_noun_phrase} f_participle {i_verb1} i_do1 _child{_trans_adverb}
  _outm 2 _child{_noun_phrase} _child{_trans_adverb} f_participle {i_verb1} i_do1
  _out _child{_noun_phrase} f_participle {i_verb1} i_do1, _child{_trans_adverb} and _child{_trans_adverb}
  _if i_verb2 ^= nil  && i_do2 ^= nil  && i_compound_verbs = true
    _outm 4 _child{_noun_phrase} f_participle {i_verb1} i_do1 and f_participle {i_verb2} i_do2
    _out _child{_noun_phrase} f_participle {i_verb1} i_do1 and f_participle {i_verb2} i_do2 , _child{_trans_adverb}
    _out _child{_noun_phrase} _child{_trans_adverb} f_participle {i_verb1} i_do1 and f_participle {i_verb2} i_do2
    _out _child{_noun_phrase} f_participle {i_verb1} i_do1 and f_participle {i_verb2} i_do2, _child{_trans_adverb} , _child{_trans_adverb}
  _endif
_endif
_set i_doing_appositive = false
_
_appositive_phrase
_out _child{_appositive_phrase _the}
_
_in _subordinate_clause $t
_set i_tense $t
_
_in _subordinate_clause ~a
_out _child{_conjunction} _child{_verb_phrase i_tense}
_
_in _subordinate_phrase   // TBD: add DOs
_out f_participle {_child{_intrans_verb}}
_out f_participle {_child{_intrans_verb}} _child{_intrans_adverb_phrase}
_out _child{_intrans_adverb} f_participle {_child{_intrans_verb}}
_
_in _noun
_out thing
_in _adjective
_out real
_in _verb
_out nil
_in _intrans_verb
_out _child{_verb}
_in _trans_verb
_out _child{_verb}
_in _this   // demonstrative pronoun
_if i_count = singular
  _out this
_else
  _out these
_endif
_in _that   // demonstrative pronoun
_if i_count = singular
  _out that
_else
  _out those
_endif
_in _adverb ~a
_out nil
_in _intrans_adverb ~a   // by default, p_thing doesn't distinguish between adverb contexts
_out _child {_adverb}
_in _trans_adverb ~a
_out _child {_adverb}
_in _analogy
_out nil

// superclass of all people
PATTERNGROUP p_person EXTENDS p_thing
_
_property i_name DefaultName
_property i_sex male
_property i_pronoun he
_property i_objective him
_property i_possessive his
_property i_reflexive himself
_property i_relative who
_
_property i_location nil  // our location
_property i_item_list nil  // name of a WORDLIST containing item pointers
_
_property i_cur_topic |e|  // vars for tracking a conversation
_property i_cur_talker |e|
_property i_speech_count 0
_
_in _add_item $i
_addword `i_item_list $i
_out |e|
_
_in _remove_item $i
_removeword `i_item_list $i
_out |e|
_
_in _action  // ask the character to do something
_out i_classname do nothing
_
_in _set_speech_topic $topic
  _set i_cur_topic = $topic
  _set i_speech_count = 0
  _out |e|
_
_in _increment_speech_count
_if i_speech_count = 3
  _set i_speech_count = 4
  _out |e|
_endif
_if i_speech_count = 2
  _set i_speech_count = 3
  _out |e|
_endif
_if i_speech_count = 1
  _set i_speech_count = 2
  _out |e|
_endif
_if i_speech_count = 0
  _set i_speech_count = 1
  _out |e|
_endif

//
// these methods scrub a character's name out of a sentence
// and replace it with a specified form of the pronoun
//
_in _ApplyPronoun ~a i_name ~b i_name ~c
_out ~a i_pronoun ~b i_pronoun ~c
_in _ApplyPronoun ~a i_name ~b
_out ~a i_pronoun ~b
_in _ApplyPossessive ~a i_name ~b i_name ~c
_out ~a i_possessive ~b i_possessive ~c
_in _ApplyPossessive ~a i_name ~b
_out ~a i_possessive ~b
_in _ApplyReflexive ~a i_name ~b i_name ~c
_out ~a i_reflexive ~b i_reflexive ~c
_in _ApplyReflexive ~a i_name ~b
_out ~a i_reflexive ~b
_in _ApplyObjective ~a i_name ~b i_name ~c
_out ~a i_objective ~b i_objective ~c
_in _ApplyObjective ~a i_name ~b
_out ~a i_objective ~b

// superclass of all locations

PATTERNGROUP p_location EXTENDS p_thing
_
_property i_name location
_
_property i_item_list nil  // name of a WORDLIST containing item pointers
_property i_people_list nil  // name of a WORDLIST containing people pointers
_
_in _noun
_out location
_in _adjective
_out real
_in _stimulus
_out null_stimulus
_in _in  // preposition describing a character's presence here.  i.e. "on" the balcony
_out in
_
_in _add_item $i
_addword `i_item_list $i
_out |e|
_
_in _remove_item $i
_removeword `i_item_list $i
_out |e|
_
_in _add_person $p
_addword `i_people_list $p
_out |e|
_
_in _remove_person $p
_removeword `i_people_list $p
_out |e|
_

PATTERNGROUP p_item EXTENDS p_thing
_
_property i_name item
_
_in _noun
_out item
_in _adjective
_out real
_in _use_verb   // "wave" wand...  TBD: is this how we want to do this?
_out use

// superclass of all stimuli
PATTERNGROUP p_stimulus EXTENDS p_thing
_
_property i_substimulus1 nil   /* temporary storage during phrase-generation */
_property i_substimulus2 nil
_property i_substimulus3 nil
_property i_substimulus_phrase nil
_
_in _stimulus  /* a pointer to a stimulus patterngroup
                  that describes a subcomponent of this one */
_out nil
_in _noun
_out stimulus
_in _sense_verb
_out sense
_in _intrans_verb
_out exist
_in _trans_verb
_out stimulate
_in _adverb
_out truly
_in _adjective
_out real
_in _conjunction
_out which
_in _location_phrase
_out nearby
_in _prepositional_phrase
_out on the ground
_
_in _substimulus_phrase
_set i_substimulus1 _child{_stimulus}
_set i_substimulus2 _child{_stimulus}
_set i_substimulus3 _child{_stimulus}
_if i_substimulus1 = nil
  _out nil
_else
  _out `i_substimulus1{_appositive_phrase}
  _if i_substimulus2 = nil
  _else
    _out `i_substimulus1{_appositive_phrase} , `i_substimulus2{_appositive_phrase}
    _if i_substimulus3 = nil
    _else
      _out `i_substimulus1{_appositive_phrase} , `i_substimulus2{_appositive_phrase} , `i_substimulus3{_appositive_phrase}
    _endif
  _endif
_endif


// superclass of all problems
PATTERNGROUP p_problem EXTENDS p_thing
_
_property i_owner nil   // the person who has the problem
_property i_compound_verbs false  // hack to limit compound verbs
_property i_subject problem  // lets us specify the subject of generated sentences
_property i_problem_count singular
_
_in _main_clause $s ~a
_if $s = owner || $s = problem
  _set i_subject = $s
  _set i_count = _child{_count $s}
_else
  _set i_subject = owner
  _set i_count = _child{_count owner}
_endif
_out _parent{_main_clause ~a}
_
_in _appositive_phrase $s
_if $s = owner || $s = problem
  _set i_subject = $s
  _set i_count = _child{_count $s}
_else
  _set i_subject = owner
  _set i_count = _child{_count owner}
_endif
_out _parent{_appositive_phrase}
_
_in _subordinate_clause $s ~a
_if $s = owner || $s = problem
  _set i_subject = $s
  _set i_count = _child{_count $s}
_else
  _set i_subject = owner
  _set i_count = _child{_count owner}
_endif
_out _parent{_subordinate_clause ~a}
_
_in _count $s
_if $s = problem
  _out i_problem_count
_else
  _out i_owner->i_count
_endif
_
_in _noun
_if i_subject = problem
  _out _child{_problem_noun}
_else
  _out i_owner->i_name
_endif
_
_in _problem_noun
_out problem
_
_in _problem_article
_if i_doing_appositive = true
  _out i_owner->i_name 's
_else
  _out a
_endif
_
_in _problem_conjunction
_out which
_
_in _problem_adjective
_out _child{_adjective}
_
_in _owner_conjunction
_out who
_
_in _the
_if i_doing_appositive = true && i_subject = problem
  _out i_owner->i_possessive
_else
  _if i_subject = owner
    _out |e|
  _else
    _out _child {_problem_article}
  _endif
_endif
_
_in _a
_out _child{_the}   // TBD: do something unique here?
_
_in _conjunction
_if i_subject = owner
  _out _child{_owner_conjunction}
_else
  _out _child {_problem_conjunction}
_endif
_
_in _intrans_verb
_out nil
_in _trans_verb
_out have
_in _adverb
_out truly
_in _adjective
_out real
_in _prepositional_phrase
_out of great seriousness
_
_in _direct_object ~a
_if i_subject = owner
  _out _child{_owner_direct_object ~a}
_else
  _out _child{_problem_direct_object ~a}
_endif
_
_in _owner_direct_object ~a
_out _child{_problem_article} _child{_problem_noun}
_out _child{_problem_article} _child{_problem_adjective} _child{_problem_noun}
_
_in _problem_direct_object ~a
_out i_owner->i_objective
_
_in _init $o
_set i_owner `$o
_eval i_owner {_problem i_self}   // tell the fool that he has us as a problem
_out `i_self   // pass back our pattern name, not a pointer

// a person perceives a stimulus
PATTERNGROUP p_person_perceives_stimulus
_
_property i_person nil
_property i_stimulus nil
_property i_tense present
_
_property i_main_clause nil
_
_  /*** begin internal handlers ***/
_
_in _main_clause
_out i_person->i_name p_conjugate{i_stimulus{_sense_verb} $p i_tense} i_stimulus{_noun_phrase}
_out i_person->i_name p_conjugate{i_stimulus{_sense_verb} $p i_tense} i_stimulus{_noun_phrase} i_stimulus{_location_phrase}
_
_in ~a
_set i_tense present   /* default tense = present */
_
_in $p $s $t  /* user optionally can impose a verb tense */
_set i_tense $t
_
_  /*** end internal handlers ***/
_
_in $p $s ~a
_set i_person ` $p
_set i_stimulus ` $s
_set i_main_clause _child{_main_clause}
_out i_main_clause

_out i_person->i_name p_conjugate{i_stimulus{_sense_verb} $p i_tense} i_stimulus{_noun_phrase} , i_stimulus{_subordinate_clause i_tense}
_set i_substimulus_phrase i_stimulus{_substimulus_phrase}
_if i_substimulus_phrase ^= nil
  _out i_main_clause , i_substimulus_phrase ,
_endif

// calculate subject-verb agreement in the third person
// TBD: currently only handles third-person
PATTERNGROUP p_conjugate
_property i_subject nil
_property i_count nil
_in ~a   /* reset variables */
_set i_subject nil
_set i_count nil
_in $verb $subject $tense  /* assign variables */
_set i_subject `$subject
_set i_count i_subject->i_count
_in $verb $subject present   /* do calculations */
_if i_count = plural
  _out f_plural_present $verb
_else
  _out f_third_present $verb
_endif
_in $verb $subject past
_if i_count = plural
  _out f_plural_past $verb
_else
  _out f_third_past $verb
_endif
_in $verb $subject future
_out f_future $verb
