INCLUDE Story_LIB.s

/****************************************/

// the balcony overlooking the rocky coastline

WORDGROUP w_west_balcony_intrans_verb
lie
stand
slumber
burn
live

WORDGROUP w_west_balcony_trans_verb
endure
reflect
receive
await

WORDGROUP w_west_balcony_adverb
stoically
achingly
darkly

WORDGROUP w_west_balcony_adjective
chaotic
terrifying
dangerous
ruined
destroyed
trashed

WORDGROUP w_west_balcony_preposition
amid
among
below
within sight of
at the mercy of
in defiance to

WORDGROUP w_west_balcony_stimulus
@p_police_car_moving

// @p_lost_dog
// @p_distant_smoke

WORDGROUP w_west_balcony_items

WORDGROUP w_west_balcony_people

PATTERNGROUP p_west_balcony EXTENDS p_location
_
_property i_name west balcony
_
_property i_item_list @w_west_balcony_items  
_property i_people_list @w_west_balcony_people
_
_property i_tempverb nil
_
_in _in
_out on   // "on" the balcony
_
_in _stimulus
_out w_west_balcony_stimulus
_
_in _conjunction
_out which
_
_in _preposition
_out on
_
_in _sense_verb
_out see
_
_in _noun
_out west balcony
_
_in _intrans_verb
_out w_west_balcony_intrans_verb
_
_in _intrans_verb_phrase $t
_set i_tense = $t
_
_in _intrans_verb_phrase ~a
_set i_tempverb = w_west_balcony_intrans_verb
_if i_tempverb ~= lie stand live
  _set i_thing1 w_distant_thing
  _out p_conjugate{i_tempverb i_self i_tense} w_west_balcony_preposition `i_thing1 _noun_phrase
_else
  _out _parent {_intrans_verb_phrase ~a}
_endif
_
_in _trans_verb
_out w_west_balcony_trans_verb
_
_in _adverb
_out w_west_balcony_adverb
_
_in _adjective
_out w_west_balcony_adjective
_
_in _direct_object $verb
_set i_last_verb = $verb
_
_in _direct_object ~a
_set i_thing1 w_distant_thing
_out `i_thing1 _noun_phrase

/****************************************/

WORDGROUP w_police_car_moving_substimulus
@p_damaged_windshield
@p_active_lightbar
@p_active_siren

WORDGROUP w_police_car_moving_intrans_verb
screech
speed
zoom
skid
fishtail
race

WORDGROUP w_police_car_moving_trans_verb
pierce
terrorize
roam
patrol
invade

WORDGROUP w_police_car_moving_adverb
loudly
deafeningly
sharply
frantically

WORDGROUP w_police_car_moving_adjective
dented
war-weary
wounded
scratched
fire-stained
burning
gleaming

PATTERNGROUP p_police_car_moving EXTENDS p_stimulus
_
_in _stimulus
_out w_police_car_moving_substimulus
_
_in _noun
_out cop car
_out patrol car
_out police car
_
_in _article
_out a
_
_in _conjunction
_out which
_
_in _sense_verb
_out see
_
_in _intrans_verb
_out w_police_car_moving_intrans_verb
_
_in _trans_verb
_out w_police_car_moving_trans_verb
_
_in _adverb
_out w_police_car_moving_adverb
_
_in _adjective
_out w_police_car_moving_adjective
_
_in _location_phrase
_out down the street
_out at the nearby intersection
_out in the smoky distance
_out in the distance
_out amid the chaos
_
_in _prepositional_phrase
_out over the littered pavement
_out across glittering pools of broken glass
_out over a fallen streetsign
_out away into the gloom
_
_in _direct_object $verb
_set i_last_verb = $verb
_
_in _direct_object ~a
_set i_thing1 w_distant_thing
_out `i_thing1 _noun_phrase

/*********************************************/

WORDGROUP w_damaged_windshield_intrans_verb
disintegrate
spiderweb
crack
shatter

WORDGROUP w_damaged_windshield_trans_verb
brave
reflect
deflect
taunt
ignore

WORDGROUP w_damaged_windshield_adverb
brightly
completely
whitely
edge to edge
painfully

WORDGROUP w_damaged_windshield_adjective
smashed
broken
damaged

PATTERNGROUP p_damaged_windshield EXTENDS p_stimulus
_
_in _noun
_out windshield
_out window
_
_in _article
_out the
_
_in _conjunction
_out which
_
_in _sense_verb
_out see
_out notice
_
_in _intrans_verb
_out w_damaged_windshield_intrans_verb
_
_in _trans_verb
_out w_damaged_windshield_trans_verb
_
_in _adverb
_out w_damaged_windshield_adverb
_
_in _adjective
_out w_damaged_windshield_adjective
_
_in _location_phrase
_out of a nearby car
_
_in _prepositional_phrase
_out from a hateful blow
_out in the cruel firelight
_out in the feathery wind
_
_in _direct_object $verb
_set i_last_verb = $verb
_
_in _direct_object ~a
_set i_thing1 w_distant_thing
_out `i_thing1 _noun_phrase

/*********************************************/

WORDGROUP w_active_lightbar_intrans_verb
whirl
flash
beam
parade

WORDGROUP w_active_lightbar_trans_verb
color
defy
reclaim
threaten
baffle

WORDGROUP w_active_lightbar_adverb
brightly
hotly
angrily
anxiously
madly
confidently
proudly
eye-to-eye with the rioters

WORDGROUP w_active_lightbar_adjective
blue and red
angry
high-lumin
wild
deranged
directional

PATTERNGROUP p_active_lightbar EXTENDS p_stimulus
_
_in _noun
_out lights
_out lightbar
_
_in _article
_out the
_
_in _conjunction
_out which
_
_in _sense_verb
_out see
_
_in _intrans_verb
_out w_active_lightbar_intrans_verb
_
_in _trans_verb
_out w_active_lightbar_trans_verb
_
_in _adverb
_out w_active_lightbar_adverb
_
_in _adjective
_out w_active_lightbar_adjective
_
_in _location_phrase
_out of a cop car
_
_in _prepositional_phrase
_out in defiance
_out on a swift trajectory
_out with a mean light for everyone
_
_in _direct_object $verb
_set i_last_verb = $verb
_
_in _direct_object ~a
_set i_thing1 w_distant_thing
_out `i_thing1 _noun_phrase

/*********************************************/

WORDGROUP w_active_siren_intrans_verb
howl
scream
blare
rip
carom
wail
whoop
sing
cry
beckon

WORDGROUP w_active_siren_trans_verb
condemn
pierce
rend
scour
command
startle
berate
serenade

WORDGROUP w_active_siren_adverb
loudly
frightfully
belligerently
warningly
ceaselessly

WORDGROUP w_active_siren_adjective
ear-splitting
knife-sharp
cycling
aimless
lonely

PATTERNGROUP p_active_siren EXTENDS p_stimulus
_
_in _noun
_out siren
_
_in _article
_out the
_
_in _conjunction
_out which
_
_in _sense_verb
_out hear
_
_in _intrans_verb
_out w_active_siren_intrans_verb
_
_in _trans_verb
_out w_active_siren_trans_verb
_
_in _adverb
_out w_active_siren_adverb
_
_in _adjective
_out w_active_siren_adjective
_
_in _location_phrase
_out of a cop car
_
_in _prepositional_phrase
_out through the night
_out at the dark buildings
_out in the faces of looters
_
_in _direct_object $verb
_set i_last_verb = $verb
_
_in _direct_object ~a
_set i_thing1 w_distant_thing
_out `i_thing1 _noun_phrase

/****************************************/

WORDGROUP w_distant_thing
@p_night
@p_sky
@p_faces
@p_people

/*********************************************/

WORDGROUP w_night_intrans_verb
brood
wait
weep
suffer
ache

WORDGROUP w_night_trans_verb
watch
bless
hide
conceal
veil
cloak
entomb
bury
smother

WORDGROUP w_night_adverb
silently
darkly
calmly
sweetly
ruefully
mercifully
kindly
cruelly

WORDGROUP w_night_adjective
deep
black
fathomless
blameless
neutral
troubled
confused
insatiable

PATTERNGROUP p_night EXTENDS p_stimulus
_
_in _noun
_out night
_out darkness
_out gloom
_out blackness
_
_in _article
_out the
_
_in _conjunction
_out which
_
_in _sense_verb
_out see
_out feel
_
_in _intrans_verb
_out w_night_intrans_verb
_
_in _trans_verb
_out w_night_trans_verb
_
_in _adverb
_out w_night_adverb
_
_in _adjective
_out w_night_adjective
_
_in _location_phrase
_out above
_out everywhere
_out in the streets
_out thick and liquid
_out containing everything
_
_in _prepositional_phrase
_out over everything
_out without sound or indication
_out from a great distance
_
_in _direct_object $verb
_set i_last_verb = $verb
_
_in _direct_object ~a
_set i_thing1 w_distant_thing
_out `i_thing1 _noun_phrase

/*********************************************/

WORDGROUP w_sky_intrans_verb
lower
loom
smolder
roil
glow
churn

WORDGROUP w_sky_trans_verb
lid
frame
intimidate
observe
record
mock
deride

WORDGROUP w_sky_adverb
turbulently
smokily
silently
darkly
calmly
indifferently
sourly
moodily

WORDGROUP w_sky_adjective
smoky
murky
polluted
sad
corrupted
dirty
ugly
dark

WORDGROUP w_sky_noun
sky
heavens
cloudcover
firmament
atmosphere

PATTERNGROUP p_sky EXTENDS p_stimulus
_
_property i_temp_word nil
_
_in _noun
_set i_temp_word w_sky_noun
_if i_temp_word = heavens   // terrible, terrible hack
  _set i_count plural
_else
  _set i_count singular
_endif
_out i_temp_word
_
_in _article
_out the
_
_in _conjunction
_out which
_
_in _sense_verb
_out see
_out feel
_
_in _intrans_verb
_out w_sky_intrans_verb
_
_in _trans_verb
_out w_sky_trans_verb
_
_in _adverb
_out w_sky_adverb
_
_in _adjective
_out w_sky_adjective
_
_in _location_phrase
_out above
_
_in _prepositional_phrase
_out over everything
_out full of smoke and ash
_out from horizon to horizon
_
_in _direct_object $verb
_set i_last_verb = $verb
_
_in _direct_object ~a
_set i_thing1 w_distant_thing
_out `i_thing1 _noun_phrase

/*********************************************/

WORDGROUP w_faces_intrans_verb
weep
search
watch
sweat
laugh
gather
hide

WORDGROUP w_faces_trans_verb
eye
beseech
contemplate
reflect
read
litter
populate
embroider
accuse

WORDGROUP w_faces_adverb
silently
calmly
angrily
uniformly
hotly
coolly
enigmatically
individually

WORDGROUP w_faces_adjective
dour
serious
grimy
pale
mean
cruel
frightened
varied
bewildered
intent
searching
lost
demented
amazed
pleased

WORDGROUP w_faces_noun
faces
expressions
visages

PATTERNGROUP p_faces EXTENDS p_stimulus
_
_property i_pronoun they
_property i_possessive their
_property i_reflexive themselves
_property i_count plural
_
_property i_last_noun nil
_
_in _noun
_set i_last_noun w_faces_noun
_out i_last_noun
_
_in _article
_out the
_
_in _conjunction
_out which
_
_in _sense_verb
_out see
_out notice
_out encounter
_
_in _intrans_verb
_out w_faces_intrans_verb
_
_in _trans_verb
_out w_faces_trans_verb
_
_in _adverb
_out w_faces_adverb
_
_in _adjective
_out w_faces_adjective
_
_in _location_phrase
_out nearby
_out scatttered through the night
_out lost in the gloom
_out hovering nearby
_out in the distance
_out mixed up in the smoke and shadows
_out hovering like ghosts
_
_in _prepositional_phrase
_out along the street
_out amid the darkness
_out in the road
_out everywhere
_out to all sides
_out darting everywhere
_outm 4 of w_people_noun
_
_in _direct_object $verb
_set i_last_verb = $verb
_
_in _direct_object ~a
_set i_thing1 w_distant_thing
_out `i_thing1 _noun_phrase


/*********************************************/

WORDGROUP w_people_intrans_verb
weep
search
watch
sweat
laugh
gather
hide

WORDGROUP w_people_trans_verb
eye
beseech
contemplate
reflect
read
litter
populate
embroider
accuse

WORDGROUP w_people_adverb
silently
calmly
angrily
uniformly
hotly
coolly
enigmatically
individually

WORDGROUP w_people_adjective
dour
serious
grimy
pale
mean
cruel
frightened
varied
bewildered
intent
searching
lost
demented
amazed
pleased

WORDGROUP w_people_noun
people
rioters
looters

PATTERNGROUP p_people EXTENDS p_stimulus
_
_property i_pronoun they
_property i_possessive their
_property i_reflexive themselves
_property i_count plural
_
_property i_last_noun nil
_
_in _noun
_set i_last_noun w_people_noun
_out i_last_noun
_
_in _article
_out the
_
_in _conjunction
_out who
_
_in _sense_verb
_out see
_out notice
_out encounter
_
_in _intrans_verb
_out w_people_intrans_verb
_
_in _trans_verb
_out w_people_trans_verb
_
_in _adverb
_out w_people_adverb
_
_in _adjective
_out w_people_adjective
_
_in _location_phrase
_out nearby
_out scatttered through the night
_out lost in the gloom
_out hovering nearby
_out in the distance
_out mixed up in the smoke and shadows
_out hovering like ghosts
_
_in _prepositional_phrase
_out along the street
_out amid the darkness
_out in the road
_out everywhere
_out to all sides
_out darting everywhere
_
_in _direct_object $verb
_set i_last_verb = $verb
_
_in _direct_object ~a
_set i_thing1 w_distant_thing
_out `i_thing1 _noun_phrase

