INCLUDE StandardEnglish_LIB.s

WORDGROUP w_cast
John
Richard
Larry
Ally
Ling

MAP m_cast_pronoun
John he
Richard he
Larry he
Ally she
Ling she

MAP m_cast_possessive
John his
Richard his
Larry his
Ally her
Ling her

MAP m_cast_reflexive
John himself
Richard himself
Larry himself
Ally herself
Ling herself

// pick a cast member different than the input string
PATTERNGROUP p_cast_other
_in John
_out Richard
_out Larry
_out Ally
_out Ling
_in Richard
_out John
_out Larry
_out Ally
_out Ling
_in Larry
_out Richard
_out John
_out Ally
_out Ling
_in Ally
_out Richard
_out Larry
_out John
_out Ling
_in Ling
_out Richard
_out Larry
_out Ally
_out John

PATTERNGROUP p_ally_eyes
_
_in noun
_out eyes
_
_in adjective neutral
_out green
_out large
_
_in adjective positive
_out lovely
_out softly alluring
_out soft
_out pretty
_
_in adjective negative
_out bulbous
_out sunken
_out amphibious
_out puffy


// superclass of all people
PATTERNGROUP p_person
_
_property i_name DefaultName
_property i_sex male
_property i_pronoun he
_property i_possessive his
_property i_reflexive himself
_
_in trait $mood
_out average looks
_in SayHi
_out hello
_in Grunt
_out Ugh
_in ColorfulHi
_out _child Grunt _child SayHi

PATTERNGROUP p_ally EXTENDS p_person
_
_property i_name Ally
_property i_sex female
_property i_reflexive herself
_property i_cast w_cast
_property i_grow one
_property i_sky in the sky
_property i_ocean on the ocean
_
_in ~a m_cast_possessive ~b
_out $m_cast_possessive1 bird died .
_in ~a sky ~b
_out Matched the sky !
_in g_sky_ocean
_out matched : $g_sky_ocean1 .
_in i_sky ~b i_ocean ~c
_out I love to float i_sky myself , as well as i_ocean.
_in i_cast ~a
_if i_sex = female
  _set i_sex male
_else
  _set i_sex female
_endif
_out $i_cast1 ~a ! i_name is a i_sex .
_in trait $mood
_out p_ally_eyes { adjective $mood } p_ally_eyes noun , i_possessive wombat
_out p_ally_eyes { adjective $mood } p_ally_eyes { adjective neutral } p_ally_eyes noun
_in SayHiTwice
_out _parent {SayHi} _parent {SayHi}
_in Grunt
_out Booyah!

// expects c_envy_other to be set to the name of the person envied
GRAMMARGROUP g_envy_other
envies c_envy_other for m_cast_possessive c_envy_other \
     p_cast_good_quality c_envy_other

CONST c_hero f_pick w_cast
CONST c_hero_pronoun m_cast_pronoun c_hero
CONST c_hero_possessive m_cast_possessive c_hero

CONST c_enemy f_pick w_cast
CONST c_enemy_pronoun m_cast_pronoun c_enemy
CONST c_enemy_possessive m_cast_possessive c_enemy

CONST c_victim f_pick w_cast
CONST c_victim_pronoun m_cast_pronoun c_victim
CONST c_victim_possessive m_cast_possessive c_victim

CONST c_gossip1 f_pick w_cast
CONST c_gossip1_pronoun m_cast_pronoun c_gossip1
CONST c_gossip1_possessive m_cast_possessive c_gossip1

CONST c_gossip2 f_pick w_cast
CONST c_gossip2_pronoun m_cast_pronoun c_gossip2
CONST c_gossip2_possessive m_cast_possessive c_gossip2

CONST c_hero_victim c_hero c_victim
CONST c_hero_victim_good_relation p_cast_good_relation c_hero_victim

// CONST c_problem w_problem
CONST c_problem stolenlover

// pretty yucky.  no parens, so we must build our own arg in a temp variable
CONST c_hero_reaction_arg c_hero c_problem c_victim
CONST c_hero_reaction p_cast_reaction c_hero_reaction_arg

PATTERNGROUP p_problem_description
_in stolenlover
_out p_trans_action_description p_problem_stolenlover_description _self

PATTERNGROUP p_cast_good_relation
_in John Larry
_out friend
_in John Richard
_out boss
_in John Ling
_out secret love interest
_in John Ally
_out secret love interest
_in Richard John
_out employee
_in Richard Larry
_out collegue
_in Richard Ling
_out lover
_in Richard Ally
_out employee
_in Larry Ally
_out lover
_in Larry John
_out friend
_in Larry Richard
_out collegue
_in Larry Ling
_out secret love interest
_in Ally Larry
_out lover
_in Ally John
_out friend
_in Ally Richard
_out boss
_in Ally Ling
_out secret love interest
_in Ling Ally
_out secret love interest
_in Ling Richard
_out lover
_in Ling John
_out colleague
_in Ling Larry
_out colleague

WORDGROUP w_john_good_adj
kind
sincere
cute
brainy

WORDGROUP w_richard_good_adj
successful
able
witty
honest

WORDGROUP w_larry_good_adj
good looking
charming
funny
musical

WORDGROUP w_ally_good_adj
beautiful
sincere
passionate
idealistic

WORDGROUP w_ling_good_adj
strong
hot
spontaneous
tough

PATTERNGROUP p_cast_good_adj
_in Ally
_out w_ally_good_adj
_in Richard
_out w_richard_good_adj
_in John
_out w_john_good_adj
_in Ling
_out w_ling_good_adj
_in Larry
_out w_larry_good_adj

WORDGROUP w_john_bad_adj
shy
insecure
small
goofy looking

WORDGROUP w_richard_bad_adj
greedy
power-loving
insensitive
sexist

WORDGROUP w_larry_bad_adj
ambivalent
smarmy
cocky

WORDGROUP w_ally_bad_adj
sentimental
gossipy
nosy
self-absorbed
coddled

WORDGROUP w_ling_bad_adj
rude
hateful
insecure
unpredictabie
cruel

PATTERNGROUP p_cast_bad_adj
_in John
_out w_john_bad_adj
_in Richard
_out w_richard_bad_adj
_in Larry
_out w_larry_bad_adj
_in Ally
_out w_ally_bad_adj
_in Ling
_out w_ling_bad_adj

WORDGROUP w_john_good_quality
kindness
sincerity
cuteness
brains

WORDGROUP w_richard_good_quality
success
ability
wit
honesty

WORDGROUP w_larry_good_quality
good looks
charm
sense of humor
musical ability

WORDGROUP w_ally_good_quality
beauty
sincerity
passion
ideals

WORDGROUP w_ling_good_quality
strength
hot body
spontaneity
determination

PATTERNGROUP p_cast_good_quality
_in John
_out w_john_good_quality
_in Richard
_out w_richard_good_quality
_in Larry
_out w_larry_good_quality
_in Ally
_out w_ally_good_quality
_in Ling
_out w_ling_good_quality

WORDGROUP w_john_bad_quality
shyness
insecurity
size
goofy looks

WORDGROUP w_richard_bad_quality
greed
love of power
insensitvity
Machiavellian approach to relationships
sexism

WORDGROUP w_larry_bad_quality
ambivalence
checkered past
smarmy attitude
cockiness

WORDGROUP w_ally_bad_quality
sentimentality
love of gossip
self-absorption
coddled existence

WORDGROUP w_ling_bad_quality
rudeness
hatefulness
insecurity
unpredictability
cruelty

PATTERNGROUP p_cast_bad_quality
_in John
_out w_john_bad_quality
_in Richard
_out w_richard_bad_quality
_in Larry
_out w_larry_bad_quality
_in Ally
_out w_ally_bad_quality
_in Ling
_out w_ling_bad_quality

WORDGROUP w_ally_disparage_adj
pipey
anorexic
cutesy
fisheyed
pampered
whiney
clingy
little
girly

WORDGROUP w_ally_disparage_noun
anorexic
princess
brat
tease
snob
child

// This code is a nearly unreadable hack.  The _self hack lets us pass the
// name of this patterngroup to another patterngroup, which in turn can
// "call" us to ask for parts of speech related to a given subject, in 
// this case Ally insults.

PATTERNGROUP p_ally_disparage
_in _self
_out p_ally_disparage
_in subject
_out Ally
_in pronoun
_out she
_in relativepronoun
_out who
_in linkingverb
_out 's
_in adjective
_out f_pick w_ally_disparage_adj
_in noun
_out f_pick w_ally_disparage_noun
_in article
_out a
_in conjunction
_out which is why
_out maybe because
_in predicate
_set c_envy_other p_cast_other Ally
_out g_envy_other
_out hates herself
_out worries a lot
_out cries every day
_out butts into everyone's business

WORDGROUP w_ling_disparage_adj
rude
mean
conceited
cold
rotten
immature
loveless

WORDGROUP w_ling_disparage_noun
flirt
tease
devil
succubus
harpie
robot

PATTERNGROUP p_ling_disparage
_in _self
_out p_ling_disparage
_in subject
_out Ling
_in pronoun
_out she
_in relativepronoun
_out who
_in linkingverb
_out 's
_in adjective
_out f_pick w_ling_disparage_adj
_in noun
_out f_pick w_ling_disparage_noun
_in article
_out a
_in conjunction
_out which is why
_out maybe because
_in predicate
_set c_envy_other p_cast_other Ling
_out g_envy_other
_out wishes she was more beautiful
_out hides behind her w_ling_bad_quality
_out is overcompensating for something
_out hates being a woman

WORDGROUP w_larry_disparage_adj
smarmy
cocky
vain
touchy-feely
indecisive

WORDGROUP w_larry_disparage_noun
macho man
showoff
creep
ladies man
fake

PATTERNGROUP p_larry_disparage
_in _self
_out p_larry_disparage
_in subject
_out Larry
_in pronoun
_out he
_in relativepronoun
_out who
_in linkingverb
_out 's
_in adjective
_out f_pick w_larry_disparage_adj
_in noun
_out f_pick w_larry_disparage_noun
_in article
_out a
_in conjunction
_out which is why
_out maybe because
_in predicate
_set c_envy_other p_cast_other Larry
_out g_envy_other
_out only THINKS he knows how to play the piano
_out hides behind his w_larry_good_quality
_out can't make up his mind
_out doesn't know what he wants
_out can't commit to anything

WORDGROUP w_john_disparage_adj
sneaky
creepy
shy
goofy
slippery
boyish
funny looking

WORDGROUP w_john_disparage_noun
Sesame Street character
geek
dork
social retard
mutant

PATTERNGROUP p_john_disparage
_in _self
_out p_john_disparage
_in subject
_out John
_in pronoun
_out he
_in relativepronoun
_out who
_in linkingverb
_out 's
_in adjective
_out f_pick w_john_disparage_adj
_in noun
_out f_pick w_john_disparage_noun
_in article
_out a
_in conjunction
_out which is why
_out maybe because
_in predicate
_set c_envy_other p_cast_other John
_out g_envy_other
_out can't ever say what he means
_out hides behind his w_john_bad_quality
_out has no backbone
_out envies other men
_out is as much of a sexist as Richard

WORDGROUP w_richard_disparage_adj
heartless
arrogant
pushy
devious
high-handed
bossy

WORDGROUP w_richard_disparage_noun
capitalist
jerk
sexist
prig
rooster

PATTERNGROUP p_richard_disparage
_in _self
_out p_richard_disparage
_in subject
_out Richard
_in pronoun
_out he
_in relativepronoun
_out who
_in linkingverb
_out 's
_in adjective
_out f_pick w_richard_disparage_adj
_in noun
_out f_pick w_richard_disparage_noun
_in article
_out a
_in conjunction
_out which is why
_out maybe because
_in predicate
_set c_envy_other p_cast_other Richard
_out g_envy_other
_out pushes everyone around
_out doesn't understand other people
_out hides behind his w_richard_good_quality
_out overrationalizes his w_richard_bad_quality
_out loves his w_richard_good_quality too much
_out needs his job in order to have self-esteem

// we get two patterngroups talking to each other in order
// to generate an insult.

PATTERNGROUP p_cast_insult
_in Ally
_out p_noun_description p_ally_disparage _self 
_in Ling
_out p_noun_description p_ling_disparage _self 
_in Richard
_out p_noun_description p_richard_disparage _self 
_in John
_out p_noun_description p_john_disparage _self 
_in Larry
_out p_noun_description p_larry_disparage _self 

PATTERNGROUP p_cast_disparage_adj
_in Ally
_out w_ally_disparage_adj
_in Ling
_out w_ling_disparage_adj
_in John
_out w_john_disparage_adj
_in Richard
_out w_richard_disparage_adj
_in Larry
_out w_larry_disparage_adj

PATTERNGROUP p_cast_disparage_noun
_in Ally
_out w_ally_disparage_noun
_in Ling
_out w_ling_disparage_noun
_in John
_out w_john_disparage_noun
_in Richard
_out w_richard_disparage_noun
_in Larry
_out w_larry_disparage_noun

WORDGROUP w_problem
stolenlover
bodymalfunction
mistakenidentity

WORDGROUP w_problem_stolenlover_verb
_verb TRANSITIVE to_make_love_to make_love_to \
                 make_love_to made_love_to \
                 make_love_to made_love_to \
                 makes_love_to made_love_to \
                 make_love_to made_love_to \
                 made_love_to making_love_to

WORDGROUP w_problem_stolenlover_adverb
openly
deliberately
callously

PATTERNGROUP p_problem_verb
_in stolenlover
_out w_problem_stolenlover_verb
_in bodymalfunction
_out w_problem_bodymalfunction_verb
_in mistakenidentity
_out w_problem_mistakenidentity_verb

PATTERNGROUP p_problem_stolenlover_description
_in subject
_out c_enemy
_in pronoun
_out c_enemy_pronoun
_in linkingverb
_out 's
_in subject_adjective
_out p_cast_disparage_adj c_enemy
_in subject_noun
_out p_cast_disparage_noun c_enemy
_in subject_noun_lead
_out a
_out known to be a
_out proving that c_enemy_pronoun 's a
_in verb
_out f_third_past w_problem_stolenlover_verb
_in adverb
_out w_problem_stolenlover_adverb
_in object
_out c_hero 's c_hero_victim_good_relation , c_victim
_out c_victim , c_hero 's c_hero_victim_good_relation
_out c_hero 's c_hero_victim_good_relation , c_victim
_out c_victim , c_hero 's c_hero_victim_good_relation
_out c_hero 's p_cast_good_adj c_victim c_hero_victim_good_relation , c_victim
_out c_victim , c_hero 's p_cast_good_adj c_victim c_hero_victim_good_relation
_in subject_phrase
_out employing c_enemy_possessive p_cast_good_quality c_enemy
_out employing c_enemy_possessive p_cast_good_quality c_enemy and p_cast_good_quality c_enemy
_out sneaking around
_out revealing how p_cast_bad_adj c_hero c_enemy_pronoun thinks c_hero is
_out revealing how p_cast_bad_adj c_hero and p_cast_bad_adj c_hero c_enemy_pronoun thinks c_hero is

// takes args: <reactor> <problem> <victim>
PATTERNGROUP p_cast_reaction
_in John stolenlover Larry
_out bemusement
_in John stolenlover Richard
_out bemusement
_in John stolenlover Ling
_out jealousy
_in John stolenlover Ally
_out concern
_in Richard stolenlover John
_out bemusement
_in Richard stolenlover Larry
_out bemusement
_in Richard stolenlover Ling
_out jealousy
_in Richard stolenlover Ally
_out bemusement
_in Larry stolenlover Ally
_out sorrow
_in Larry stolenlover John
_out bemusement
_in Larry stolenlover Richard
_out bemusement
_in Larry stolenlover Ling
_out jealousy
_in Ally stolenlover Larry
_out sorrow
_in Ally stolenlover John
_out concern
_in Ally stolenlover Richard
_out concern
_in Ally stolenlover Ling
_out jealousy
_in Ling stolenlover Ally
_out jealousy
_in Ling stolenlover Richard
_out jealousy
_in Ling stolenlover John
_out bemusement
_in Ling stolenlover Larry
_out bemusement

// called by p_noun_quality_description in StandardEnglish_LIB.s
PATTERNGROUP p_emotion_description
// _in $cast $emotion _self
// _out p_emotion_description _self $cast $emotion
_in $cast $emotion subject
_out $cast
_in $cast $emotion pronoun
_out p_cast_pronoun $cast
_in $cast $emotion linkingverb
_out was
_in $cast $emotion subject_adjective
_out p_emotion_adj $emotion
_in $cast sorrow subject_phrase
_out staring out the window all day long
_out wishing it would rain and wash away the hurt
_in $cast concern subject_phrase
_out fearing the worst
_out afraid of the consequences
_in $cast bemusement subject_phrase
_out laughing to m_cast_reflexive $cast
_out anxious to tell m_cast_possessive $cast friends
_in $cast jealousy subject_phrase
_out seething
_out suspicious of everyone
_out fed up with living

WORDGROUP w_bemusement_adj
bemused
amused
entertained
indifferent
unconcerned

WORDGROUP w_concern_adj
concerned
worried
upset
preoccupied

WORDGROUP w_sorrow_adj
sad
miserable
depressed
miserable

WORDGROUP w_jealousy_adj
envious
angry
hurt
betrayed

PATTERNGROUP p_emotion_adj
_in bemusement
_out f_pick w_bemusement_adj
_in concern
_out f_pick w_concern_adj
_in jealousy
_out f_pick w_jealousy_adj
_in sorrow
_out f_pick w_sorrow_adj

// CONST c_hero_emotion_arg c_hero c_hero_reaction _self
GRAMMARGROUP g_hero_emotion_sentence
f_cap p_noun_quality_description {+p_emotion_description c_hero c_hero_reaction}.

GRAMMARGROUP g_hero_emotion_sentenceX
p_noun_quality_description {+p_emotion_description Ally concern}.

GRAMMARGROUP g_problem_sentence
f_cap p_problem_description {c_problem}.

GRAMMARGROUP g_problem_paragraph
g_problem_sentence g_hero_emotion_sentence
g_hero_emotion_sentence p_convert_to_past_perfect g_problem_sentence

GRAMMARGROUP g_story
p_ally i_name has p_ally { trait positive } , p_ally i_possessive best trait .  p_ally i_pronoun is a stud .

GRAMMARGROUP g_test
p_ally {The John bird was flying in the sky and then I was on the ocean .}

GRAMMARGROUP g_sky_ocean_sub
in the sky
on the ocean

GRAMMARGROUP g_sky_ocean
g_sky_ocean_sub ~b
~a g_sky_ocean_sub ~b

CONST c_sky in the sky
CONST c_ocean on the ocean

WRITE
g_test
